/*
 * Copyright 1997-2003 Samuel Audet <guardia@step.polymtl.ca>
 *                     Taneli Lepp <rosmo@sektori.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *    1. Redistributions of source code must retain the above copyright notice,
 *       this list of conditions and the following disclaimer.
 *
 *    2. Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *
 *    3. The name of the author may not be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* pm123 GUI routines */

#define INCL_WIN
#define INCL_GPI
#define INCL_DOS
#define INCL_OS2MM

#include <os2.h>
#include <os2me.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
//#include <dirent.h>
#include <direct.h>

#include <utilfct.h>

#include "button95.h"
#include "format.h"
#include "decoder_plug.h"
#include "output_plug.h"
#include "filter_plug.h"
#include "plugin.h"

#include "pm123.h"
#include "plugman.h"
#include "gbm.h"
#include "httpget.h"

extern HWND container, main_menu;

static BUTTONDATA btn_data;

static char DropBuf[256];
extern HWND hwndFrame;
char filename[256] = {0};
char display_msg[256] = {0};
char current_track = 0;
char current_cd_drive[4] = {0};

RGB2 shadeB, shadeD, seekB, seekD, songC;
ULONG foocol;

extern HPOINTER mp3;
extern int playlist_total, playlist_index, scrolled, dirs_found;
extern char *dirs[256];
int timer_spacing = 1, timer_sep = 1, hvol = 0, new_plind = 0;

extern MRESULT EXPENTRY MyListProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);

extern int amp_playmode;
extern int current_bitrate;
extern int current_channels;
extern int current_length, current_freq;
extern char current_decoder_info_string[128];
extern int playlist_length;
extern int repeat;
extern HAB haba;
extern char decoder_needed[128];
extern OUTPUT_PARAMS out_params;
HPAL hpal;

int stat_shade = 1, vol_shade = 1, main_shade = 1;
int plugindex = 0;
PMYMPREC currentf;

int shuffle_ind, repeat_ind, pause_ind, play_ind, ffwd_ind, rew_ind, pl_ind;
extern HWND hwndPlaylist, menu_directory;
extern int dsp_mode;

/* Good old charset
   char AMP_CHARSET[] = "abcdefghijklmnopqrstuvwxyz-_&.0123456789 ():"; */

/* New characters needed: "[],%" 128 - 255 */
char AMP_CHARSET[] = "abcdefghijklmnopqrstuvwxyz-_&.0123456789 ():,+%[]";

char *titles[] = { " ","Filename ", "Song name ", "Size ", "Time ", "Information " };

/* Bitmap lookupm, 32kB */
HBITMAP bmp_cache[8000];
/* Bitmap position, 64kB */
POINTL bmp_pos[1024];

/* Vars for splitting filename */
static char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
static char file_size[256];
extern int priority1;
extern int update_now;
extern int scroll_index;
extern int msg_mode;
extern int update_index;
int smooth_scroller = 0;
int winamp_vol = 0, winamp_kbs = 0;

extern HWND hwndClient;
extern int dont_continue;
extern ULONG WindowTiny;
extern ULONG WindowSmall;

extern int gui_font;
extern tune curtun;

extern ULONG mainFg, mainBright, mainDark, variz;
extern int maxmsglen;
int nmaxmsg, smaxmsg;

int slider_width = 2, slider_shade = 1;

extern char startpath[CCHMAXPATH];

// even more kludges, plugins > 31 are non-skin visual plug-ins
PLUGIN plugins[64] = { 0 };

extern int do_not_recall;

extern HPIPE piippu, plpiippu;
extern char pipename[256], plpipename[256];

typedef struct {
  int       resource;
  char         filename[128];
  unsigned long length;
} bundle_hdr;

int bmp_x(int res)
{
 BITMAPINFOHEADER2 hdr;
 HBITMAP hbm = bmp_cache[res];

 hdr.cbFix = sizeof(BITMAPINFOHEADER2);
 GpiQueryBitmapInfoHeader(hbm, &hdr);
 return(hdr.cx);
}

int bmp_y(int res)
{
 BITMAPINFOHEADER2 hdr;
 HBITMAP hbm = bmp_cache[res];

 hdr.cbFix = sizeof(BITMAPINFOHEADER2);
 GpiQueryBitmapInfoHeader(hbm, &hdr);
 return(hdr.cy);
}

/* Returns the drive of buffer */
char *sdrive(char *buffer) {
 _splitpath(buffer, drive, dir, fname, ext);
 if (drive == NULL) strcpy(drive, "");
 return(drive);
}

/* Returns the dir of buffer */
char *sdir(char *buffer) {
 _splitpath(buffer, drive, dir, fname, ext);
 if (dir == NULL) strcpy(dir, "");
 return(dir);
}

/* Returns the filename of buffer */
char *sfname(char *buffer) {
 _splitpath(buffer, drive, dir, fname, ext);
 if (fname == NULL) strcpy(fname, "");
 return(fname);
}

/* Returns the extension of buffer */
char *sext(char *buffer) {
 _splitpath(buffer, drive, dir, fname, ext);
 if (ext == NULL) strcpy(ext, "");
 return(ext);
}

void fnameext(char *buf, char *fullpath)
{
   char fname[_MAX_FNAME], ext[_MAX_EXT];
   _splitpath(fullpath, NULL, NULL, fname, ext);
   strcpy(buf,fname);
   strcat(buf,ext);
}

void drivedir(char *buf, char *fullpath)
{
   char drive[_MAX_DRIVE], path[_MAX_PATH];
   _splitpath(fullpath, drive, path, NULL, NULL);
   strcpy(buf,drive);
   strcat(buf,path);
}

void amp_drawbmp(HPS hps, int x, int y, int res) {
   HBITMAP hbm;
   POINTL point;

   if (x >= 0 && y >= 0)
   {
    point.x = x; point.y = y;
    hbm = bmp_cache[res];
    WinDrawBitmap(hps, hbm, NULL, &point, 0, 0, DBM_NORMAL);
   }
}


HPS amp_beginpaint(HWND hwnd) {
   RECTL rcl;
   return(WinBeginPaint(hwnd, NULLHANDLE, &rcl));
}

void amp_endpaint(HPS hps) {
   WinEndPaint(hps);
}

/* transparency */
void amp_drawbmptr(HAB hab, HPS hps, int x, int y, int res, int transparent) {
   HBITMAP hbm, hbmWork, hbmMask;
   POINTL point;
   HDC hdcMem, hdcWork;
   HPS hpsMem;
   SIZEL szlHps;
   BITMAPINFOHEADER2 hdr;
   ULONG lValue;
   POINTL aptlPoints[4];

/* Load bitmap */
   hbm = GpiLoadBitmap(hps, NULLHANDLE, res, 0, 0);

/* Create mask */

#if 0
   hdcMem = DevOpenDC(hab, OD_MEMORY, "*", 0, NULL, NULLHANDLE);
   if (hdcMem == NULLHANDLE) DosBeep(500, 100);

   szlHps.cx = 0; szlHps.cy = 0;

   hpsMem = GpiCreatePS(hab, hdcMem, &szlHps, PU_PELS | GPIT_MICRO | GPIA_ASSOC);
   if (hpsMem == NULLHANDLE)
   {
    DevCloseDC(hdcMem);
    DosBeep(800, 100);
   }
#endif

/* Get bitmap information */
   hdr.cbFix = 16;
   GpiQueryBitmapInfoHeader(hbm, &hdr);
   /* 1 plane, 1 bit */
   hdr.cPlanes  = 1;
   hdr.cBitCount = 1;

#if 0
   /* Create mask bitmap */
   hbmMask = GpiCreateBitmap(hpsMem, &hdr, 0, NULL, NULL);
   if (hbmMask == NULLHANDLE) DosBeep(1500, 200);
   GpiSetBitmap(hpsMem, hbmMask);
#endif

   /* Map bitmap -> PS */
   aptlPoints[0].x = 0;
   aptlPoints[0].y = 0;
   aptlPoints[1].x = aptlPoints[0].x + hdr.cx - 1;
   aptlPoints[1].y = aptlPoints[0].y + hdr.cy - 1;
   aptlPoints[2].x = 0;
   aptlPoints[2].y = 0;
   aptlPoints[3].x = hdr.cx;
   aptlPoints[3].y = hdr.cy;

#if 0
   /* Associate a bitmap with the created PS */

/*  GpiSetColor(hpsMem, CLR_WHITE);
   GpiSetBackColor(hpsMem, CLR_BLACK); */
   GpiSetColor(hpsMem, CLR_BLACK);
   GpiSetBackColor(hpsMem, CLR_WHITE);

   GpiWCBitBlt(hpsMem,
            hbm,
            4,
            (PPOINTL)aptlPoints,
            ROP_SRCCOPY,
            BBO_IGNORE);

   GpiSetBitmap(hpsMem, NULLHANDLE);

   GpiDestroyPS(hpsMem);
   DevCloseDC(hdcMem);

#endif
   aptlPoints[0].x = x;
   aptlPoints[0].y = y;
   aptlPoints[1].x = aptlPoints[0].x + hdr.cx - 1;
   aptlPoints[1].y = aptlPoints[0].y + hdr.cy - 1;

/*  GpiWCBitBlt(hps,
            hbmMask,
            4,
            aptlPoints,
            ROP_SRCAND,
            BBO_IGNORE); */

   GpiSetBackColor(hps, transparent);
   GpiSetBackMix(hps, BM_SRCTRANSPARENT);

   GpiWCBitBlt(hps,
            hbm,
            4,
            (PPOINTL)&aptlPoints,
            ROP_SRCCOPY,
            BBO_IGNORE);

   GpiSetBackMix(hps, BM_DEFAULT);

   GpiDeleteBitmap(hbm);
#if 0
   GpiDeleteBitmap(hbmMask);
#endif
}

/* transparency */
void btn_drawbmp(HPS hps, HBITMAP hbm, int x, int y, int transparent) {
   BITMAPINFOHEADER2 hdr;
   POINTL aptlPoints[4];

/* Get bitmap information */
   hdr.cbFix = 16;
   GpiQueryBitmapInfoHeader(hbm, &hdr);

   /* Map bitmap -> PS */
   aptlPoints[0].x = x;
   aptlPoints[0].y = y;
   aptlPoints[1].x = aptlPoints[0].x + hdr.cx - 1;
   aptlPoints[1].y = aptlPoints[0].y + hdr.cy - 1;
   aptlPoints[2].x = 0;
   aptlPoints[2].y = 0;
   aptlPoints[3].x = aptlPoints[2].x + hdr.cx;
   aptlPoints[3].y = aptlPoints[2].y + hdr.cy;

   GpiSetBackColor(hps, transparent);
   GpiSetBackMix(hps, BM_SRCTRANSPARENT);

   GpiWCBitBlt(hps,
            hbm,
            4,
            (PPOINTL)&aptlPoints,
            ROP_SRCCOPY,
            BBO_IGNORE);

   GpiSetBackMix(hps, BM_DEFAULT);
}


void amp_drawled(HPS hps, int x, int y, int state)
{
  if (state)
     amp_drawbmp(hps, bmp_pos[22].x, bmp_pos[22].y, BMP_LED);
  else
     amp_drawbmp(hps, bmp_pos[23].x, bmp_pos[23].y, BMP_NOLED);
}

int amp_drawstring(HPS hps, int x, int y, char *string, int maxlen) {
   int i, o, merkki, inc, lisays;
   unsigned char c;
   ULONG z;

   /* cuz someone might want to use their own scroller */
   if (!WindowSmall && bmp_pos[13].x == -1 && bmp_pos[13].y == -1) return(0);
   if (WindowSmall  && bmp_pos[14].x == -1 && bmp_pos[14].y == -1) return(0);

   if (gui_font == 0) inc = 1400;
   if (gui_font == 1) inc = 4400;

   for (i = 0; i < strlen(string); i++) {
    if (string[i] == '') string[i] = '';
    if (string[i] == '') string[i] = '';
    if (string[i] == '') string[i] = ''; /* pheer */
   }

   lisays = 0;
   for (i = 0; i < strlen(string); i++) {
    merkki = -1;
    for (o = 0; o < strlen(AMP_CHARSET); o++) if (AMP_CHARSET[o] == string[i]) merkki = o;

    /* Support for 127..255 */
    if (merkki == -1)
     {
      c = string[i];
      z = c;
      if (z > 126)
      {
       if (bmp_cache[inc + o + (z - 126) + 1] != 0)
         merkki = o + z - 126 + 1;
      }
     }

    if (merkki == -1) merkki = 40;
    if (bmp_cache[merkki + inc] == 0) merkki = 40;

    amp_drawbmp(hps, x + lisays, y, inc + merkki);
    lisays += bmp_x(inc + merkki);

    if (i == (maxlen - 1)) return 1;
   }
   return 1;
}

void amp_drawdigit(HPS hps, int x, int y, int digit, int size) {
   HBITMAP hbm;
   POINTL point;

   point.x = x; point.y = y;

//  hbm = GpiLoadBitmap(hps, NULLHANDLE, size + digit, 0, 0);
   hbm = bmp_cache[size + digit];
   WinDrawBitmap(hps, hbm, NULL, &point, 0, 0, DBM_NORMAL);
//  GpiDeleteBitmap(hbm);
}

void amp_box3d(HPS hps, int x, int y, int width, int height, long clr1, long clr2) {
  POINTL pp;

  pp.x = x; pp.y = y; GpiMove(hps, &pp);
// GpiSetColor(hps, CLR_PALEGRAY);
// pp.x = x + width; pp.y = y + height;
// GpiBox(hps, DRO_OUTLINEFILL, &pp, 0, 0);

  pp.x = x; pp.y = y; GpiMove(hps, &pp);
  GpiSetColor(hps, clr2);
  pp.x = x + width;
  GpiLine(hps, &pp); GpiMove(hps, &pp);
  pp.y = y + height;
  GpiLine(hps, &pp);

  pp.x = x;
  GpiSetColor(hps, clr1);
  GpiLine(hps, &pp); GpiMove(hps, &pp);
  pp.y = y; GpiLine(hps, &pp);
}

void amp_box(HPS hps, int x, int y, int width, int height, long clr1) {
  POINTL pp;

  pp.x = x; pp.y = y; GpiMove(hps, &pp);
  pp.x = x + width; pp.y = y + height;
  GpiSetColor(hps, clr1);
  GpiBox(hps, DRO_OUTLINEFILL, &pp, 0, 0);
}

void amp_thick3d(HPS hps, int x, int y, int width, int height, long clr1, long clr2) {
   amp_box3d(hps, x, y, width, height, clr1, clr2);
   amp_box3d(hps, x + 1, y + 1, width - 2, height - 2, clr1, clr2);
//  amp_box3d(hps, x + 2, y + 2, width - 4, height - 4, clr1, clr2);
}


void amp_drawbackground(HPS hps, HWND hwnd, ULONG color) {
   RECTL rcl;
   POINTL p;
   ULONG phoo;
#if 0
   WinQueryWindowRect(hwnd, &rcl);
   WinFillRect(hps, &rcl, color);

   rcl.yBottom += 35;
   rcl.xLeft += 26; rcl.xRight -= 6;
   rcl.yTop -= 6;

   if (!WindowTiny) {
    WinFillRect(hps, &rcl, CLR_BLACK);
//    amp_thick3d(hps, rcl.xLeft, rcl.yBottom, rcl.xRight - rcl.xLeft - 1, rcl.yTop - rcl.yBottom - 1, CLR_DARKGRAY, CLR_WHITE);
    amp_thick3d(hps, rcl.xLeft, rcl.yBottom, rcl.xRight - rcl.xLeft - 1, rcl.yTop - rcl.yBottom - 1, mainDark, mainBright);
   }
#endif
/* New bitmap jazzin' background */
   HBITMAP hbm;
   POINTL point;

   WinQueryWindowRect(hwnd, &rcl);
   point.x = 0; point.y = 0;

//  hbm = GpiLoadBitmap(hps, NULLHANDLE, 1900, 0, 0);
//  WinDrawBitmap(hps, hbm, NULL, &point, 0, 0, DBM_NORMAL);
//  GpiDeleteBitmap(hbm);

/* Skin */
   if (!WindowSmall)
     WinDrawBitmap(hps, bmp_cache[1900], NULL, &point, 0, 0, DBM_NORMAL);

   if (WindowSmall && !WindowTiny && bmp_cache[1611] != 0)
   {
     WinDrawBitmap(hps, bmp_cache[1611], NULL, &point, 0, 0, DBM_NORMAL);
   }
   else if (WindowTiny && bmp_cache[1612] != 0)
         {
          WinDrawBitmap(hps, bmp_cache[1612], NULL, &point, 0, 0, DBM_NORMAL);
         } else WinDrawBitmap(hps, bmp_cache[1900], NULL, &point, 0, 0, DBM_NORMAL);

/*    WinDrawBitmap(hps, bmp_cache[1900], NULL, &point, 0, 0, DBM_NORMAL);

   if (WindowTiny && bmp_cache[1612] != 0)
     WinDrawBitmap(hps, bmp_cache[1612], NULL, &point, 0, 0, DBM_NORMAL);
    else
     WinDrawBitmap(hps, bmp_cache[1900], NULL, &point, 0, 0, DBM_NORMAL); */

   rcl.yBottom += 35;
   rcl.xLeft += 26; rcl.xRight -= 6;
   rcl.yTop -= 6;

   if (!WindowTiny) {
/*    if (!WindowSmall)
      amp_drawbmp(hps, 28, 37, 1905);
     else
      amp_drawbmp(hps, 28, 37, 1906); */

    if (stat_shade) amp_thick3d(hps, rcl.xLeft, rcl.yBottom, rcl.xRight - rcl.xLeft - 1, rcl.yTop - rcl.yBottom - 1, mainDark, mainBright);
    if (!WindowSmall && slider_shade)
     {
      foocol = (seekD.bRed * 65536) + (seekD.bGreen * 256) + seekD.bBlue;
      phoo = GpiQueryColorIndex(hps, 0, foocol);

      p.x = bmp_pos[24].x - 1; p.y = bmp_pos[24].y - 1; GpiMove(hps, &p);
      p.x += slider_width + bmp_x(1610) + 1; p.y += bmp_y(1610) + 1; GpiSetColor(hps, phoo);
      GpiBox(hps, DRO_OUTLINE, &p, 0, 0);
     }
   }
}

void amp_drawtimer(HPS hps, int x, int y, long time) {
 int minutes, seconds, xz;

 minutes = time / 60;
 seconds = time % 60;
 if (minutes > 99)
  {
   seconds = (time % 3600) / 60;
   minutes = time / 3600;
  }

 x = bmp_pos[1].x; y = bmp_pos[1].y;

 if (x != -1 && y != -1)
  {
 amp_drawdigit(hps, x,     y, minutes / 10, DIGIT_BIG);
 xz = bmp_x(minutes / 10 + DIGIT_BIG) + timer_spacing;
 amp_drawdigit(hps, x + xz, y, minutes % 10, DIGIT_BIG);
 xz += bmp_x(minutes % 10 + DIGIT_BIG) + timer_spacing;

 if (timer_sep)
  {
   if (time % 2 == 0) amp_drawdigit(hps, x + xz, y, 10, DIGIT_BIG); else
                 amp_drawdigit(hps, x + xz, y, 11, DIGIT_BIG);
   xz += bmp_x(10 + DIGIT_BIG) + timer_spacing;
  } else xz += timer_spacing;

 amp_drawdigit(hps, x + xz, y, seconds / 10, DIGIT_BIG);
 xz += bmp_x(seconds / 10 + DIGIT_BIG) + timer_spacing;
 amp_drawdigit(hps, x + xz, y, seconds % 10, DIGIT_BIG);
  }
}

void amp_drawtinytimer(HPS hps, int x, int y, long time) {
 int minutes, seconds, fooz, inkki = 0;

 fooz = time;
 if (fooz > 3600) fooz = fooz / 60;

 if (y == 63)
  {
   x = bmp_pos[19].x;
   y = bmp_pos[19].y;
  }

 if (y == 47)
  {
   x = bmp_pos[20].x;
   y = bmp_pos[20].y;
  }

 if (x > 0 && y > 0)
  {
   if (fooz > 0) {
    minutes = fooz / 60;
    seconds = fooz % 60;

    amp_drawdigit(hps, x,        y, minutes / 10, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + minutes / 10);
    amp_drawdigit(hps, x + inkki, y, minutes % 10, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + minutes % 10);

    amp_drawdigit(hps, x + inkki, y, 10, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + 10);

    amp_drawdigit(hps, x + inkki, y, seconds / 10, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + seconds / 10);
    amp_drawdigit(hps, x + inkki, y, seconds % 10, DIGIT_TINY);
   } else {
    amp_drawdigit(hps, x,     y, 11, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + 11);
    amp_drawdigit(hps, x + inkki , y, 11, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + 11);

    amp_drawdigit(hps, x + inkki, y, 12, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + 12);

    amp_drawdigit(hps, x + inkki, y, 11, DIGIT_TINY);
    inkki += bmp_x(DIGIT_TINY + 11);
    amp_drawdigit(hps, x + inkki, y, 11, DIGIT_TINY);
   }
  }
}

void amp_movewindow(HWND hwnd) {
   TRACKINFO TrackInfo;
   SWP Position;

   memset ( &TrackInfo, 0, sizeof(TrackInfo) ) ;

   TrackInfo.cxBorder = 1 ;
   TrackInfo.cyBorder = 1 ;
   TrackInfo.cxGrid = 1 ;
   TrackInfo.cyGrid = 1 ;
   TrackInfo.cxKeyboard = 8 ;
   TrackInfo.cyKeyboard = 8 ;

   WinQueryWindowPos ( hwnd, &Position ) ;
   TrackInfo.rclTrack.xLeft   = Position.x ;
   TrackInfo.rclTrack.xRight  = Position.x + Position.cx ;
   TrackInfo.rclTrack.yBottom = Position.y ;
   TrackInfo.rclTrack.yTop   = Position.y + Position.cy ;

   WinQueryWindowPos ( HWND_DESKTOP, &Position ) ;
   TrackInfo.rclBoundary.xLeft    = Position.x ;
   TrackInfo.rclBoundary.xRight  = Position.x + Position.cx ;
   TrackInfo.rclBoundary.yBottom = Position.y ;
   TrackInfo.rclBoundary.yTop  = Position.y + Position.cy ;

   TrackInfo.ptlMinTrackSize.x = 0 ;
   TrackInfo.ptlMinTrackSize.y = 0 ;
   TrackInfo.ptlMaxTrackSize.x = Position.cx ;
   TrackInfo.ptlMaxTrackSize.y = Position.cy ;

   TrackInfo.fs = TF_MOVE | TF_STANDARD /*| TF_ALLINBOUNDARY*/;

   WinSendMsg(hwnd, WM_TRACKFRAME, MPFROMSHORT(TrackInfo.fs), 0);
/*  if ( WinTrackRect ( HWND_DESKTOP, NULLHANDLE, &TrackInfo ) )
   {
    WinSetWindowPos ( hwnd, NULLHANDLE,
     (SHORT) TrackInfo.rclTrack.xLeft,
     (SHORT) TrackInfo.rclTrack.yBottom,
     0, 0, SWP_MOVE | SWP_ACTIVATE | SWP_SHOW) ;
   } */

}

void amp_createmainwin(HWND hwnd) {
   int inc = 2;
   DATA95 btn;

   WinDestroyWindow(btn_play);   btn_play   = 0;
   WinDestroyWindow(btn_pause); btn_pause  = 0;
   WinDestroyWindow(btn_rew); btn_rew    = 0;
   WinDestroyWindow(btn_fwd); btn_fwd    = 0;
   WinDestroyWindow(btn_list);   btn_list   = 0;
   WinDestroyWindow(btn_load);   btn_load   = 0;
   WinDestroyWindow(btn_pl);  btn_pl      = 0;
   WinDestroyWindow(btn_power); btn_power  = 0;
   WinDestroyWindow(btn_next);   btn_next   = 0;
   WinDestroyWindow(btn_prev);   btn_prev   = 0;
   WinDestroyWindow(btn_fload); btn_fload  = 0;
   WinDestroyWindow(btn_stop);   btn_stop   = 0;

   btn.cb = sizeof(DATA95); btn.Pressed = 0;
   btn.bmp1 = BMP_N_PLAY; btn.bmp2 = BMP_PLAY;
   btn.stick = 1; btn.stickvar = &play_ind; btn.hwndOwner = hwnd;
   strcpy(btn.Help, "Starts playing");
   btn_play = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                       inc + 4, 5, 24, 24, hwnd, HWND_TOP, BMP_PLAY,
                       &btn, NULL);

   btn.stick = 0; btn.stickvar = NULL;

   btn.bmp1 = BMP_N_STOP; btn.bmp2 = BMP_STOP;
   btn.stick = 0; btn.stickvar = NULL;
   strcpy(btn.Help, "Stop playback");
   btn_stop = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                       0, 0, 0, 0, hwnd, HWND_TOP, BMP_STOP,
                       &btn, NULL);

   btn.bmp1 = BMP_N_FLOAD; btn.bmp2 = BMP_FLOAD;
   btn.stick = 0; btn.stickvar = NULL;
   strcpy(btn.Help, "Load a file");
   btn_fload = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        0, 0, 0, 0, hwnd, HWND_TOP, BMP_FLOAD,
                        &btn, NULL);

   btn.bmp1 = BMP_N_PAUSE; btn.bmp2 = BMP_PAUSE;
   btn.stick = 1; btn.stickvar = &pause_ind;
   strcpy(btn.Help, "Pauses the playback");
   btn_pause = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 29, 5, 24, 24, hwnd, HWND_TOP, BMP_PAUSE,
                        &btn, NULL);

   btn.stick = 1; btn.stickvar = &rew_ind;
   btn.bmp1 = BMP_N_REW; btn.bmp2 = BMP_REW;
   strcpy(btn.Help, "Seeks current song backward");
   btn_rew   = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 54, 5, 24, 24, hwnd, HWND_TOP, BMP_REW,
                        &btn, NULL);

   btn.stick = 1; btn.stickvar = &ffwd_ind;
   btn.bmp1 = BMP_N_FWD; btn.bmp2 = BMP_FWD;
   strcpy(btn.Help, "Seeks current song forward");
   btn_fwd   = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 79, 5, 24, 24, hwnd, HWND_TOP, BMP_FWD,
                        &btn, NULL);

   btn.stick = 0; btn.stickvar = NULL;
   btn.bmp1 = BMP_N_PL; btn.bmp2 = BMP_PL;
   strcpy(btn.Help, "Opens/closes playlist window");
   btn_pl    = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 114, 5, 24, 24, hwnd, HWND_TOP, BMP_PL,
                        &btn, NULL);

   inc += 25;
   btn.stick = 0; btn.stickvar = NULL;
   btn.bmp1 = BMP_N_LOAD; btn.bmp2 = BMP_LOAD;
   btn.stick = 1; btn.stickvar = &repeat_ind;
   strcpy(btn.Help, "Toggles playlist/song repeat");
   btn_load  = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 114, 5, 24, 24, hwnd, HWND_TOP, BMP_LOAD,
                        &btn, NULL);

   btn.stick = 1/*0*/; btn.stickvar = &shuffle_ind;
   btn.bmp1 = BMP_N_LIST; btn.bmp2 = BMP_LIST;
//   strcpy(btn.Help, "Shuffles the playlist");
   strcpy(btn.Help, "Plays randomly from the playlist");
   btn_list  = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 139, 5, 24, 24, hwnd, HWND_TOP, BMP_LIST,
                        &btn, NULL);

   btn.stick = 0; btn.stickvar = NULL;
   btn.bmp1 = BMP_N_PREV; btn.bmp2 = BMP_PREV;
   strcpy(btn.Help, "Selects previous song in playlist");
   btn_prev  = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 164, 5, 24, 24, hwnd, HWND_TOP, BMP_PREV,
                        &btn, NULL);

   btn.bmp1 = BMP_N_NEXT; btn.bmp2 = BMP_NEXT;
   strcpy(btn.Help, "Selects next song in playlist");
   btn_next  = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 189, 5, 24, 24, hwnd, HWND_TOP, BMP_NEXT,
                        &btn, NULL);

   inc -= 24;
   btn.bmp1 = BMP_N_POWER; btn.bmp2 = BMP_POWER;
   strcpy(btn.Help, "Quits PM123");
   btn_power = WinCreateWindow(hwnd, CLASSNAME, "", WS_VISIBLE,
                        inc + 266, 5, 24, 24, hwnd, HWND_TOP, BMP_POWER,
                        &btn, NULL);

}

HWND amp_list_static(HWND hwnd) {
   SWP swp;
   HWND rc;
   RGB rgb;

   WinQueryWindowPos(hwnd, &swp);

   rc = WinCreateWindow(hwnd, WC_STATIC, "Playlist - untitled.lst", SS_TEXT | DT_LEFT | DT_VCENTER | DT_MNEMONIC | WS_VISIBLE,
                  28, swp.cy - 27, swp.cx - 50, 20, hwnd, HWND_TOP, LIST_STATIC,
                  NULL, NULL);

   if (!WinSetPresParam(rc, PP_FONTNAMESIZE, strlen("9.WarpSans") + 1, "9.WarpSans"))
   WinSetPresParam(rc, PP_FONTNAMESIZE, strlen("10.Helv") + 1, "10.Helv");

   rgb.bBlue = 0; rgb.bRed = 0; rgb.bGreen = 0;
   WinSetPresParam(rc, PP_FOREGROUNDCOLOR, sizeof(RGB), &rgb);

   return (rc);
}

void amp_listwindow(HWND hwnd) {
 WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP, MyListProc, NULLHANDLE, LISTDLG, NULL);
}

HWND amp_listcontainer(HWND hwnd) {
    int i;
    RECORDINSERT insert;
    CNRINFO cnr;
    PFIELDINFO pfi, pfii, pfiCurrent;
    FIELDINFOINSERT fii;
    RGB rgb;
    SWP Position;
    int ty;

    ty = WinQuerySysValue(HWND_DESKTOP, SV_CYTITLEBAR) + WinQuerySysValue(HWND_DESKTOP, SV_CYSIZEBORDER) + 5 ;

    playlist = WinCreateWindow(hwnd, WC_CONTAINER, "Playlist",
                        WS_VISIBLE | CCS_READONLY | CCS_SINGLESEL,
                        0, 0, 0, 0, hwnd, HWND_TOP, CNR_PLAYLIST,
                        NULL, NULL);

    WinQueryWindowPos(hwnd, &Position);
    WinSetWindowPos(playlist, HWND_TOP, 5, 5, Position.cx - 11,
               Position.cy - ty, SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW | SWP_ZORDER);

    rgb.bBlue  = 0; rgb.bGreen = 0; rgb.bRed = 0;
    WinSetPresParam(playlist, PP_BACKGROUNDCOLOR, sizeof(RGB), &rgb);
    rgb.bBlue  = 0; rgb.bGreen = 255; rgb.bRed   = 0;
    WinSetPresParam(playlist, PP_FOREGROUNDCOLOR, sizeof(RGB), &rgb);

    if (!WinSetPresParam(playlist, PP_FONTNAMESIZE, sizeof("9.WarpSans") + 1, "9.WarpSans"))
     WinSetPresParam(playlist, PP_FONTNAMESIZE, sizeof("10.Helv") + 1, "10.Helv");

    pfi = (PFIELDINFO)PVOIDFROMMR(WinSendMsg(playlist, CM_ALLOCDETAILFIELDINFO, MPFROMSHORT(6), 0));

    pfiCurrent = pfi;

    /* Icon */
    pfiCurrent->cb = sizeof(FIELDINFO);
    pfiCurrent->flData = CFA_SEPARATOR | CFA_HORZSEPARATOR |
                    CFA_BITMAPORICON | CFA_FIREADONLY;
    pfiCurrent->flTitle = CFA_FITITLEREADONLY;
    pfiCurrent->pTitleData = titles[0];
    pfiCurrent->offStruct = FIELDOFFSET(MYMPREC, rc.hptrIcon);
    pfiCurrent->pUserData = NULL;
    pfiCurrent = pfiCurrent->pNextFieldInfo;

    cnr.flWindowAttr = CV_DETAIL | CA_CONTAINERTITLE | CA_DETAILSVIEWTITLES | CA_TITLELEFT | CA_DRAWICON;
    cnr.pFieldInfoLast = pfiCurrent;
    cnr.xVertSplitbar = 180;
    cnr.slBitmapOrIcon.cx = 16;
    cnr.slBitmapOrIcon.cy = 16;
//    cnr.pszCnrTitle = "Current playlist";
    cnr.pszCnrTitle = NULL;

    WinSendMsg(playlist, CM_SETCNRINFO, MPFROMP(&cnr), MPFROMLONG(CMA_FLWINDOWATTR | CMA_PFIELDINFOLAST | CMA_XVERTSPLITBAR | /*CMA_CNRTITLE |*/ CMA_SLBITMAPORICON));

    /* Filename */
    pfiCurrent->cb = sizeof(FIELDINFO);
    pfiCurrent->flData = CFA_STRING | CFA_FIREADONLY | CFA_HORZSEPARATOR;
    pfiCurrent->flTitle = CFA_FITITLEREADONLY;
    pfiCurrent->pTitleData = titles[1];
    pfiCurrent->offStruct = FIELDOFFSET(MYMPREC, rc.pszIcon);
    pfiCurrent = pfiCurrent->pNextFieldInfo;


    /* Songname */
    pfiCurrent->cb = sizeof(FIELDINFO);
    pfiCurrent->flData = CFA_SEPARATOR | CFA_HORZSEPARATOR |
                    CFA_STRING | CFA_FIREADONLY;
    pfiCurrent->flTitle = CFA_FITITLEREADONLY;
    pfiCurrent->pTitleData = titles[2];
    pfiCurrent->offStruct = FIELDOFFSET(MYMPREC, songname);
    pfiCurrent->pUserData = NULL;
    pfiCurrent = pfiCurrent->pNextFieldInfo;

    /* Size */
    pfiCurrent->cb = sizeof(FIELDINFO);
    pfiCurrent->flData = CFA_SEPARATOR | CFA_HORZSEPARATOR |
                    CFA_STRING | CFA_FIREADONLY;
    pfiCurrent->flTitle = CFA_FITITLEREADONLY;
    pfiCurrent->pTitleData = titles[3];
    pfiCurrent->offStruct = FIELDOFFSET(MYMPREC, length);
    pfiCurrent->pUserData = NULL;
    pfiCurrent = pfiCurrent->pNextFieldInfo;

    /* Playing time */
    pfiCurrent->cb = sizeof(FIELDINFO);
    pfiCurrent->flData = CFA_SEPARATOR | CFA_HORZSEPARATOR |
                    CFA_STRING | CFA_FIREADONLY;
    pfiCurrent->flTitle = CFA_FITITLEREADONLY;
    pfiCurrent->pTitleData = titles[4];
    pfiCurrent->offStruct = FIELDOFFSET(MYMPREC, time);
    pfiCurrent->pUserData = NULL;
    pfiCurrent = pfiCurrent->pNextFieldInfo;

    /* Other info */
    pfiCurrent->cb = sizeof(FIELDINFO);
    pfiCurrent->flData = CFA_SEPARATOR | CFA_HORZSEPARATOR |
                    CFA_STRING | CFA_FIREADONLY;
    pfiCurrent->flTitle = CFA_FITITLEREADONLY;
    pfiCurrent->pTitleData = titles[5];
    pfiCurrent->offStruct = FIELDOFFSET(MYMPREC, info);
    pfiCurrent->pUserData = NULL;

    /* FIELDINFOINSERT */
    fii.cb = sizeof(FIELDINFOINSERT);
    fii.pFieldInfoOrder = (PFIELDINFO)CMA_FIRST;
    fii.fInvalidateFieldInfo = FALSE;
    fii.cFieldInfoInsert = 6;

    WinSendMsg(playlist, CM_INSERTDETAILFIELDINFO,
            MPFROMP(pfi), MPFROMP(&fii));

    WinSendMsg(playlist, CM_ARRANGE, 0, 0);

    WinSendMsg(playlist, CM_INVALIDATERECORD, MPFROMP(NULL),
            MPFROM2SHORT(0, CMA_REPOSITION | CMA_ERASE | CMA_TEXTCHANGED));

    return (playlist);
}

void amp_resizelist(HWND hwnd, HWND container, HWND kill, HWND staattinen) {
   SWP Position;
   int ty, bx, by;

   by = WinQuerySysValue(HWND_DESKTOP, SV_CYSIZEBORDER);
   ty = WinQuerySysValue(HWND_DESKTOP, SV_CYTITLEBAR);
   bx = WinQuerySysValue(HWND_DESKTOP, SV_CXSIZEBORDER);

   WinQueryWindowPos(hwnd, &Position);
   WinSetWindowPos(container, HWND_TOP, bx, by, Position.cx - bx*2,
               Position.cy - ty - by*2, SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW | SWP_ZORDER);

 /*   WinSetWindowPos(kill, HWND_TOP, 8, Position.cy - 26, 16, 15, SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

   WinSetWindowPos(staattinen, HWND_TOP, 28, Position.cy - 27, Position.cx - 50, 20, SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW); */
}

HWND amp_drop_mainwin(HWND hwnd, MPARAM mp2, char *single, int size) {
   /* DM_DROP */

   int i, files_found = 0, files_inc = 0;
   struct stat tats;
   char srceName[CCHMAXPATH], pathName[CCHMAXPATH], RMF[CCHMAXPATH], *filz;
   PDRAGINFO pDInfo;
   PDRAGITEM pDItem;
   HWND hwndSource;
   int sizefilz = 32768;

   strcpy(single, "");

   pDInfo = (PDRAGINFO)mp2;
   DrgAccessDraginfo(pDInfo);
   pDItem = DrgQueryDragitemPtr(pDInfo, 0);

   hwndSource = pDInfo->hwndSource;
   filz = malloc(sizefilz); files_found = 0; files_inc = 0; dirs_found = 0;

   for (i=0; i < pDInfo->cditem; i++) {
    DrgQueryStrName(pDItem->hstrSourceName, CCHMAXPATH, srceName);
    DrgQueryStrName(pDItem->hstrContainerName, CCHMAXPATH, pathName);
    DrgQueryStrName(pDItem->hstrRMF, CCHMAXPATH, RMF);
    if (strstr(RMF, "DRM_OS2FILE")) {
      strcpy(single, pathName);
      strcat(single, srceName);

      stat(single, &tats);
      if (tats.st_mode&S_IFDIR) {
       dirs[dirs_found] = strdup(single);
       dirs_found++;
      }
      else
      {
       if(sizefilz < files_inc + strlen(single) + 2)
       {
          sizefilz += 32768;
          filz = (char *) realloc(filz,sizefilz);
       }
       percent_encode(single,size,";|");
       strncpy(&filz[files_inc], single, strlen(single));
       filz[files_inc + strlen(single)] = ';';
       files_found++;
       files_inc += (strlen(single) + 1);
      }
    }
    pDItem++;
   }
   DrgFreeDraginfo(pDInfo);

   if (files_found > 1)
    {
     filz[files_inc] = '\0';
     playlist_post_file(filz);
     strcpy(single, "");
    }
    else
       percent_decode(single);

   free(filz);
   filz = NULL;

   if (dirs_found > 0)
    {
     if (menu_directory == 0)
      menu_directory = WinLoadMenu(HWND_OBJECT, 0, DIRECTORY_MENU);

     WinPopupMenu(hwnd, hwndPlaylist,
               menu_directory,
               5,
               5,
               0,
               PU_HCONSTRAIN | PU_VCONSTRAIN |
               PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
               PU_KEYBOARD);
    }

   return hwndSource;
}

MRESULT amp_accept_drop(MPARAM mp1) {
   /* DM_DRAGOVER */
   PDRAGINFO pDInfo;
   PDRAGITEM pDItem;

   pDInfo = (PDRAGINFO)mp1;
   DrgAccessDraginfo(pDInfo);
   pDItem = DrgQueryDragitemPtr(pDInfo, 0);
   return (MPFROM2SHORT(DOR_DROP, DO_DEFAULT));
}

char *amp_fsize(char *buffer) {
   FILE *f;
   ULONG i;

   f = fopen(buffer, "rb");
   if (f == NULL) {
    strcpy(file_size, "Error opening file!");
    return(file_size);
   }
   fseek(f, 0, SEEK_END);
   i = ftell(f); fclose(f);
   sprintf(file_size, "%u kB", i / 1024);

   return(file_size);
}

ULONG amp_filesize(char *buffer) {
   FILE *f;
   ULONG i;

   f = fopen(buffer, "rb");
   if (f == NULL) {
    return((ULONG)0);
   }
   fseek(f, 0, SEEK_END);
   i = (ULONG)ftell(f); fclose(f);
   return((ULONG)i);
}

int amp_gettag(char *fiilunimi, DECODER_INFO *info, tune *joku)
{
   int bar, fuf = FALSE;

   if(fiilunimi != NULL && fiilunimi[0] != 0 && strnicmp(fiilunimi, "http://", 7) != 0
                                             && strnicmp(fiilunimi, "cd://", 6) != 0)
   {
      bar = open(fiilunimi ,O_RDONLY | O_BINARY);
      if (bar != 0 && bar != -1)
      {
         memset(joku, '\0', sizeof(tune));
         fuf = gettag(bar, joku);
         close(bar);
      }
   }

   if(!fuf && info != NULL)
   {
      strcpy(joku->title, info->title);
      strcpy(joku->artist, info->artist);
      strcpy(joku->album, info->album);
      strcpy(joku->year, info->year);
      strcpy(joku->comment, info->comment);
      strcpy(joku->genre, info->genre);
      return 1;
   }

   return fuf;
}

int amp_wipetag(char *fiilunimi) {
   int bar, fuf;
   struct stat ztat;

   bar = open(fiilunimi ,O_RDWR | O_BINARY);
   if (bar == 0) return 0;

   if (fstat(bar, &ztat) == 0)
   {
    fuf = wipetag(bar, ztat.st_size);
    close(bar);
   }
   return(fuf);
}

int amp_puttag(char *fiilunimi, tune *joku) {
   int bar, fuf;

   bar = open(fiilunimi, O_RDWR | O_BINARY);
   if (bar == 0) return 0;
   fuf = settag(bar, joku);
   close(bar);
   return(fuf);
}

int amp_addplaylist(HWND container, HWND hwnd, char *pfilename, int clear) {
   FILE *playlist;
   char filez[512], _buf[512], __buf[512], *filz;
   PMYMPREC core;
   RECORDINSERT insert;
   tune tun;
   int i, files_found = 0, files_inc = 0;
   int sizefilz = 32768;

   playlist = fopen(pfilename, "r");
   if (playlist == NULL) return 0;

   if (clear == 1)
      free_all_records(container);

   filz = malloc(sizefilz); files_found = 0; files_inc = 0;

   while (!feof(playlist)) {
      *filez = '\0';
       fgets(filez, sizeof(filez), playlist);
       blank_strip(filez);

      if (strcmp(filez, "") != 0 && filez[0] != '#' && filez[0] != '>' && filez[0] != '<')
      {
         if(sizefilz < files_inc + strlen(filez) + 2)
         {
            sizefilz += 32768;
            filz = (char *) realloc(filz,sizefilz);
         }
         percent_encode(filez,sizeof(filez),";|");
         strncpy(&filz[files_inc], filez, strlen(filez));
         filz[files_inc + strlen(filez)] = ';';
         files_found++;
         files_inc += (strlen(filez) + 1);
      }
   }
   fclose(playlist);

   if (!do_not_recall)
    {
     /* Regulars list */
     for (i = 8; i >= 0; i--)
      strcpy(cfg.list[i + 1], cfg.list[i]);

     strcpy(cfg.list[0], pfilename);
    }

   filz[files_inc] = '\0';
   playlist_post_file(filz);
   free(filz);
   filz = NULL;

   return 1;
}

int amp_add_m3u_playlist(HWND container, HWND hwnd, char *pfilename, int clear)
{
   int playlist;
   char filez[512], _buf[512], __buf[512], *filz;
   PMYMPREC core;
   RECORDINSERT insert;
   tune tun;
   int i, files_found = 0, files_inc = 0, eof;
   char *z;
   int sizefilz = 32768;
   HTTP_INFO http_info;

   if (strnicmp(pfilename, "http://", 7) != 0) /* Local M3U */
     return amp_addplaylist(container, hwnd, pfilename, clear);

   playlist = http_open(pfilename, &http_info);
   if (playlist == 0) return 0;

   if (clear == 1)
      free_all_records(container);

   filz = malloc(sizefilz); files_found = 0; files_inc = 0;

   eof = 1;
   while (eof) {
      *filez = '\0';
      eof = readline(filez, sizeof(filez), playlist);
      if (strchr(filez, '\n') != (char *)NULL)
      {
       z = strchr(filez, '\n');
       *z = '\0';
      } else
       if (strchr(filez, '\r') != (char *)NULL)
        {
         z = strchr(filez, '\r');
         *z = '\0';
        }
       blank_strip(filez);

      if (strcmp(filez, "") != 0 && filez[0] != '#' && filez[0] != '>' && filez[0] != '<')
      {
       if(sizefilz < files_inc + strlen(filez) + 2)
       {
          sizefilz += 32768;
          filz = (char *) realloc(filz,sizefilz);
       }
       percent_encode(filez,sizeof(filez),";|");
       strncpy(&filz[files_inc], filez, strlen(filez));
       filz[files_inc + strlen(filez)] = ';';
       files_found++;
       files_inc += (strlen(filez) + 1);
      }
   }
   http_close(playlist);

   if (!do_not_recall)
    {
     /* Regulars list */
     for (i = 8; i >= 0; i--)
      strcpy(cfg.list[i + 1], cfg.list[i]);

     strcpy(cfg.list[0], pfilename);
    }

   filz[files_inc] = '\0';
   playlist_post_file(filz);
   free(filz);
   filz = NULL;

   return 1;
}

int amp_add_warpamp_playlist(HWND container, HWND hwnd, char *pfilename, int clear) {
   FILE *playlist;
   char filez[512], _buf[512], __buf[512], *filz;
   PMYMPREC core;
   RECORDINSERT insert;
   tune tun;
   int i, files_found = 0, files_inc = 0;
   int sizefilz = 32768;

   playlist = fopen(pfilename, "r");
   if (playlist == NULL) return 0;

   if (clear == 1)
      free_all_records(container);

   filz = malloc(sizefilz); files_found = 0; files_inc = 0;

   while (!feof(playlist)) {
      *filez = '\0';
       fgets(filez, sizeof(filez), playlist);
       blank_strip(filez);

      if (strcmp(filez, "") != 0 && filez[0] != '#' && filez[0] != '[' && filez[0] != '>' && filez[0] != '<')
      {
       char *equal_pos = strchr(filez, '=');
       if (strnicmp(filez, "File", 4) == 0 && equal_pos != NULL)
        {
         strncpy(_buf, (char *)(equal_pos + 1), 255);
         if(sizefilz < files_inc + strlen(_buf) + 2)
         {
            sizefilz += 32768;
            filz = (char *) realloc(filz,sizefilz);
         }
         percent_encode(_buf,sizeof(_buf),";|");
         strncpy(&filz[files_inc], _buf, strlen(_buf));
         filz[files_inc + strlen(_buf)] = ';';
         files_found++;
         files_inc += (strlen(_buf) + 1);
        }
      }
   }
   if (!do_not_recall)
    {
     /* Regulars list */
     for (i = 8; i >= 0; i--)
      strcpy(cfg.list[i + 1], cfg.list[i]);

     strcpy(cfg.list[0], pfilename);
    }

   fclose(playlist);
   filz[files_inc] = '\0';
   playlist_post_file(filz);
   free(filz);
   filz = NULL;

   return 1;
}

int amp_add_winamp_playlist(HWND container, HWND hwnd, char *pfilename, int clear) {
   FILE *playlist;
   char filez[512], _buf[512], __buf[512], *filz;
   PMYMPREC core;
   RECORDINSERT insert;
   tune tun;
   int i, files_found = 0, files_inc = 0;
   int sizefilz = 32768;
   int last_index = -1;

   playlist = fopen(pfilename, "r");
   if (playlist == NULL) return 0;

   if (clear == 1)
      free_all_records(container);

   filz = malloc(sizefilz); files_found = 0; files_inc = 0;

   while (!feof(playlist)) {
      *filez = '\0';
       fgets(filez, sizeof(filez), playlist);
       blank_strip(filez);

      if (strcmp(filez, "") != 0 && filez[0] != '#' && filez[0] != '[' && filez[0] != '>' && filez[0] != '<')
      {
       char *equal_pos = strchr(filez, '=');
       if (strnicmp(filez, "File", 4) == 0 && equal_pos != NULL)
        {
         strncpy(_buf, (char *)(equal_pos + 1), 255);
         if(sizefilz < files_inc + strlen(_buf) + 2)
         {
            sizefilz += 32768;
            filz = (char *) realloc(filz,sizefilz);
         }
         percent_encode(_buf,sizeof(_buf),";|");
         strncpy(&filz[files_inc], _buf, strlen(_buf));
         filz[files_inc + strlen(_buf)] = ';';
         files_found++;
         files_inc += (strlen(_buf) + 1);

         // we hope the title field always follows the file field
         // man do winamp playlist suck ass
         *equal_pos = 0;
         last_index = atoi(&filez[4]);
        }
       else if (strnicmp(filez, "Title", 5) == 0 && equal_pos != NULL)
        {
         *equal_pos = 0;
         equal_pos++;

         if(last_index == atoi(&filez[5]))
         {
            // different seperator
            filz[files_inc-1] = '|';

            strncpy(_buf, equal_pos, 255);
            if(sizefilz < files_inc + strlen(_buf) + 2)
            {
               sizefilz += 32768;
               filz = (char *) realloc(filz,sizefilz);
            }
            percent_encode(_buf,sizeof(_buf),";|");
            strncpy(&filz[files_inc], _buf, strlen(_buf));
            filz[files_inc + strlen(_buf)] = ';';
            files_inc += (strlen(_buf) + 1);
         }


        }

      }
   }
   if (!do_not_recall)
    {
     /* Regulars list */
     for (i = 8; i >= 0; i--)
      strcpy(cfg.list[i + 1], cfg.list[i]);

     strcpy(cfg.list[0], pfilename);
    }

   fclose(playlist);
   filz[files_inc] = '\0';
   playlist_post_file(filz);
   free(filz);
   filz = NULL;

   return 1;
}


int load_singlefile(char *file, HWND container, HWND hwnd) {
  FILE      *test;
  char      _buf[256];
  int    firstlist = 1;
  int    isURL = FALSE;
  DECODER_INFO info;
  int    i;
  ULONG    dfiRc;
  char module_name[128];

  if (strnicmp(file, "http://", 7) == 0)
     isURL = TRUE;

  if (!isURL)
     test = fopen(file, "rb");
  else
     test = NULL;

  if (test == NULL && !isURL) {
    StopWait();
    WinInvalidateRect(hwndClient, NULL, 1);
    amp_playmode = AMP_NOFILE; strcpy(display_msg, "File not found"); scroll_index = 0; scrolled = 0; currentf = NULL;
    current_bitrate = 0;
    current_channels = -1;
    current_length = 0;
    current_freq = 0;
    current_track = 0;
    current_cd_drive[0] = 0;
    update_index = 1;
    update_now = 1;
    return 0;
   }

  if (!isURL)
     fclose(test);

#if 0
  if (!isURL && strcmp(strlwr(sext(file)), ".m3u") == 0) {
   test = fopen(file, "r");
   fgets(file, 256, test);
   if (*file) file[strlen(file) - 1] = 0;
   fclose(test);
   isURL = TRUE;
  }
#endif

   if (is_playlist(file))
   {
      if (firstlist == 1)
      {
//         WinSendMsg(container, CM_REMOVERECORD, MPFROMP(NULL), MPFROM2SHORT(0, CMA_FREE | CMA_INVALIDATE));
         WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_CLEAR), 0);
         firstlist = 0;
      }

      load_playlist(container, hwnd, file, 1);

      WinSendMsg(container, CM_INVALIDATERECORD, MPFROMP(NULL), MPFROM2SHORT(0, 0));

#if 0
      if (amp_playmode == AMP_PLAYLIST || cfg.autouse == 1)
         WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
#endif
   }
   else
   {
      if ((dfiRc = dec_fileinfo(file, &info, module_name)) != 0)
      {
         handle_dfi_error(dfiRc, file);
         current_bitrate = 0;
         current_channels = -1;
         current_length = 0;
         current_freq = 0;
         current_track = 0;
         current_cd_drive[0] = 0;
         amp_playmode = AMP_NOFILE;
         currentf = NULL;
         no_file_loaded();
         WinInvalidateRect(hwndClient, NULL, 1);
         return(0);
      }
      else
      {
         strcpy(decoder_needed,module_name);
         out_params.formatinfo = info.format;

         amp_playmode = AMP_SINGLE;
         currentf = NULL;

         current_bitrate  = info.bitrate;
         current_channels = info.mode;
         current_length  = info.songlength/1000;
         current_freq    = info.format.samplerate;
         current_track = 0;
         current_cd_drive[0] = 0;

         strcpy(filename, file);

         strcpy(current_decoder_info_string,info.tech_info);

         memset(&curtun, '\0', sizeof(tune));
         amp_gettag(filename, &info, &curtun);

         WinInvalidateRect(hwndClient, NULLHANDLE, 1);
         do_display_msg(filename);
         scroll_index = 0;
         msg_mode = MSG_SCROLL;

         StopWait();
         if (cfg.playonload == 1) {
             WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
         }

         if (!do_not_recall)
         {
            /* Regulars list */
           for (i = 8; i >= 0; i--)
              strcpy(cfg.last[i + 1], cfg.last[i]);

           strcpy(cfg.last[0], filename);
         }

         return(1);
      }
   }
   return(0);
}

BOOL load_singletrack(char *drive, char track)
{
   DECODER_INFO info;
   int    i;
   ULONG    dfiRc;
   char module_name[128];

   if ((dfiRc = dec_trackinfo(drive, track, &info, module_name)) != 0)
   {
      char temp[128];
      sprintf(temp,"%s\\Track %d",drive,track);
      handle_dfi_error(dfiRc, temp);
      current_bitrate = 0;
      current_channels = -1;
      current_length = 0;
      current_freq = 0;
      current_track = 0;
      current_cd_drive[0] = 0;
      amp_playmode = AMP_NOFILE;
      currentf = NULL;
      no_file_loaded();
      WinInvalidateRect(hwndClient, NULL, 1);

      return FALSE;
   }
   else
   {
      strcpy(decoder_needed,module_name);
      out_params.formatinfo = info.format;

      amp_playmode = AMP_SINGLE;
      currentf = NULL;

      current_bitrate  = info.bitrate;
      current_channels = info.mode;
      current_length  = info.songlength/1000;
      current_freq    = info.format.samplerate;

      filename[0] = 0;
      current_track = track;
      strncpy(current_cd_drive,drive,sizeof(current_cd_drive));

      strcpy(current_decoder_info_string,info.tech_info);

      memset(&curtun, '\0', sizeof(tune));
      amp_gettag(filename, &info, &curtun);

      WinInvalidateRect(hwndClient, NULLHANDLE, 1);
      do_display_msg(filename);
      scroll_index = 0;
      msg_mode = MSG_SCROLL;

      StopWait();
      if (cfg.playonload == 1) {
          WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
      }

#if 0
Add something to recall tracks too
      if (!do_not_recall)
      {
         /* Regulars list */
        for (i = 8; i >= 0; i--)
           strcpy(cfg.last[i + 1], cfg.last[i]);

        strcpy(cfg.last[0], filename);
      }
#endif

      return TRUE;
   }
}

void amp_volumebar(HWND hwnd, HPS hps, int x, int y, int height, int volume) {
   int i, o, z;
   POINTL p;

   x = bmp_pos[25].x; y = bmp_pos[25].y;
   if (winamp_vol && (!hvol && volume < bmp_y(BMP_VOLBAR)))
   {
    amp_drawbk(hps, x, y + volume, x + bmp_x(BMP_VOLBAR), y + bmp_y(BMP_VOLBAR), 1900);
   }
   amp_drawbmp(hps, x, y, BMP_VOLBAR);
   if ((!hvol && volume < bmp_y(BMP_VOLBAR)) || (hvol && volume < bmp_x(BMP_VOLBAR))) {
    if (volume < 0) volume = 0;
    if (!winamp_vol)
     {
      if (!hvol)
       amp_drawbk(hps, x, y + volume, x + bmp_x(BMP_VOLBAR) - 1, y + bmp_y(BMP_VOLBAR), 1900);
      else
       amp_drawbk(hps, x + volume, y, x + bmp_x(BMP_VOLBAR), y + bmp_y(BMP_VOLBAR), 1900);
     } else
      {
      if (winamp_vol)
       if (!hvol)
         {
         o = (int)((((double)bmp_y(1630) - (double)bmp_y(1620))/(double)bmp_y(1630)) * (double)volume);
         if (o > (bmp_y(1630) - bmp_y(1620))) o = bmp_y(1630) - bmp_y(1620);
         amp_drawbmp(hps, x, y + o, 1620);
         }
        else
         {
         o = (int)((((double)bmp_x(1630) - (double)bmp_x(1620))/(double)bmp_x(1630)) * (double)volume);
         if (o > (bmp_x(1630) - bmp_x(1620))) o = bmp_x(1630) - bmp_x(1620);
         amp_drawbmp(hps, x + o, y + 2, 1620);
         }
      }
   } else
   {
    if (winamp_vol)
     if (!hvol)
      amp_drawbmp(hps, x, y + bmp_y(1630) - bmp_y(1620), 1620);
     else
      amp_drawbmp(hps, x + bmp_x(1630) - bmp_x(1620), y + 2, 1620);
   }
}

void amp_drawscope(HAB hab, HWND hwnd, HPS hps, int x, int y, int *bands) {
   int i;
   POINTL p;
   RECTL r;
   HBITMAP hbm, hbmNew;
   HDC hdcMem;
   SIZEL szlHps;
   HPS hpsMem;
   BITMAPINFOHEADER2 hdr;
   POINTL aptlPoints[4];

   hbm = bmp_cache[1605];

   hdcMem = DevOpenDC(hab,
                 OD_MEMORY,
                 "*",
                 0,
                 NULL,
                 NULLHANDLE);

   szlHps.cx = 100; szlHps.cy = 100;
   hpsMem = GpiCreatePS(hab,
                  hdcMem,
                  &szlHps,
                  PU_PELS | GPIT_MICRO | GPIA_ASSOC);

   memset(&hdr, '\0', sizeof(BITMAPINFOHEADER2));
   hdr.cbFix = sizeof(BITMAPINFOHEADER2);
   GpiQueryBitmapInfoHeader(hbm, &hdr);

   hbmNew = GpiCreateBitmap(hpsMem, &hdr, 0, NULL, NULL);
   GpiSetBitmap(hpsMem, hbmNew);

   aptlPoints[0].x = 0;
   aptlPoints[0].y = 0;
   aptlPoints[1].x = 95;
   aptlPoints[1].y = 31;
   aptlPoints[2].x = 0;
   aptlPoints[2].y = 0;
   aptlPoints[3].x = 95;
   aptlPoints[3].y = 31;

   GpiWCBitBlt(hpsMem,
            hbm,
            4,
            (PPOINTL)&aptlPoints,
            ROP_SRCCOPY,
            BBO_IGNORE);

   p.x = p.y = 0;

   for (i = 0; i < 32; i++)
   {
   if (bands[i] > 32 || bands[i] < 0) bands[i] = 32;
   aptlPoints[0].x = (i * 4);
   aptlPoints[0].y = bands[i];
   aptlPoints[1].x = (i * 4) + 3;
   aptlPoints[1].y = 31;
   aptlPoints[2].x = (x - 28) + (i * 4);
   aptlPoints[2].y = (y - 37) + bands[i];
   aptlPoints[3].x = (x - 28) + (i * 4) +3;
   aptlPoints[3].y = (y - 37) + 31;

   GpiWCBitBlt(hpsMem,
            bmp_cache[1905],
            4,
            (PPOINTL)&aptlPoints,
            ROP_SRCCOPY,
            BBO_IGNORE);

   }

   aptlPoints[0].x = x;
   aptlPoints[0].y = y;
   aptlPoints[1].x = (x + 95);
   aptlPoints[1].y = (y + 31);
   aptlPoints[2].x = 0;
   aptlPoints[2].y = 0;
   aptlPoints[3].x = 95;
   aptlPoints[3].y = 31;

   GpiBitBlt(hps,
          hpsMem,
          4,
          (PPOINTL)&aptlPoints,
          ROP_SRCCOPY,
          BBO_IGNORE);

   GpiDestroyPS(hpsMem);
   DevCloseDC(hdcMem);
   GpiDeleteBitmap(hbmNew);

//  p.x = x; p.y = y;
//  WinDrawBitmap(hps, hbm, NULL, &p, 0, 0, DBM_NORMAL);
//  if (rate < 32) {
//    amp_drawbk(hps, x, y + rate, x + 9, y + 46, 1900);
//  }
}


/*
void amp_spectrumbar(HPS hps, int x, int y, int height, int power) {
   int i;

   for (i = 0; i < height; i++)
   amp_drawbmp(hps, x, y + (i * 4), BMP_NOSCOPE);

   for (i = 0; i < power; i++)
   amp_drawbmp(hps, x, y + (i * 4), BMP_SCOPE);
}
*/

void amp_spectrumbar(HPS hps, int x, int y, int power) {
   int i;

   amp_drawbmp(hps, x, y, BMP_BARS + power);
}

void amp_drawrate(HPS hps, int x, int y, int rate) {
   int i, index = 0;
   char buf[32];
   int rate_index[] = { 0, 32, 48, 56, 64, 80, 96, 112, 128, 144,
                  160, 176, 192, 224, 256 };

   for (i = 0; i < 16; i++)
   if (rate_index[i] == rate) { index = i; break; }

   if (!winamp_kbs)
   {
    if (index > 0) amp_drawbmp(hps, bmp_pos[29].x, bmp_pos[29].y, 1800 + index); else
               amp_drawbk(hps, bmp_pos[29].x, bmp_pos[29].y, bmp_pos[29].x + bmp_x(1800 + 14), bmp_pos[29].y + bmp_y(1800 + 14), 1900);
   }
   else
   {

    amp_drawbk(hps, bmp_pos[29].x, bmp_pos[29].y, bmp_pos[29].x + bmp_x(1830) * 3, bmp_pos[29].y + bmp_y(1830), 1900);
    if (rate > 0)
     {
      sprintf(buf, "%3u", rate);
      for (i = 0; i < 3; i++)
      {
       if (buf[i] != ' ')
         amp_drawbmp(hps, bmp_pos[29].x + (i * bmp_x(1830)), bmp_pos[29].y, 1830 + (buf[i] - 48));
      }
     }
   }
}

void amp_drawchannels(HPS hps, int x, int y, int channels) {

   amp_drawbk(hps, bmp_pos[26].x, bmp_pos[26].y, bmp_pos[26].x + bmp_x(1608), bmp_pos[26].y + bmp_y(1608), 1900);
   amp_drawbk(hps, bmp_pos[27].x, bmp_pos[27].y, bmp_pos[27].x + bmp_x(1602), bmp_pos[27].y + bmp_y(1602), 1900);
   amp_drawbk(hps, bmp_pos[28].x, bmp_pos[28].y, bmp_pos[28].x + bmp_x(1601), bmp_pos[28].y + bmp_y(1601), 1900);

   switch (channels)
   {
    case -1: amp_drawbmp(hps, bmp_pos[26].x, bmp_pos[26].y, 1608); break;
    case  3: amp_drawbmp(hps, bmp_pos[27].x, bmp_pos[27].y, 1602); break;
    default: amp_drawbmp(hps, bmp_pos[28].x, bmp_pos[28].y, 1601); break;
   }
}

void amp_priochange(HWND hwndMenu, int newprio) {
   int set;

   switch (priority1) {
      case 1: set = IDM_M_PRIDLE; break;
      case 2: set = IDM_M_PRREG;  break;
      case 4: set = IDM_M_PRFG;   break;
      case 3: set = IDM_M_PRCRIT; break;
   }
   WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(set, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

   priority1 = newprio;
   cfg.priority = newprio;
   amp_msg(MSG_PRIO, 0, 0);

   switch (priority1) {
      case 1: set = IDM_M_PRIDLE; break;
      case 2: set = IDM_M_PRREG;  break;
      case 4: set = IDM_M_PRFG;   break;
      case 3: set = IDM_M_PRCRIT; break;
   }
   WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(set, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
}

void amp_quit(HWND hwnd, HAB haba, HMQ hmq) {
 int i;
 char buf[256];

 save_ini();
 for (i = 0; i < 8000; i++)
   GpiDeleteBitmap(bmp_cache[i]);

 dont_continue = 1;
 if (decoder_playing())
    StopWait();

 for (i = 0; i < 32; i++)
    deinit_plugin(hwnd, i);

// WinDestroyWindow(hwnd);
// WinDestroyMsgQueue(hmq);
// WinTerminate(haba);

  DosExit(EXIT_PROCESS, 0);
}

SHORT _System pfnCompareAlphabet(PMYMPREC p1, PMYMPREC p2, PVOID pStorage) {
  int i, o;
  char s1[256], s2[256];

  sprintf(s1, "%s", strlwr(sfname(p1->full)));
  sprintf(s2, "%s", strlwr(sfname(p2->full)));
  if (strlen(s1) < strlen(s2)) o = strlen(s2); else
                        o = strlen(s1);

  for (i = 0; i < o; i++) {
   if (s1[i] < s2[i]) return((SHORT)-1);
   if (s1[i] > s2[i]) return((SHORT)1);
  }
  return((SHORT)0);
}

SHORT _System pfnCompareSongname(PMYMPREC p1, PMYMPREC p2, PVOID pStorage) {
  int i, o;
  char s1[256], s2[256];

  if (p1->songname == NULL && p2->songname == NULL) return((SHORT)0);
  if (p1->songname == NULL && p2->songname != NULL) return((SHORT)-1);
  if (p1->songname != NULL && p2->songname == NULL) return((SHORT)1);

  sprintf(s1, "%s", strlwr(p1->songname));
  sprintf(s2, "%s", strlwr(p2->songname));

  if (strlen(s1) < strlen(s2)) o = strlen(s2); else
                        o = strlen(s1);

  for (i = 0; i < o; i++) {
   if (s1[i] < s2[i]) return((SHORT)-1);
   if (s1[i] > s2[i]) return((SHORT)1);
  }
  return((SHORT)0);
}

SHORT _System pfnCompareRandom(PMYMPREC p1, PMYMPREC p2, PVOID pStorage) {
  int i, o;
  i = rand() % 100;
  if (i < 33) return((SHORT)0);
  if (i > 32 && i < 66) return((SHORT)1);
  if (i > 65 && i < 100) return((SHORT)-1);
  return((SHORT)0);
}

SHORT _System pfnCompareSize(PMYMPREC p1, PMYMPREC p2, PVOID pStorage) {
  int i, o;
  if (p1->size < p2->size) return((SHORT)-1);
  if (p1->size > p2->size) return((SHORT)1);
  return((SHORT)0);
}

SHORT _System pfnCompareTime(PMYMPREC p1, PMYMPREC p2, PVOID pStorage) {
  int i, o;
  if (p1->secs < p2->secs) return((SHORT)-1);
  if (p1->secs > p2->secs) return((SHORT)1);
  return((SHORT)0);
}

int count_files(int argc, char *argv[]) {
 int i, o = 0;

 for (i = 1; i < argc; i++)
    if (argv[i][0] != '/' && argv[i][0] != '-') o++;

 return(o);
}

void set_bubbletext(USHORT id, char *text) {
 WinPostMsg(WinWindowFromID(hwndClient, id), WM_SETTEXT, MPFROMP(text), 0);
}

#if 0
char *GetDeviceName(ULONG ulNumber) {
 APIRET           rc;
 MCI_SYSINFO_PARMS      SysInfo;
 MCI_SYSINFO_LOGDEVICE LogDevice;
 CHAR             RetBuf[256];
 static char         DeviceName[256];

 SysInfo.usDeviceType = MCI_DEVTYPE_WAVEFORM_AUDIO;
 SysInfo.ulNumber   = ulNumber;
 SysInfo.pszReturn     = (PSZ) &RetBuf;
 SysInfo.ulRetSize     = sizeof(RetBuf);

 rc = mciSendCommand(0,
                MCI_SYSINFO,
                MCI_WAIT | MCI_SYSINFO_INSTALLNAME,
                (PVOID)&SysInfo,
                0);

 if (rc != MCIERR_SUCCESS) {
   return(NULL);
 }

 strcpy(LogDevice.szInstallName, RetBuf);

 SysInfo.ulItem     = MCI_SYSINFO_QUERY_DRIVER;
 SysInfo.pSysInfoParm = (PVOID)&LogDevice;

 rc = mciSendCommand(0,
                MCI_SYSINFO,
                MCI_WAIT | MCI_SYSINFO_ITEM,
                (PVOID)&SysInfo,
                0);

 if (rc != MCIERR_SUCCESS) {
  return(NULL);
 }

 sprintf(DeviceName, "%s (%s)", LogDevice.szProductInfo, LogDevice.szVersionNumber);

 return(DeviceName);
}
#endif

HPAL amp_dopalette(HAB hab, HWND hwnd)
{
 BITMAPINFO2 hdr1, hdr2;
 HBITMAP hbm;
 ULONG totalColors = 0;
 int i, o;
 HPS hpspal, hps;
 HDC hdc;
 SIZEL sizl;
 APIRET rc;
 LONG cSimulColors, lPalSupport;
 ULONG *palette;


 hpal = 0;
 hdc = WinOpenWindowDC(hwnd);

 DevQueryCaps(hdc, CAPS_COLORS,         1, &cSimulColors);
 DevQueryCaps(hdc, CAPS_ADDITIONAL_GRAPHICS, 1, &lPalSupport);

 if (lPalSupport & CAPS_PALETTE_MANAGER)
  {
   hps = WinGetPS(hwnd);

   hbm = bmp_cache[1900];
   GpiQueryBitmapParameters(hbm, (PBITMAPINFOHEADER)&hdr1);

   switch (hdr1.cBitCount)
   {
    case 1:  totalColors = 2;    break;
    case 4:  totalColors = 16;    break;
    case 8:  totalColors = 256;   break;
    case 16: totalColors = 65535; break;
    case 24: totalColors = 0;    break;
    default: totalColors = 256;   break;
   }

   palette = malloc(totalColors * sizeof(ULONG));
   for (i = 0, o = 0; i < totalColors; i++, o++)
   {
    palette[o] = (ULONG)((hdr1.argbColor[i].bRed * 65536) + (hdr1.argbColor[i].bGreen * 256) + (hdr1.argbColor[i].bBlue));
   }

   /* Create palette */
   hpal = GpiCreatePalette(hab,
                            LCOL_PURECOLOR,
                     LCOLF_CONSECRGB,
                     totalColors,
                     (PULONG)palette);

    GpiSelectPalette(hps, hpal);
    WinRealizePalette(hwnd, hps, &totalColors);
    plugin_broadcast(WM_REALIZEPALETTE, 0, 0);
    WinReleasePS(hps);
  }

 /* Realize palette on each paint (?) */
 return hpal;
}

int find_index(PMYMPREC position)
{
  int i = 0;
  PMYMPREC current = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
  while(current != position)
  {
     current = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(current), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
     i++;
  }
  return i;
}

PMYMPREC pl_add_song(char *pfilename, PMYMPREC position, char *title)
{
   int          i;
   char         buf[512], _buf[512];
   PMYMPREC     core, ret;
   DECODER_INFO info;
   tune         tun;
   RECORDINSERT insert;
   struct stat  sb;
   PMYMPREC     removearray[1];

   if (pfilename == NULL) return 0;

   memset(&info, '\0', sizeof(DECODER_INFO));

   memset(&sb, '\0', sizeof(struct stat));
   i = stat(pfilename, &sb);
   if (i < 0 && strnicmp(pfilename, "http://", 7) != 0 &&
                strnicmp(pfilename, "cd:///", 6) != 0) /* Error */
   {
     sprintf(buf, "%s: %s", pfilename, strerror(errno));
     WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf, "Error", 0, MB_ERROR | MB_OK);
     return 0;
   }

   /* Allocate a new record */
   core = (PMYMPREC) WinSendMsg(container, CM_ALLOCRECORD, MPFROMLONG(sizeof(MYMPREC) - sizeof(RECORDCORE)), MPFROMLONG(1));

   // decide wether this is a CD track, or a normal string
   if(strnicmp(pfilename, "cd:///", 6) == 0)
   {
      char drive[4] = "1:";
      int track = -1;

      sscanf(pfilename,"cd:///%1c:\\Track %d",drive,&track);
      if(drive[0] == 1 || track == -1)
      {
         sprintf(buf, "Invalid CD URL: %s", pfilename);
         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf, "Error", 0, MB_ERROR | MB_OK);
         return 0;
      }

      i = dec_trackinfo(drive, track, &info, core->decoder_module_name);

      core->track         = track;
      strcpy(core->cd_drive, drive);
   }
   else
   {
      i = dec_fileinfo((char *)pfilename, (DECODER_INFO *)&info, core->decoder_module_name);

      core->track         = -1;
      core->cd_drive[0]   = 0;
   }

   if (i != 0) /* FALSE, invalid file */
   {
      handle_dfi_error(i, pfilename);
      return 0;
   }

   core->rc.cb         = sizeof(RECORDCORE);
   core->rc.flRecordAttr = CRA_DROPONABLE;
   core->bitrate       = info.bitrate;
   core->channels      = info.mode;
   core->secs          = info.songlength/1000;
   core->freq          = info.format.samplerate;

   core->format = info.format;

   /* Load ID3 tag */
   amp_gettag(pfilename, &info, &tun);

   if(title == NULL || title[0] == 0)
   {
      strcpy(buf, "");
      if(strcmp(tun.artist, "") != 0)
      {
         strcat(buf, tun.artist);
         if (strcmp(tun.title, "") != 0)
            strcat(buf, ": ");
      }

      if(strcmp(tun.title, "") != 0)
         strcat(buf, tun.title);

      core->songname = strdup(buf);
   }
   else
      core->songname = strdup(title);

   strcpy(buf, "");
   if (strcmp(tun.album, "") != 0)
   {
     strcat(buf, tun.album);
     strcat(buf, " ");
   }

   if (strcmp(tun.year, "") != 0)
   {
     strcat(buf, tun.year);
     strcat(buf, ", ");
   }

   if (strcmp(tun.genre, "") != 0)
   {
     strcat(buf, tun.genre);
     strcat(buf, ", ");
   }

   strcat(buf, info.tech_info);

   core->comment == NULL;
   if (strcmp(tun.comment, "") != 0)
   {
     strcat(buf, ", comment: ");
     core->comment = (char *) (strchr(buf,0)-buf);
     strcat(buf, tun.comment);
   }

   free(core -> info);
   core->info = strdup(buf);
   if(core->comment != NULL)
      core->comment = core->info + (int)core->comment;

   /* File name or host or cd track */
   if(strnicmp(pfilename,"http://",7) == 0 &&
      ( strrchr(pfilename,'/') == pfilename+6 || *(strrchr(pfilename,'/')+1) == 0) )
      strcpy(buf, pfilename);
   else if(strnicmp(pfilename,"cd:///",6) == 0)
      strcpy(buf, pfilename+6);
   else
      fnameext(buf,pfilename);
   core -> rc.pszIcon = strdup(buf);

   /* Icon */
   core -> rc.hptrIcon = mp3;

   /* Fully qualified file name */
   core -> full = strdup(pfilename);

   /* File size */
   sprintf(buf, "%u kB", (int)(sb.st_size / 1024));
   core -> length = strdup(buf);
   core -> size  = (long)sb.st_size;

   /* Song length */
   sprintf(buf, "%02u:%02u", core->secs / 60, core->secs % 60);
   core -> time = strdup(buf);

   /* decoder info string needed for eventual playback */
   core->info_string = strdup(info.tech_info);

   insert.cb             = sizeof(RECORDINSERT);
   insert.pRecordOrder   = (PRECORDCORE) position;
   insert.pRecordParent     = NULL;
   insert.fInvalidateRecord = FALSE;
   insert.zOrder         = CMA_TOP;
   insert.cRecordsInsert    = 1;

   WinSendMsg(container, CM_INSERTRECORD, MPFROMP(core), MPFROMP(&insert));
   // WinSendMsg(container, CM_SETRECORDEMPHASIS, MPFROMP(core), MPFROM2SHORT(TRUE, CRA_SELECTED));
   playlist_total++;
   if(position != (PMYMPREC) CMA_END && find_index(core) <= playlist_index)
      playlist_index++;

   removearray[0] = core;
   WinSendMsg(container, CM_INVALIDATERECORD, MPFROMP(&removearray), MPFROM2SHORT(1, 0));

   return (core);
}

void amp_drawindicator(HPS hps, int position)
{
 static int old_position = 1;
 POINTL p;
 ULONG i;

 if (!WindowSmall)
 {
  if (position < 0) position = 0;

  if (old_position > slider_width) old_position = slider_width;
  if (position > slider_width) position = slider_width;

  if (bmp_cache[1906] != 0 && bmp_pos[67].x != -1 && bmp_pos[67].y != -1)
    amp_drawbmp(hps, bmp_pos[67].x, bmp_pos[67].y, 1906);
   else
    amp_drawbk(hps, bmp_pos[24].x, bmp_pos[24].y, bmp_pos[24].x + slider_width + bmp_x(1610) - 1, bmp_pos[24].y + bmp_y(1610) - 1, 1900);

  amp_drawbmp(hps, bmp_pos[24].x + position, bmp_pos[24].y, 1610);

  old_position = position;
 }
}

HBITMAP gpi_load_bitmap(HPS hps, int res)
{
 return(GpiLoadBitmap(hps, NULLHANDLE, res, 0, 0));
}

void init_skins_rest(HPS hps)
{
 int i;

 /* Small digits */
 for (i = 1100; i < 1110; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Big digits */
 for (i = 1200; i < 1212; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Buttons */
 for (i = 1300; i < 1322; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Buttons */
 for (i = 5500; i < 5522; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Font 1 */
 for (i = 1400; i < 1445; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Font 2 */
 for (i = 4400; i < 4445; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Misc */
 for (i = 1600; i < 1670; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Bit rates */
 for (i = 1800; i < 1822; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Stuph */
 for (i = 1900; i < 1907; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

/* POSITIONS */
 /* Led on */
// bmp_pos[1820].x = ; bmp_pos[1820].y = ;
 /* Led off */
// bmp_pos[1821].x = ; bmp_pos[1821].y = ;
}

void init_positions(void)
{
 /* Timer */
 bmp_pos[1].x = 212; bmp_pos[1].y = 47;

 /* Main window regular */
 bmp_pos[2].x = 300; bmp_pos[2].y = 110;

 /* Buttons */
 bmp_pos[3].x  = 6;   bmp_pos[3].y  = 5;  /* Play */
 bmp_pos[4].x  = 31;  bmp_pos[4].y  = 5;  /* Pause */
 bmp_pos[5].x  = 56;  bmp_pos[5].y  = 5;  /* Rewind */
 bmp_pos[6].x  = 81;  bmp_pos[6].y  = 5;  /* Fast forward */
 bmp_pos[7].x  = 116; bmp_pos[7].y  = 5;  /* Playlist */
 bmp_pos[8].x  = 141; bmp_pos[8].y  = 5;  /* Repeat */
 bmp_pos[9].x  = 166; bmp_pos[9].y  = 5;  /* Shuffle */
 bmp_pos[10].x = 191; bmp_pos[10].y = 5;  /* Previous */
 bmp_pos[11].x = 216; bmp_pos[11].y = 5;  /* Next */
 bmp_pos[12].x = 268; bmp_pos[12].y = 5;  /* Power */

 /* Text display start, regular */
 bmp_pos[13].x = 32; bmp_pos[13].y = 81;

 /* Text display start, Small */
 bmp_pos[14].x = 32; bmp_pos[14].y = 41;

 /* Time left, dark */
 bmp_pos[15].x = 68; bmp_pos[15].y = 65;
 /* Time left, bright */
 bmp_pos[16].x = 68; bmp_pos[16].y = 65;

 /* List left, dark */
 bmp_pos[17].x = 62; bmp_pos[17].y = 47;
 /* List left, bright */
 bmp_pos[18].x = 62; bmp_pos[18].y = 47;

 /* Time left mini */
 bmp_pos[19].x = 115; bmp_pos[19].y = 63;

 /* List left mini */
 bmp_pos[20].x = 115; bmp_pos[20].y = 47;

 /* Play mode indicator */
 bmp_pos[21].x = 32; bmp_pos[21].y = 48;

 /* Led */
 bmp_pos[22].x = 8; bmp_pos[22].y = 90;
 bmp_pos[23].x = 8; bmp_pos[23].y = 90;

 /* Slider */
 bmp_pos[24].x = 32; bmp_pos[24].y = 40;

 /* Volume */
 bmp_pos[25].x = 9; bmp_pos[25].y = 38;

 /* Channels */
 bmp_pos[26].x = 157; bmp_pos[26].y = 64;
 bmp_pos[27].x = 157; bmp_pos[27].y = 64;
 bmp_pos[28].x = 157; bmp_pos[28].y = 64;

 /* Bitrate */
 bmp_pos[29].x = 177; bmp_pos[29].y = 64;

 /* Window sizes */
 bmp_pos[30].x = 300; bmp_pos[30].y = 70; /* Small */
 bmp_pos[31].x = 300; bmp_pos[31].y = 37; /* Tiny */

 /* Button locations in small size */
 bmp_pos[33].x = 6;   bmp_pos[33].y = 5;  /* Play */
 bmp_pos[34].x = 31;  bmp_pos[34].y = 5;  /* Pause */
 bmp_pos[35].x = 56;  bmp_pos[35].y = 5;  /* Rewind */
 bmp_pos[36].x = 81;  bmp_pos[36].y = 5;  /* Fast forward */
 bmp_pos[37].x = 116; bmp_pos[37].y = 5;  /* Playlist */
 bmp_pos[38].x = 141; bmp_pos[38].y = 5;  /* Repeat */
 bmp_pos[39].x = 166; bmp_pos[39].y = 5;  /* Shuffle */
 bmp_pos[40].x = 191; bmp_pos[40].y = 5;  /* Previous */
 bmp_pos[41].x = 216; bmp_pos[41].y = 5;  /* Next */
 bmp_pos[42].x = 268; bmp_pos[42].y = 5;  /* Power */

 /* Button locations in tiny size */
 bmp_pos[53].x = 6;   bmp_pos[53].y = 5;  /* Play */
 bmp_pos[54].x = 31;  bmp_pos[54].y = 5;  /* Pause */
 bmp_pos[55].x = 56;  bmp_pos[55].y = 5;  /* Rewind */
 bmp_pos[56].x = 81;  bmp_pos[56].y = 5;  /* Fast forward */
 bmp_pos[57].x = 116; bmp_pos[57].y = 5;  /* Playlist */
 bmp_pos[58].x = 141; bmp_pos[58].y = 5;  /* Repeat */
 bmp_pos[59].x = 166; bmp_pos[59].y = 5;  /* Shuffle */
 bmp_pos[60].x = 191; bmp_pos[60].y = 5;  /* Previous */
 bmp_pos[61].x = 216; bmp_pos[61].y = 5;  /* Next */
 bmp_pos[62].x = 268; bmp_pos[62].y = 5;  /* Power */

 /* Playlist position indicators */
 bmp_pos[63].x = 150; bmp_pos[63].y = 48;
 bmp_pos[64].x = 176; bmp_pos[64].y = 48;

 /* Stop button (hidden) */
 bmp_pos[65].x = -1; bmp_pos[65].y = -1;

 /* File load button (hidden) */
 bmp_pos[66].x = -1; bmp_pos[66].y = -1;

 /* Slider shaft (hidden) */
 bmp_pos[67].x = -1; bmp_pos[67].y = -1;
}

void reflow_and_resize()
{
 HAB haba;
 HMQ hmq;
 int btninc = 0, btninc2 = 0;
 ULONG fl = 0;

 /* Reinstate dead buttons */
 amp_createmainwin(hwndClient);

 /* Main window */
 switch (cfg.mode)
  {
   case 1: WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, bmp_pos[30].x, bmp_pos[30].y,
                    SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW); break;
   case 2: WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, bmp_pos[31].x, bmp_pos[31].y,
                    SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW); break;
   default: WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, bmp_pos[2].x, bmp_pos[2].y,
               SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW); break;
  }
 if (!WindowSmall) { btninc = 0; btninc2 = 0; } else { if (!WindowTiny) btninc = 30; else btninc = 50; btninc2 = 4200; }

 /* Buttons */
 if (bmp_pos[btninc + 3].x < 0 && bmp_pos[btninc + 3].y < 0) { WinDestroyWindow(btn_play); btn_play = 0; }
 WinSetWindowPos(btn_play, HWND_TOP, /* Play */
             bmp_pos[btninc + 3].x, bmp_pos[btninc + 3].y,
             bmp_x(btninc2 + BMP_PLAY), bmp_y(btninc2 + BMP_PLAY),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW | fl);

 if (bmp_cache[5510] > 0 && bmp_cache[5500] > 0 && WindowSmall)
   WinSendMsg(btn_play, WM_CHANGEBMP, MPFROMLONG(5510), MPFROMLONG(5500));
  else
   WinSendMsg(btn_play, WM_CHANGEBMP, MPFROMLONG(1310), MPFROMLONG(1300));

 if (bmp_pos[btninc + 4].x < 0 && bmp_pos[btninc + 4].y < 0) { WinDestroyWindow(btn_pause); btn_pause = 0; }
 WinSetWindowPos(btn_pause, HWND_TOP, /* Pause */
             bmp_pos[btninc + 4].x, bmp_pos[btninc + 4].y,
             bmp_x(btninc2 + BMP_PAUSE), bmp_y(btninc2 + BMP_PAUSE),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW | fl);

 if (bmp_cache[5512] > 0 && bmp_cache[5502] > 0 && WindowSmall)
   WinSendMsg(btn_pause, WM_CHANGEBMP, MPFROMLONG(5512), MPFROMLONG(5502));
  else
   WinSendMsg(btn_pause, WM_CHANGEBMP, MPFROMLONG(1312), MPFROMLONG(1302));

 if (bmp_pos[btninc + 5].x < 0 && bmp_pos[btninc + 5].y < 0) { WinDestroyWindow(btn_rew); btn_rew = 0; }
 WinSetWindowPos(btn_rew, HWND_TOP, /* Rewind */
             bmp_pos[btninc + 5].x, bmp_pos[btninc + 5].y,
             bmp_x(btninc2 + BMP_REW), bmp_y(btninc2 + BMP_REW),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

 if (bmp_cache[5513] > 0 && bmp_cache[5503] > 0 && WindowSmall)
   WinSendMsg(btn_rew, WM_CHANGEBMP, MPFROMLONG(5513), MPFROMLONG(5503));
  else
   WinSendMsg(btn_rew, WM_CHANGEBMP, MPFROMLONG(1313), MPFROMLONG(1303));

 if (bmp_pos[btninc + 6].x < 0 && bmp_pos[btninc + 6].y < 0) { WinDestroyWindow(btn_fwd); btn_fwd = 0; }
 WinSetWindowPos(btn_fwd, HWND_TOP, /* Fast forward */
             bmp_pos[btninc + 6].x, bmp_pos[btninc + 6].y,
             bmp_x(btninc2 + BMP_FWD), bmp_y(btninc2 + BMP_FWD),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW | fl);

 if (bmp_cache[5514] > 0 && bmp_cache[5504] > 0 && WindowSmall)
   WinSendMsg(btn_fwd, WM_CHANGEBMP, MPFROMLONG(5514), MPFROMLONG(5504));
  else
   WinSendMsg(btn_fwd, WM_CHANGEBMP, MPFROMLONG(1314), MPFROMLONG(1304));

 if (bmp_pos[btninc + 7].x < 0 && bmp_pos[btninc + 7].y < 0) { WinDestroyWindow(btn_pl); btn_pl = 0; }
 WinSetWindowPos(btn_pl, HWND_TOP, /* Playlist */
             bmp_pos[btninc + 7].x, bmp_pos[btninc + 7].y,
             bmp_x(btninc2 + BMP_PL), bmp_y(btninc2 + BMP_PL),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

 if (bmp_cache[5521] > 0 && bmp_cache[5520] > 0 && WindowSmall)
   WinSendMsg(btn_pl, WM_CHANGEBMP, MPFROMLONG(5521), MPFROMLONG(5520));
  else
   WinSendMsg(btn_pl, WM_CHANGEBMP, MPFROMLONG(1320), MPFROMLONG(1321));

 if (bmp_pos[btninc + 8].x < 0 && bmp_pos[btninc + 8].y < 0) { WinDestroyWindow(btn_load); btn_load = 0; }
 WinSetWindowPos(btn_load, HWND_TOP, /* Repeat */
             bmp_pos[btninc + 8].x, bmp_pos[btninc + 8].y,
             bmp_x(btninc2 + BMP_LOAD), bmp_y(btninc2 + BMP_LOAD),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

 if (bmp_cache[5519] > 0 && bmp_cache[5509] > 0 && WindowSmall)
   WinSendMsg(btn_load, WM_CHANGEBMP, MPFROMLONG(5519), MPFROMLONG(5509));
  else
   WinSendMsg(btn_load, WM_CHANGEBMP, MPFROMLONG(1319), MPFROMLONG(1309));

 if (bmp_pos[btninc + 9].x < 0 && bmp_pos[btninc + 9].y < 0) { WinDestroyWindow(btn_list); btn_list = 0; }
 WinSetWindowPos(btn_list, HWND_TOP, /* Shuffle */
             bmp_pos[btninc + 9].x, bmp_pos[btninc + 9].y,
             bmp_x(btninc2 + BMP_LIST), bmp_y(btninc2 + BMP_LIST),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

 if (bmp_cache[5518] > 0 && bmp_cache[5508] > 0 && WindowSmall)
   WinSendMsg(btn_list, WM_CHANGEBMP, MPFROMLONG(5518), MPFROMLONG(5508));
  else
   WinSendMsg(btn_list, WM_CHANGEBMP, MPFROMLONG(1318), MPFROMLONG(1308));

 if (bmp_pos[btninc + 10].x < 0 && bmp_pos[btninc + 10].y < 0) { WinDestroyWindow(btn_prev); btn_prev = 0; }
 WinSetWindowPos(btn_prev, HWND_TOP, /* Prev */
             bmp_pos[btninc + 10].x, bmp_pos[btninc + 10].y,
             bmp_x(btninc2 + BMP_PREV), bmp_y(btninc2 + BMP_PREV),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

 if (bmp_cache[5516] > 0 && bmp_cache[5506] > 0 && WindowSmall)
   WinSendMsg(btn_prev, WM_CHANGEBMP, MPFROMLONG(5516), MPFROMLONG(5506));
  else
   WinSendMsg(btn_prev, WM_CHANGEBMP, MPFROMLONG(1316), MPFROMLONG(1306));

 if (bmp_pos[btninc + 11].x < 0 && bmp_pos[btninc + 11].y < 0) { WinDestroyWindow(btn_next); btn_next = 0; }
 WinSetWindowPos(btn_next, HWND_TOP, /* Next */
             bmp_pos[btninc + 11].x, bmp_pos[btninc + 11].y,
             bmp_x(btninc2 + BMP_NEXT), bmp_y(btninc2 + BMP_NEXT),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

 if (bmp_cache[5517] > 0 && bmp_cache[5507] > 0 && WindowSmall)
   WinSendMsg(btn_next, WM_CHANGEBMP, MPFROMLONG(5517), MPFROMLONG(5507));
  else
   WinSendMsg(btn_next, WM_CHANGEBMP, MPFROMLONG(1317), MPFROMLONG(1307));

 if (bmp_pos[btninc + 12].x < 0 && bmp_pos[btninc + 12].y < 0) { WinDestroyWindow(btn_power); btn_power = 0; }
 WinSetWindowPos(btn_power, HWND_TOP, /* Power */
             bmp_pos[btninc + 12].x, bmp_pos[btninc + 12].y,
             bmp_x(btninc2 + BMP_POWER), bmp_y(btninc2 + BMP_POWER),
             SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

 if (bmp_cache[5515] > 0 && bmp_cache[5505] > 0 && WindowSmall)
   WinSendMsg(btn_power, WM_CHANGEBMP, MPFROMLONG(5515), MPFROMLONG(5505));
  else
   WinSendMsg(btn_power, WM_CHANGEBMP, MPFROMLONG(1315), MPFROMLONG(1305));

 if (!WindowSmall)
  {
   if (bmp_pos[65].x < 0 && bmp_pos[65].y < 0) { WinDestroyWindow(btn_stop); btn_stop = 0; }
   WinSetWindowPos(btn_stop, HWND_TOP, /* Stop */
               bmp_pos[65].x, bmp_pos[65].y,
               bmp_x(1323), bmp_y(1323),
               SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

   WinSendMsg(btn_stop, WM_CHANGEBMP, MPFROMLONG(1323), MPFROMLONG(1322));
  } else
   {
   WinShowWindow(btn_stop, FALSE);
   WinDestroyWindow(btn_stop); btn_stop = 0;
   }

 if (!WindowSmall)
  {
   if (bmp_pos[66].x < 0 && bmp_pos[66].y < 0) { WinDestroyWindow(btn_fload); btn_fload = 0; }
   WinSetWindowPos(btn_fload, HWND_TOP, /* Stop */
               bmp_pos[66].x, bmp_pos[66].y,
               bmp_x(1325), bmp_y(1325),
               SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);

   WinSendMsg(btn_fload, WM_CHANGEBMP, MPFROMLONG(1325), MPFROMLONG(1324));
  } else
   {
   WinShowWindow(btn_fload, FALSE);
   WinDestroyWindow(btn_fload); btn_fload = 0;
   }

 if (!WindowSmall) maxmsglen = nmaxmsg; else maxmsglen = smaxmsg;

 WinInvalidateRect(hwndClient, NULL, 1);
}

int load_packfile(char *pfilename)
{
 FILE *pack, *temp;
 char buf[256], *fbuf, tmpnm[256];
 bundle_hdr hdr;
 ULONG i;

 pack = fopen(pfilename, "rb");
 if (pack == NULL)
  {
   sprintf(buf, "The bitmap bundle file, %s, for this skin was not found. Skin display as incomplete.\n", pfilename);
   WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf, "Warning", 0, MB_INFORMATION | MB_OK);
   return 0;
  }

 while (!feof(pack))
  {
   fread(&hdr, 1, sizeof(bundle_hdr), pack);
   if (hdr.length > 0)
   {
    fbuf = malloc(hdr.length);
    if (fbuf != NULL)
     {
      i = fread(fbuf, 1, hdr.length, pack);

      sprintf(tmpnm, "pm123%s", sext(hdr.filename));
      temp = fopen(tmpnm, "wb");

      if (temp != NULL)
      {
       fwrite(fbuf, 1, i, temp);
       fclose(temp);

       bmp_cache[hdr.resource] = gbm_load_bitmap(tmpnm);
       remove(tmpnm);
      }
      free(fbuf);
     }
   }
  }

 fclose(pack);
 return 1;
}

void init_new_default_skin(HPS hps)
{
 int i;

 bmp_pos[15].x = -1; bmp_pos[15].x = -1;
 bmp_pos[16].x = -1; bmp_pos[16].x = -1;
 bmp_pos[17].x = -1; bmp_pos[17].x = -1;
 bmp_pos[18].x = -1; bmp_pos[18].x = -1;
 bmp_pos[19].x = -1; bmp_pos[19].x = -1;
 bmp_pos[20].x = -1; bmp_pos[20].x = -1;
 bmp_pos[21].x = -1; bmp_pos[21].x = -1;

 /* Channels */
 bmp_pos[26].x = 159; bmp_pos[26].y = 64;
 bmp_pos[27].x = 159; bmp_pos[27].y = 64;
 bmp_pos[28].x = 159; bmp_pos[28].y = 64;

 /* Playlist position indicators */
 bmp_pos[63].x = 163; bmp_pos[63].y = 50;
 bmp_pos[64].x = 189; bmp_pos[64].y = 50;

 /* Channels */
 bmp_pos[26].x = 162; bmp_pos[26].y = 64;
 bmp_pos[27].x = 162; bmp_pos[27].y = 64;
 bmp_pos[28].x = 162; bmp_pos[28].y = 64;

 /* Bitrate */
 bmp_pos[29].x = 182; bmp_pos[29].y = 64;

 /* Init correct fonts */
 /* Font 1 */

 for (i = 1445; i < 1451; i++)
  if (bmp_cache[i] != 0) GpiDeleteBitmap(bmp_cache[i]);
 for (i = 4445; i < 4451; i++)
  if (bmp_cache[i] != 0) GpiDeleteBitmap(bmp_cache[i]);

 for (i = 1445; i < 1451; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 /* Font 2 */
 for (i = 4445; i < 4451; i++)
  if (bmp_cache[i] == 0) bmp_cache[i] = GpiLoadBitmap(hps, NULLHANDLE, i, 0, 0);

 if (bmp_cache[1900] == 0) GpiDeleteBitmap(bmp_cache[1900]);
 bmp_cache[1900] = GpiLoadBitmap(hps, NULLHANDLE, 10000, 0, 0);

 strcpy(plugins[plugindex].filename, "visplug/analyzer.dll");
 plugins[plugindex].x     = 29;
 plugins[plugindex].y     = 49;
 plugins[plugindex].cx    = 128;
 plugins[plugindex].cy    = 32;
 strcpy(plugins[plugindex].param, "");
 plugindex++;

 if (smooth_scroller)
  {
   strcpy(plugins[plugindex].filename, "visplug/scroller.dll");
   plugins[plugindex].x     = 30;
   plugins[plugindex].y     = 80;
   plugins[plugindex].cx    = 258;
   plugins[plugindex].cy    = 20;
   strcpy(plugins[plugindex].param, "");
   plugindex++;
   bmp_pos[13].x = -1;
   bmp_pos[13].y = -1;
  }

 new_plind = 1;
 timer_sep = 1;
}


int init_skins(char *pfilename, HWND hwnd, HPS hps)
{
 FILE *f;
 char buf[256], *buf2, buf3[256], *buf4, buf5[256], *buf6;
 int i, o;
 RGB2 rgb;
 char c;
 POINTL p;
 int pos_set = 0;
 char def_path[CCHMAXPATH];
 char orig_path[CCHMAXPATH];
 struct stat ztat;
 APIRET rc;
 int errors = 0;
 int line = 0;

 getcwd(orig_path, CCHMAXPATH);
 drivedir(def_path, pfilename);
 *(strchr(def_path,0)-1) = 0;
 _chdrive(def_path[0] - 'A' + 1);
 chdir(def_path);

/* for (i = 0; i < 8000; i++) GpiDeleteBitmap(bmp_cache[i]); */

 memset(&bmp_cache, '\0', 8000 * sizeof(HBITMAP));
 memset(&bmp_pos, '\0', 1024 * sizeof(POINTL));

 /* Free loaded plugins */
 for (i = 0; i < 32; i++)
    deinit_vis_plugin(hwnd, i);

 memset(plugins, '\0', sizeof(PLUGIN) * 32);
 plugindex = 0;

 init_positions();

 shadeB.bRed = 0xFF; shadeB.bGreen = 0xFF; shadeB.bBlue = 0xFF;
 shadeD.bRed = 64;    shadeD.bGreen = 64;   shadeD.bBlue = 64;
 seekB.bRed  = 0;  seekB.bGreen  = 0xFF; seekB.bBlue  = 0;
 seekD.bRed  = 0;  seekD.bGreen  = 128;  seekD.bBlue  = 0;
 songC.bRed  = 0;  songC.bGreen  = 0xFF; songC.bBlue  = 0;

 stat_shade = 1; vol_shade = 1; main_shade = 1; maxmsglen = smaxmsg = nmaxmsg = 25;
 slider_width = 242; timer_spacing = 1; hvol = 0; winamp_vol = 0; winamp_kbs = 0; slider_shade = 1;

 if (amp_playmode == AMP_NOFILE) { no_file_loaded(); }

 f = fopen(pfilename, "r");
 if (f == NULL)
  {
   _chdrive(orig_path[0] - 'A' + 1);
   chdir(orig_path);
   init_skins_rest(hps);
   init_new_default_skin(hps);
   for (i = 0; i < plugindex; i++)
      init_plugin(hwnd, i);
   return 0;
  }

 *buf = '\0';

 /* Background */
 while (!feof(f))
  {
   *buf = '\0';
   while (!*buf || buf[0] == '#' || buf[0] == ';')
   {
    if (feof(f)) break;
    fgets(buf, 256, f);
    line++;
    if (*buf) blank_strip(buf);
   }

   if (*buf && buf[0] != '#' && buf[0] != ';')
   {
    buf4 = buf;

    while (*buf4 != 0 && *buf4 != ',' && *buf4 != ':' && *buf4 != '=') { buf4++; }

    if (*buf4)
     {
      c = *buf4;
      *buf4 = '\0';
      buf4++;

      /* Plugin */
      if (*buf && buf[0] != ';' && buf[0] != '#' && c == '=')
      {
       strcpy(buf5, buf4);
       buf6 = strtok(buf4, ",");
       if (!plugin_loaded(buf6))
        {
         strcpy(plugins[plugindex].filename, buf6);
         buf6 = strtok(NULL, ",");
         plugins[plugindex].x  = atoi(buf6);
         buf6 = strtok(NULL, ",");
         plugins[plugindex].y  = atoi(buf6);
         buf6 = strtok(NULL, ",");
         plugins[plugindex].cx = atoi(buf6);
         buf6 = strtok(NULL, ",");
         plugins[plugindex].cy = atoi(buf6);
         if ((buf6 = strtok(NULL, ",")) != NULL) /* pheer */
         {
          for (o = 0, i = 0; i < strlen(buf5) && o < 5; i++)
           if (buf5[i] == ',') o++;
          if (i < strlen(buf5))
            strcpy(plugins[plugindex].param, &buf5[i]);
         }
         plugindex++;
        }
      }

      /* Position */
      if (*buf && atoi(buf) > 0 && c == ':')
      {
       if ((char *)strchr(buf4, ',') != (char *)NULL)
        {
         buf2 = (char *)strchr(buf4, ','); *buf2 = '\0'; buf2++;
         p.x = atoi(buf4); p.y = atoi(buf2);
         bmp_pos[atoi(buf)] = p;
         pos_set = 1;
        }
      }

      /* Bitmap */
      if (*buf && atoi(buf) > 0 && c == ',')
      {
       if (atoi(buf) > 5)
        {
         switch (atoi(buf))
         {
          case  6: stat_shade = 0; break;
          case  7: vol_shade = 0; break;
          case  8: if (amp_playmode == AMP_NOFILE) { strcpy(display_msg, buf4); scroll_index = 0; scrolled = 0; } break;
          case  9: main_shade = 0; break;
          case 10: slider_shade = 0; break;
          case 20: nmaxmsg = atoi(buf4); break;
          case 21: slider_width = atoi(buf4); break;
          case 22: smaxmsg = atoi(buf4); break;
          case 23: cfg.font = gui_font = atoi(buf4); update_font(); break;
          case 24: timer_spacing = atoi(buf4); break;
          case 25: timer_sep = atoi(buf4); break;
          case 26: hvol = atoi(buf4); break;
          case 27: winamp_vol = atoi(buf4); break;
          case 28: winamp_kbs = atoi(buf4); break;
          case 29: new_plind = atoi(buf4); break;
          case 30: load_packfile(buf4); break;
          default:
            if (stat(buf4, &ztat) != 0)
               errors++;
            bmp_cache[atoi(buf)] = gbm_load_bitmap(buf4);
            break;
         }
        }
        else
         {
         *buf3 = '\0';
         while (*buf4 && *buf4 != '/') { strncat(buf3, buf4, 1); buf4++; }
         if (*buf4)
           { rgb.bRed = atoi(buf3); buf4++; }
          else
           rgb.bRed = 0xFF;

         *buf3 = '\0';
         while (*buf4 && *buf4 != '/') { strncat(buf3, buf4, 1); buf4++; }
         if (*buf4)
           { rgb.bGreen = atoi(buf3); buf4++; }
          else
           rgb.bGreen = 0xFF;

         *buf3 = '\0';
         while (*buf4) { strncat(buf3, buf4, 1); buf4++; }
         rgb.bBlue = atoi(buf3); buf4++;

         switch ((int)atoi(buf))
          {
           case 1:  shadeB = rgb;
                  break;
           case 2:  shadeD = rgb;
                  break;
           case 3:  seekB = rgb;
                  break;
           case 4:  seekD = rgb;
                  break;
           case 5:  songC = rgb;
                  break;
           default: break;
          }
         }
      }
     }
   }
  }

 fclose(f);

 o = 1;
 for (i = 0; i < 8000; i++)
  if (bmp_cache[i] != 0) o = 0;

 if (o && !pos_set) init_new_default_skin(hps);

 init_skins_rest(hps);

 reflow_and_resize();

 if (errors > 0)
  {
   rc = WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Some bitmaps of this skin was not found. Would you like to continue the loading of this skin (if you select No, default skin will be used)?", "Error encountered", 0, MB_ERROR | MB_YESNO | MB_APPLMODAL);
   if (rc == MBID_NO)
   {
    init_skins("", hwnd, hps);
    strcpy(cfg.defaultskin, "");
    return 0;
   }

  }

 /* Now initialize plugins */
 for (i = 0; i < 32; i++)
   init_plugin(hwnd, i);

 _chdrive(orig_path[0] - 'A' + 1);
 chdir(orig_path);

 return 1;
}

void amp_drawbk(HPS hps, int x1, int y1, int x2, int y2, int bground)
{
 POINTL aptlPoints[4];

 aptlPoints[0].x = x1;
 aptlPoints[0].y = y1;
 aptlPoints[1].x = x2;
 aptlPoints[1].y = y2;
 aptlPoints[2].x = x1;
 aptlPoints[2].y = y1;
 aptlPoints[3].x = x2 + 1;
 aptlPoints[3].y = y2 + 1;
/* if (bground == 1905)
  {
   aptlPoints[2].x = x1 - 28;
   aptlPoints[2].y = y1 - 37;
   aptlPoints[3].x = x2 - 28 + 1;
   aptlPoints[3].y = y2 - 37 + 1;
  } */

 GpiWCBitBlt(hps,
          bmp_cache[1900],
          4,
          (PPOINTL)&aptlPoints,
          ROP_SRCCOPY,
          /*BBO_IGNORE | BBO_PAL_COLORS*/0);
}

void amp_drawbk2(HPS hps, int x1, int y1, int x2, int y2, int bground)
{
 POINTL aptlPoints[4];

 aptlPoints[0].x = x1;
 aptlPoints[0].y = y1;
 aptlPoints[1].x = (x2 - x1);
 aptlPoints[1].y = (y2 - y1);
 aptlPoints[2].x = x1;
 aptlPoints[2].y = y1;
 aptlPoints[3].x = x2;
 aptlPoints[3].y = y2;
 if (bground == 1905)
  {
   aptlPoints[2].x = x1 - 28;
   aptlPoints[2].y = y1 - 37;
   aptlPoints[3].x = x2 - 28 + 1;
   aptlPoints[3].y = y2 - 37 + 1;
  }

 GpiWCBitBlt(hps,
          bmp_cache[bground],
          4,
          (PPOINTL)&aptlPoints,
          ROP_SRCCOPY,
          /*BBO_IGNORE | BBO_PAL_COLORS*/0);
}

void lamepad(char *target, int width, char *string)
{
 int i;
 char buf[2];

#if 0
 buf[1] = '\0'; buf[0] = ' ';
 strncpy(target, string, 255);
 if (strlen(target) < width)
  {
   for (i = strlen(target); i < width; i++) strncat(target, buf, 1);
  }
 if (strlen(target) > width)
  {
   target[width] = 0;
  }
#else
 strncpy(target, string, 255);
 if (strlen(target) > width) { target[width] = '\0'; return; }
 if (strlen(target) < width)
  {
   for (i = strlen(target); i < width; i++) strncat(target, " ", 1);
  }
#endif
}

int char_width()
{
 if (gui_font == 1) return bmp_x(1400); else return bmp_x(4400);
}

int char_height()
{
 if (gui_font == 1) return bmp_y(1400); else return bmp_y(4400);
}

char *construct_tag_info_string(tune *joopajoo)
{
 static char buf[256] = {0};

 strcpy(buf, "");

 if (strcmp(joopajoo->artist, "") != 0)
  {
   strcat(buf, joopajoo->artist);
   if (strcmp(joopajoo->title, "") != 0)
   strcat(buf, ": ");
  }

 if (strcmp(joopajoo->title, "") != 0)
   strcat(buf, joopajoo->title);

 if (strcmp(joopajoo->album, "") != 0 && strcmp(joopajoo->year, "") != 0)
  {
   strcat(buf, " (");
   strcat(buf, joopajoo->album);
   strcat(buf, ", ");
   strcat(buf, joopajoo->year);
   strcat(buf, ")");
 }
 else
  {
   if (strcmp(joopajoo->album, "") != 0 && strcmp(joopajoo->year, "") == 0)
   {
    strcat(buf, " (");
    strcat(buf, joopajoo->album);
    strcat(buf, ")");
   }
   if (strcmp(joopajoo->album, "") == 0 && strcmp(joopajoo->year, "") != 0)
   {
    strcat(buf, " (");
    strcat(buf, joopajoo->year);
    strcat(buf, ")");
   }
  }

 if(joopajoo->comment[0] != 0)
 {
   strncat(buf," -/- ",sizeof(buf)-strlen(buf)-1);
   strncat(buf,joopajoo->comment,sizeof(buf)-strlen(buf)-1);
 }

 return(buf);
}

void amp_drawplind(HPS hps, int index, int total)
{
 int inc, i, x, y;
 char buf[16];

 /* Erase */
 amp_drawbk(hps, bmp_pos[63].x, bmp_pos[63].y, bmp_pos[63].x + (bmp_x(1660) * 3), bmp_pos[63].y + bmp_y(1660), 1900);
 amp_drawbk(hps, bmp_pos[64].x, bmp_pos[64].y, bmp_pos[64].x + (bmp_x(1660) * 3), bmp_pos[64].y + bmp_y(1660), 1900);

 if (bmp_pos[63].x != -1 && bmp_pos[63].y != -1)
  {
   x = bmp_pos[63].x + (bmp_x(1660) * 3); y = bmp_pos[63].y;
   sprintf(buf, "%3u", index);

   for (i = strlen(buf) - 1; i >= 0; i--)
   {
    if (buf[i] != ' ')
     amp_drawbmp(hps, bmp_pos[63].x + (i * bmp_x(1660 + buf[i] - 48)), y, (1660 + buf[i] - 48));
   }
  }

 if (bmp_pos[64].x != -1 && bmp_pos[64].y != -1)
  {
   x = bmp_pos[64].x + (bmp_x(1660) * 3); y = bmp_pos[64].y;
   sprintf(buf, "%3u", total);

   for (i = strlen(buf) - 1; i >= 0; i--)
   {
    if (buf[i] != ' ')
     amp_drawbmp(hps, bmp_pos[64].x + (i * bmp_x(1660 + buf[i] - 48)), y, (1660 + buf[i] - 48));
   }
  }
}

/* Posts a file to the playlist thread */
void playlist_post_file(char *pfilename)
{
 HPIPE plpipe;
 ULONG action;
 ULONG rc;

 rc = DosOpen(plpipename,
       &plpipe,
       &action,
       0,
       FILE_NORMAL,
       OPEN_ACTION_FAIL_IF_NEW | OPEN_ACTION_OPEN_IF_EXISTS,
       OPEN_SHARE_DENYREADWRITE | OPEN_ACCESS_READWRITE | OPEN_FLAGS_FAIL_ON_ERROR,
       NULL);

 rc = DosWrite((HFILE) plpipe,
        pfilename,
        strlen(pfilename) + 1,
        &action);

 DosClose(plpipe);
}


int recursive_dir_add(char *directory)
{
   HDIR         hdir;
   FILEFINDBUF3 findbuf;

   char *filespec = _alloca(strlen(directory) + 3);
   char *lastchar;

   strcpy(filespec,directory);
   lastchar = strchr(filespec,0)-1;

   if(*lastchar != '\\' && *lastchar != '/')
      strcat(filespec,"\\*");
   else
      strcat(filespec,"*");

   if(findfirst(&hdir, filespec, FIND_ALL, &findbuf) != 0)
   {
      char buf[512];
      sprintf(buf, "Error: Can't read directory \"%s\"!", directory);
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf, "Error encountered", 0, MB_ERROR | MB_OK);
      return 0;
   }

   do
   {
      if(findbuf.attrFile & FILE_DIRECTORY)
      {
         if(strcmp(findbuf.achName,".") != 0 && strcmp(findbuf.achName,"..") != 0)
         {
            char *subdir = _alloca(strlen(directory)+1+strlen(findbuf.achName)+1);
            sprintf(subdir, "%s\\%s", directory, findbuf.achName);
            if(!recursive_dir_add(subdir))
               return 0;
         }
      }
      else
      {
         char *foundfile = _alloca(strlen(directory)+1+strlen(findbuf.achName)+1);
         char module_name[128];
         DECODER_INFO info;

         sprintf(foundfile, "%s\\%s", directory, findbuf.achName);
         if(dec_fileinfo(foundfile, &info, module_name) == 0)
            pl_add_song(foundfile, (PMYMPREC)CMA_END, NULL);
      }
   }
   while(findnext(hdir, &findbuf) == 0);

   findclose(hdir);

   return 1;
}


void deinit_vis_plugin(HWND hwnd, int n)
{
 if (plugins[n].type == PLUGIN_VISUAL && plugins[n].loaded)
  {
//   DosBeep(500, 100);
   if (plugins[n].deinit != NULL)
    plugins[n].deinit(0);

   plugins[n].loaded = 0;
   DosFreeModule(plugins[n].module);
   plugins[n].module = (HMODULE)0;
  }
}


void deinit_plugin(HWND hwnd, int n)
{
 if (plugins[n].type != PLUGIN_NULL && plugins[n].loaded)
  {
   if (plugins[n].deinit != NULL)
    plugins[n].deinit(0);

   plugins[n].loaded = 0;
   DosFreeModule(plugins[n].module);
   plugins[n].module = (HMODULE)0;
  }
}

void cfg_plugin(HWND hwnd, int n)
{
 PFN plugin_configure;
 APIRET rc;

 if (plugins[n].type != PLUGIN_NULL)
  {
   if (plugins[n].loaded == 1 && plugins[n].configurable == 1)
   {
    rc = DosQueryProcAddr(plugins[n].module,
                     0,
                     "plugin_configure",
                     &plugin_configure);
    if (rc == 0)
       plugin_configure(hwnd, plugins[n].module);
   }

  }
}

int init_plugin(HWND hwnd, int n)
{
 char          errorbuf[256], buf1[256], buf2[256], buf3[1024];
 APIRET        rc;
 PFN           PluginQuery, PluginInit;
 VISPLUGININIT    visinit;
 PLUGIN_QUERYPARAM query;
 PLUGIN_PROCS     procs;

 if (strcmp(plugins[n].filename, "") == 0) return 0;

 procs.output_playing_samples = out_playing_samples;
 procs.decoder_playing       = decoder_playing;
 procs.output_playing_pos    = out_playing_pos;
 procs.decoder_status        = dec_status;
 procs.decoder_command       = dec_command;
 procs.decoder_fileinfo      = dec_fileinfo;
 procs.specana_init          = specana_init;
 procs.specana_dobands       = specana_dobands;
 procs.pm123_getstring       = pm123_getstring;
 procs.pm123_control         = pm123_control;

 procs.decoder_trackinfo     = dec_trackinfo;
 procs.decoder_cdinfo        = dec_cdinfo;
 procs.decoder_length        = dec_length;

 if (plugins[n].module == 0)
 {
  // if relative path, make it relative to PM123.exe directory
  if(isrelative(plugins[n].filename))
  {
     drivedir(buf3,startpath);
     strcat(buf3,plugins[n].filename);
  }
  else
     strcpy(buf3,plugins[n].filename);

  errorbuf[0] = 0;
  rc = DosLoadModule(errorbuf,
                sizeof(errorbuf),
                // plugins[n].filename,
                buf3,
                &plugins[n].module);

  if (rc != 0)
   {
      sprintf(buf3, "The plugin `%s' could not be loaded, rc=%u: %s\n", plugins[n].filename, rc, errorbuf);
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf3, "Error", 0, MB_ERROR | MB_OK);

    plugins[n].type = PLUGIN_NULL;

    return(0);
   }
 }

 rc = DosQueryProcAddr(plugins[n].module,
                 0,
                 "plugin_query",
                 &PluginQuery);

 if (rc != 0)
 {
  sprintf(buf3, "The plugin `%s' doesn't contain a valid plugin_query routine. It may be corrupted.", plugins[n].filename);
  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf3, "Error", 0, MB_ERROR | MB_OK);

  plugins[n].type = PLUGIN_NULL;

  return(0);
 }

 rc = DosQueryProcAddr(plugins[n].module,
                       0,
                       "plugin_deinit",
                       &plugins[n].deinit);

 if (rc != 0)
 {
   sprintf(buf3, "The plugin `%s' doesn't contain a valid plugin_deinit routine. It may be corrupted.", plugins[n].filename);
  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf3, "Error", 0, MB_ERROR | MB_OK);

  plugins[n].type = PLUGIN_NULL;

  return(0);
 }

 plugins[n].loaded = 0;
 PluginQuery(&query);
 plugins[n].desc         = query.desc;
 plugins[n].author    = query.author;
 plugins[n].configurable = query.configurable;
 plugins[n].type         = query.type;

 if (query.type & PLUGIN_VISUAL)
 {
   visinit.x     = plugins[n].x;
   visinit.y     = plugins[n].y;
   visinit.cx    = plugins[n].cx;
   visinit.cy    = plugins[n].cy;
   visinit.hwnd  = hwnd;
   visinit.procs = &procs;
   visinit.id    = n;
   visinit.param = plugins[n].param;
   visinit.hab   = haba;

  rc = DosQueryProcAddr(plugins[n].module,
                   0,
                   "vis_init",
                   &PluginInit);

  if (rc == 0)
   {
  /* Initialize */
  plugins[n].hwnd = PluginInit(&visinit);
  if (plugins[n].hwnd == 0)
    plugins[n].type = PLUGIN_NULL;
   else
    plugins[n].loaded = 1;
   }
 }

  return 1;
}

void plugin_broadcast(ULONG msg, MPARAM mp1, MPARAM mp2)
{
 int i;

 for (i = 0; i < 32; i++)
  {
   if (plugins[i].type & PLUGIN_VISUAL && plugins[i].loaded)
   {
    WinSendMsg(plugins[i].hwnd, msg, mp1, mp2);
   }
  }
}

void pipe_write(HPIPE pipe, char *buf)
{
 ULONG action;

 DosWrite((HFILE)pipe,
        buf,
        strlen(buf) + 1,
        &action);
}

ULONG handle_dfi_error(ULONG rc, char *file)
{
 char buf[256];

 if (rc == 0) return 0;

 *buf = '\0';

 if (rc == 100)
   sprintf(buf, "The file %s could not be read.", file);

 if (rc == 200)
   sprintf(buf, "The file %s cannot be played by PM123. The file might be corrupted or the necessary plug-in not loaded or enabled.", file);

 if (rc == 1001)
  {
   StopWait(); /* baa */
   sprintf(buf, "%s: HTTP error occurred: %s", file, http_strerror());
  }

 if (strcmp(file, "") == 0)
  {
   sprintf(buf, "%s: Error occurred: %s", file, strerror(errno));
  }

 WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buf, "Error", 0, MB_ERROR | MB_OK);
 return 1;
}

int is_playlist(char *filename)
{
 if (stricmp(sext(filename), ".lst") == 0) return 1;
 if (stricmp(sext(filename), ".mpl") == 0) return 1;
 if (stricmp(sext(filename), ".pls") == 0) return 1;
 if (stricmp(sext(filename), ".m3u") == 0) return 1;
 return 0;
}

void load_playlist(HWND container, HWND hwnd, char *pfilename, int clear)
{
 if (stricmp(sext(pfilename), ".lst") == 0)
   amp_addplaylist(container, hwnd, pfilename, clear);

 if (stricmp(sext(pfilename), ".mpl") == 0)
   amp_add_warpamp_playlist(container, hwnd, pfilename, clear);

 if (stricmp(sext(pfilename), ".pls") == 0)
   amp_add_winamp_playlist(container, hwnd, pfilename, clear);

 if (stricmp(sext(pfilename), ".m3u") == 0)
   amp_add_m3u_playlist(container, hwnd, pfilename, clear);
}

void free_plugin(int n)
{
 int i;
 if (plugins[n].loaded) deinit_plugin(NULLHANDLE, n);
/* if (plugins[n].deinit != NULL) plugins[n].deinit(1); */

#if 0

 if (cfg.totalfilters > 0)
  {
   for (i = 0; i < 32; i++)
    {
     if (strcmp(plugins[n].filename, cfg.filters[i]) == 0)
      {
       memmove(&cfg.filters[i], &cfg.filters[i+1], (32-i) * 256);
       memset(&cfg.filters[cfg.totalfilters], '\0', (32 - cfg.totalfilters) * 256);
       cfg.totalfilters--;
       break;
      }
    }
  }
#endif

 memmove(&plugins[n], &plugins[n+1], (32-n) * sizeof(PLUGIN));
 memset(&plugins[31], '\0', sizeof(PLUGIN));
}

int plugin_loaded(char *filename)
{
 int i;
 char buf[256], bjuf[256];

 sprintf(buf, "%s%s", sfname(filename), sdir(filename));

 for (i = 0; i < 32; i++)
  {
   sprintf(bjuf, "%s%s", sfname(plugins[i].filename), sdir(plugins[i].filename));
   if (stricmp(buf, bjuf) == 0) return(1);
  }
 return(0);
}

void do_display_msg(char *filename)
{

 /* umm do I have a tag? prolly should get it just in case - but I don't :) */

   switch(cfg.viewmode)
   {
      case 1:
         if (strcmp(construct_tag_info_string(&curtun), "") != 0)
         {
            sprintf(display_msg, "%s", construct_tag_info_string(&curtun));
            dsp_mode = 1;
            break;
         }
         else if(currentf != NULL && currentf->songname != NULL && currentf->songname[0] != 0)
         {
            if(currentf->comment == NULL)
               sprintf(display_msg, "%s - %s", currentf->songname, currentf->comment);
            else
               sprintf(display_msg, "%s", currentf->songname);
            dsp_mode = 1;
            break;
         }

         // else we display the filename, track, whatever below

      case 0:
         if(current_cd_drive[0] != 0 && current_track != 0)
            sprintf(display_msg, "%s\\Track %d",current_cd_drive,current_track);
         else if(filename != NULL && filename[0] != 0)
         {
           if(strnicmp(filename,"http://",7) == 0 &&
              ( strrchr(filename,'/') == filename+6 || *(strrchr(filename,'/')+1) == 0) )
               strcpy(display_msg, filename); // host
            else
               sprintf(display_msg, "%s", sfname(filename)); // filename
         }
         else
            sprintf(display_msg, "bug");
         dsp_mode = 0;
         break;

      case 2:

         sprintf(display_msg, "%s", current_decoder_info_string);
         dsp_mode = 2;
         break;
   }
   plugin_broadcast(WM_PLUGIN_CONTROL, MPFROMLONG(PN_TEXTCHANGED), 0);

   scrolled = 0; scroll_index = 0;
}

void no_file_loaded()
{
 strcpy(display_msg, "No file loaded"); scroll_index = 0; scrolled = 0;
 plugin_broadcast(WM_PLUGIN_CONTROL, MPFROMLONG(PN_TEXTCHANGED), 0);
}

void _System pm123_control(int index, void *param)
{
 switch (index)
  {
   case CONTROL_NEXTMODE:
    next_display_mode();
    break;
   default: break;
  }
}

int _System pm123_getstring(int index, int subindex, size_t bufsize, char *buf)
{
 switch (index)
  {
   case STR_NULL: *buf = '\0'; break;
   case STR_VERSION:
     strncpy(buf, VERSION, bufsize);
     break;
   case STR_DISPLAY_TEXT:
     strncpy(buf, display_msg, bufsize);
     break;
   case STR_FILENAME:
     strncpy(buf, filename, bufsize);
     break;
   default: break;
  }
 return(0);
}

void next_display_mode()
{
 msg_mode = MSG_SCROLL;
 dsp_mode++;
 switch (dsp_mode)
   {
    case 1:
       if(amp_playmode != AMP_NOFILE && strcmp(construct_tag_info_string(&curtun), "") != 0)
       {
          strcpy(display_msg, construct_tag_info_string(&curtun));
          dsp_mode = 1;
          scroll_index = 0; scrolled = 0;
          update_now = 1;
          break;
       }
       else if(currentf != NULL && currentf->songname != NULL && currentf->songname[0] != 0)
       {
          if(currentf->comment == NULL)
             sprintf(display_msg, "%s - %s", currentf->songname, currentf->comment);
          else
             sprintf(display_msg, "%s", currentf->songname);
          dsp_mode = 1;
          scroll_index = 0; scrolled = 0;
          update_now = 1;
          break;
       }

    case 2:
      dsp_mode = 2;
      if (amp_playmode != AMP_NOFILE && current_decoder_info_string[0] != 0)
      {
        strcpy(display_msg, current_decoder_info_string);
        scroll_index = 0; scrolled = 0;
        update_now = 1;
        break;
      }

    case 0:
    default:
      if (amp_playmode == AMP_NOFILE)
        no_file_loaded();
      else
      {
         if(current_cd_drive[0] != 0 && current_track != 0)
            sprintf(display_msg, "%s\\Track %d",current_cd_drive,current_track);
         else if(filename != NULL && filename[0] != 0)
         {
           if(strnicmp(filename,"http://",7) == 0 &&
              ( strrchr(filename,'/') == filename+6 || *(strrchr(filename,'/')+1) == 0) )
               strcpy(display_msg, filename); // host
            else
               sprintf(display_msg, "%s", sfname(filename)); // filename
         }
         else
            sprintf(display_msg, "bug");
      }
      scroll_index = 0; scrolled = 0;
      dsp_mode = 0;
      update_now = 1;
      break;
     }

 plugin_broadcast(WM_PLUGIN_CONTROL, MPFROMLONG(PN_TEXTCHANGED), 0);
}

void update_font()
{
 WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT1, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
 WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT2, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

 switch (cfg.font)
  {
    case 0: WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT1, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
            break;
    case 1: WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT2, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
            break;
    default: break;
  }
}

