/*
 * Copyright 1997-2003 Samuel Audet <guardia@step.polymtl.ca>
 *                     Taneli Lepp <rosmo@sektori.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *    1. Redistributions of source code must retain the above copyright notice,
 *       this list of conditions and the following disclaimer.
 *
 *    2. Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *
 *    3. The name of the author may not be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define INCL_WIN
#define INCL_GPI
#define INCL_DOS
#define INCL_DOSERRORS
#define INCL_WINSTDDRAG

#define COL_RESERVED (PC_RESERVED * 16777216)

#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
//#include <dirent.h>
#include <math.h>
#include <float.h>

#include <utilfct.h>
#include <list.h>

#include "format.h"
#include "decoder_plug.h"
#include "output_plug.h"
#include "filter_plug.h"
#include "plugin.h"

#include "pm123.h"
#include "plugman.h"
#include "bookmark.h"
#include "button95.h"
#include "pfreq.h"
#include "httpget.h"
#include "genre.h"
#include "copyright.h"

#define WM_UPDATE1         WM_USER+70
#define WM_UPDATE2         WM_USER+71
#define WM_UPDATE3         WM_USER+72
#define WM_UPDATE4         WM_USER+73
#define WM_UPDATE5         WM_USER+74
#define WM_LOADFILE        WM_USER+75
#define WM_REFRESH_CONTROLS  WM_USER+121

char startpath[CCHMAXPATH];

int i_have_focus = 0;
int initial_shuffle = 0;
int o_open_file = 0, o_add_file = 0, o_load_list = 0, o_save_list = 0, o_tag_open = 0, o_manager = 0, eq_open = 0;
extern PLUGIN plugins[64];
ULONG action;
extern int manager_open;
HWND hwndTemp;
static HMTX mutexDir;
DECODER_INFO Info;
extern char *genres[];
char *dirs[CCHMAXPATH];
int dirs_found = 0, files_found = 0, files_inc = 0;
char *filz;
int cfg_hwnd = 0;
HWND hwndFrame, hwndClient, hwndPlaylist, hwndMain;
extern int smooth_scroller;
int current_bitrate = 0, current_channels = -1, current_length = 0, current_freq = 0;
char current_decoder_info_string[128];

extern char decoder_needed[128];
extern OUTPUT_PARAMS out_params;
BOOL decoder_finished = FALSE;


extern int stat_shade;
LONG foocol;
MYMPREC single;
extern HBITMAP bmp_cache[8000];
extern POINTL bmp_pos[8000];
extern int nmaxmsg, smaxmsg, hvol, new_plind;
int do_not_recall = 0;

PMYMPREC just_dropped, tmprec, just_saved;
HWND main_menu;
int update_index = 0;
extern int vol_shade, main_shade;
ULONG pause_time;
HMQ hmq;
int updated;
QMSG qmsg;
int paused;
HAB haba;
ULONG dirThreads = 0;
HPS hps, hpsPal;
RECTL rcl;
char add_dir[CCHMAXPATH];
FONTMETRICS ufont;
POINTL ptlMouse;
SWP swp;
char buf[512], _buf[512], __buf[512], plbuf[512], rbuf[512], cbuf[512];
char info1[512], info2[512];
int skinned = 0;
char drag_container[CCHMAXPATH], drag_filename[CCHMAXPATH];
int stat_mode = 0;
int display_width = 0;
extern int slider_width;
TRACKINFO TrackInfo;
SWP Position;
time_t playback_start;
HWND container, kill, title;
int shuffling = 0;
RECTL wn;
HPOINTER mp3, mp3play;
POINTL pint;
tune tun, curtun;
char metadata_buffer[128]; // loaded in curtun on decoder's demand WM_METADATA
HWND menu_playlist, menu_playlists, menu_directory;
PMYMPREC removearray[1];
char srceName[CCHMAXPATH], pathName[CCHMAXPATH], RMF[CCHMAXPATH];
char lastdir[CCHMAXPATH];
FILE *cfgfile;
int maxmsglen = 27, fontrise = 0;
extern RGB2 shadeB, shadeD, seekB, seekD, songC;
int scrolled = 0;

/* Play mode */
int amp_playmode = AMP_NOFILE;
int playlist_open = 0;
int playlist_index = 0;
int dont_continue = 0;
int playlist_total = 0;
int pl_entry_move_playing = 0;
PMYMPREC currentf;
PMYMPREC tagedit;
int keyboard_activated_shit = 0;

extern ULONG priority1;

extern char filename[CCHMAXPATH];
extern char current_track;
extern char current_cd_drive[4];
int paused = 0;

char filez[CCHMAXPATH];

extern char display_msg[256];
char timeout_msg[256];
int timeout = 0;
int scroll = 0;
int scroll_index = 0;
int msg_mode = MSG_SCROLL;
int blinky = 0;
int update_now = 0;

/* Current volume */
int volume = 0, volsave = 0;
int volume_drag = 0, seek_drag = 0, seek_vol = 0, seeking = 0;
int total_list = 0;
int ramp_volume = 0;

HSWITCH swits, eqSwits;
SWCNTRL sdata, eqSdata;
extern HSWITCH mgrSwits;
extern SWCNTRL mgrSdata;

/* display_thread */
char scrollbuf[255];
char tempbuf[255];

/* notebook */
HWND notebook;
ULONG pageid, pageid2, pageid3, pageid4;
HWND page1, page2, page3, page4;
HWND hwndCfg;

/* file notebook */
HWND filebook;
ULONG fpageid, fpageid2;
HWND fpage1, fpage2;
HWND hwndFile = 0;

/* Pipes to pass new song information */
HPIPE piippu, plpiippu, plpiippu2;
// pipe names decided on startup
char pipename[CCHMAXPATH], plpipename[CCHMAXPATH];

/* Since mp123 */
ULONG WindowHeight = 109;
ULONG WindowSmall = FALSE;
ULONG WindowTiny = FALSE;
extern int play_ind;
FILE *tmplist;
int open_a_fucking_temp_list = 0;
char *argument;

int gui_font = 1;
int time_mode = 0;
int dsp_mode = 0;
int ffwding = FALSE;
int rewwing = FALSE;
int repeat = FALSE;

time_t        aika;

RGB rgb;
ULONG mainFg = CLR_PALEGRAY, mainBright = CLR_WHITE, mainDark = CLR_DARKGRAY, variz;
HPAL hpal;
ULONG palette[3];

ULONG playlist_length = 0, total_played = 0;

char url[1024];
float *bandPtr;

/* PLOINK */
extern HWND container, hwndManager;
extern int forwarding, rewinding;
HWND hwndEq;
int kludge_48as44 = 0;

char http_proxy[256], http_auth[256];

LIST_NODE *dock_list = NULL; // keeps docked windows in memory


char info_display[2048];
char last_error[2048];
void _System keep_last_error(char *error)
{
   strncpy(last_error,error,sizeof(last_error)-1);
   last_error[sizeof(last_error)-1] = 0;
}

#define WM_DISPLAYMSG 33333
void _System display_info(char *info)
{
   strncpy(info_display,info,sizeof(info_display)-1);
   info_display[sizeof(info_display)-1] = 0;
   WinPostMsg(hwndClient,WM_DISPLAYMSG,MPFROMP(info_display),0);
}


MRESULT EXPENTRY UrlAddDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);

void recursive_dir_add_thread(/*char*/void *dir_add)
{
 HAB        haba;
 HMQ        hmq;
 HMTX       mutex = mutexDir;
 APIRET     rc;

 dirThreads++;

 while ((rc = DosRequestMutexSem(mutex, (ULONG)SEM_INDEFINITE_WAIT)) != 0)
  {
   DosSleep(500L);
  }

 haba = WinInitialize(0);
 hmq  = WinCreateMsgQueue(haba, 0);

 recursive_dir_add(dir_add);

 free(dir_add);

 DosSleep(250L);
 dirThreads--;
 if (dirThreads == 0)
  if (cfg.autouse == 1 || amp_playmode == AMP_PLAYLIST) {
   if (amp_playmode == AMP_SINGLE) StopWait();
   WinPostMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
  }

 WinDestroyMsgQueue(hmq);
 WinTerminate(haba);

 DosReleaseMutexSem(mutex);
}

void dir_add_thread(void *arg)
{
   HAB        haba;
   HMQ        hmq;
   char       foundfile[CCHMAXPATH];
   HDIR       hdir;
   FILEFINDBUF3 findbuf;
   HMTX       mutex = mutexDir;
   APIRET     rc;
   char *dir_add = arg;
   char *filespec = _alloca(strlen(dir_add) + 3);
   char *lastchar = strchr(filespec,0)-1;

   strcpy(filespec,dir_add);
   if(*lastchar != '\\' && *lastchar != '/')
      strcat(filespec,"\\*");
   else
      strcat(filespec,"*");

   dirThreads++;

   haba = WinInitialize(0);
   hmq  = WinCreateMsgQueue(haba, 0);

   while ((rc = DosRequestMutexSem(mutex, (ULONG)SEM_INDEFINITE_WAIT)) != 0)
   {
      DosSleep(500L);
   }

   if(findfirst(&hdir, filespec, FIND_FILE, &findbuf) != 0)
   {
      WinDestroyMsgQueue(hmq);
      WinTerminate(haba);
      return;
   }

   do
   {
      if(!(findbuf.attrFile & FILE_DIRECTORY))
      {
         char module_name[128];
         sprintf(foundfile, "%s\\%s", dir_add, findbuf.achName);
         if(dec_fileinfo(foundfile, &Info, module_name) == 0)
            pl_add_song(foundfile, (PMYMPREC)CMA_END, NULL);
      }
   }
   while(findnext(hdir, &findbuf) == 0);

   findclose(hdir);

   dirThreads--;
   DosSleep(250L);
   if (dirThreads == 0)
      if (cfg.autouse == 1 || amp_playmode == AMP_PLAYLIST) {
         if (amp_playmode == AMP_SINGLE)
            StopWait();
      WinPostMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
   }

   free(dir_add);

   WinDestroyMsgQueue(hmq);
   WinTerminate(haba);

   DosReleaseMutexSem(mutex);
}

/* Playlist thread listens for file add requests */
void playlist_thread(void *scrap)
{
   char    *pipebuf;
   int    sizebuf;
   ULONG  bytesread;
   ULONG  bytesnotread;
   AVAILDATA bytesavailable;
   ULONG pipestate;
   APIRET rc;
   HAB  haba;
   HMQ  hmq;
   char    dir_add[CCHMAXPATH], buf[CCHMAXPATH], *baf, *rig, *title;
   int  i;
   HMTX    mutex = mutexDir;

   ULONG     ulCbActual;
   AVAILDATA avail;
   ULONG     ulPipeState;


   haba = WinInitialize(0);
   hmq  = WinCreateMsgQueue(haba, 0);

   while (1 & 1)
   {
      DosConnectNPipe(plpiippu);

      pipebuf = 0;
      sizebuf = 0;
//     memset(pipebuf, 0, 32768);

      bytesread = 0;

      do
      {
         sizebuf += 32768;
         pipebuf = realloc(pipebuf,sizebuf);
         rc = DosRead(plpiippu, pipebuf+sizebuf-32768, 32768, &bytesread);
         rc = DosPeekNPipe(plpiippu, NULL, 0, &bytesnotread, &bytesavailable, &pipestate);
      } while(rc == 0 && bytesavailable.cbpipe > 0);

      DosDisConnectNPipe(plpiippu);

      if (bytesread > 0 && strcmp(pipebuf, "") != 0 && pipebuf[0] != '<' && pipebuf[0] != '>')
      {
         while ((rc = DosRequestMutexSem(mutex, (ULONG)SEM_INDEFINITE_WAIT)) != 0)
         {
            DosSleep(500L);
         }

         baf = rig = pipebuf;
         while (1)
         {
            title = NULL;
            while (*baf != 0 && *baf != ';')
            {
               // extract the position of the title
               if(*baf == '|' && title == NULL)
               {
                  *baf = 0;
                  title = &baf[1];
               }
               baf++;
            }

            if(*baf == 0)
            {
               if(*rig)
               {
                  percent_decode(rig);
                  percent_decode(title);
                  pl_add_song(rig, (PMYMPREC)CMA_END, title);
               }

               rig = ++baf;
               break;
            }

            *baf = '\0';
            if (*rig)
            {
               percent_decode(rig);
               percent_decode(title);
               pl_add_song(rig, (PMYMPREC)CMA_END, title);
            }
            rig = ++baf;
         }

         if (dirThreads == 0)
         {
            if (cfg.autouse == 1 || amp_playmode == AMP_PLAYLIST)
            {
               if (amp_playmode == AMP_SINGLE) StopWait();
               WinPostMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
            }

            if (initial_shuffle)
            {
               StopWait();
               playlist_index = 1;
               WinPostMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
               if(!shuffling)
                  WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_LIST), 0);
               initial_shuffle = 0;
            }
         }

         DosReleaseMutexSem(mutex);
      }

     DosPeekNPipe(plpiippu,&buf,0,&ulCbActual,&avail,&ulPipeState);
     while(ulPipeState == NP_STATE_CONNECTED) // wait for client to close pipe
     {
        DosSleep(50);
        DosPeekNPipe(plpiippu,&buf,0,&ulCbActual,&avail,&ulPipeState);
     }

     free(pipebuf);
   }

   WinDestroyMsgQueue(hmq);
   WinTerminate(haba);
}

void volnorm(void)
{
 int i = cfg.defaultvol;
 if (i > 100) i = 100;
 audioSetVolume(i);
}

void vollow(void)
{
 int i = cfg.defaultvol;
 if (i > 100) i = 100;
 audioSetVolume( (float) i*3/5 );
}

void amp_playcurrentf(void)
{
   DECODER_INFO info;
   if (currentf != NULL && strcmp(currentf->full, "") != 0)
   {
      strcpy(filename, currentf->full);
      strcpy(decoder_needed,currentf->decoder_module_name);
      out_params.formatinfo = currentf->format;
   }

   current_bitrate = currentf -> bitrate;
   current_channels = currentf -> channels;
   dec_fileinfo(filename, &info, NULL);
   current_length = (int)info.songlength/1000;
   current_freq = currentf->freq;
   current_track = currentf->track;
   strncpy(current_cd_drive, currentf->cd_drive, sizeof(current_cd_drive));
   strcpy(current_decoder_info_string,currentf->info_string);

   scroll = 0;
   scroll_index = 0; scrolled = 0;
   update_index = 1;
   update_now = 1;

// WinStartTimer(haba, hwndClient, TID_USERMAX - 1, 1);

   memset(&curtun,0,sizeof(curtun));
   if(currentf->songname != NULL)
      strncpy(curtun.title,currentf->songname,sizeof(curtun.title));
   amp_gettag(currentf -> full, &info, &curtun);

   do_display_msg(filename);
   strcpy(timeout_msg, display_msg);
}

void _amp_pl_next(int index, PMYMPREC pieru)
{
  int i;
  pieru = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
  for (i = 0; i < index; i++)
   {
     pieru = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(pieru), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
   }

}

ULONG calc_listlength(PMYMPREC current, int onlynonplayed)
{
  int i;
  PMYMPREC pieru = NULL;
  ULONG timme = 0;

  if (playlist_total == 0) return 0;

  if (current != NULL)
   pieru = current;
  else
   pieru = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));

  if (pieru != NULL)
   if ((onlynonplayed && pieru->played == 0) || !onlynonplayed) timme += pieru->secs;
   else return 0;

  do {
   pieru = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(pieru), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
   if (pieru != NULL) {
    if ((onlynonplayed && pieru->played == 0) || !onlynonplayed) timme += pieru->secs;
   }
  } while (pieru != NULL);

  return(timme);
}

typedef struct
{
   tune tun, orgtun;
} WPTAGDATA;

MRESULT EXPENTRY wpTagPage(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  int i;
  static int focused = 0;
  time_t T;
  struct tm *TM;
  static char *yeardata[200];
//  DECODER_INFO decinfo = {0};
//  layer lay;
  char buf[CCHMAXPATH];

  WPTAGDATA *d = WinQueryWindowPtr(hwnd, 0);

  switch (msg)
   {
   case WM_CHAR:
#if 0
     DosBeep(500, 10);
     if ((SHORT1FROMMP(mp1) & KC_VIRTUALKEY) && (SHORT1FROMMP(mp1) & KC_ALT))
      {
      DosBeep(500, 100);
      if (SHORT2FROMMP(mp2) == VK_F4)
       {
        DosBeep(500, 100);
        if (SHORT1FROMMP(mp1) & KC_KEYUP) WinDismissDlg(hwnd, 0);
        return((MRESULT)0);
       }
      }
#endif
      if (SHORT1FROMMP(mp1) & KC_KEYUP || SHORT2FROMMP(mp2) == VK_TAB)
         return WinDefDlgProc(hwnd, msg, mp1, mp2);
     break;
   case WM_PAINT:
     if (!focused) { WinFocusChange(HWND_DESKTOP, WinWindowFromID(hwnd, 103), 0); focused = 1; }
     return WinDefDlgProc(hwnd, msg, mp1, mp2);
     break;
   case WM_INITDLG:
     d = (WPTAGDATA *) malloc(sizeof(WPTAGDATA));
     WinSetWindowPtr(hwnd, 0, d);

     WinPostMsg(WinWindowFromID(hwnd, 101), LM_DELETEALL, 0, 0);
     for (i = 0; i < (GENRE_LARGEST + 1); i++)
      {
      WinPostMsg(WinWindowFromID(hwnd, 101), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(genres[i]));
     }

     T = time((time_t *) 0);
     TM = gmtime(&T);

     if (yeardata[0] == NULL)
      {
      for (i = 1; i <= TM -> tm_year; i++)
       {
        sprintf(buf, "%u", 1900 + i);
        yeardata[i] = strdup(buf);
       }
      }
     yeardata[0] = strdup("None");
     WinSendMsg(WinWindowFromID(hwnd, 112), SPBM_SETARRAY, MPFROMP(yeardata), MPFROMSHORT(TM -> tm_year + 1));
//    WinPostMsg(WinWindowFromID(hwnd, 112), SPBM_SETLIMITS, MPFROMSHORT(1900 + TM -> tm_year), MPFROMSHORT(1900));
//    WinPostMsg(WinWindowFromID(hwnd, 112), SPBM_SETCURRENTVALUE, MPFROMSHORT(1900 + TM -> tm_year), 0);

     WinPostMsg(WinWindowFromID(hwnd, 103), EM_SETTEXTLIMIT, MPFROMSHORT(30), 0);
     WinPostMsg(WinWindowFromID(hwnd, 104), EM_SETTEXTLIMIT, MPFROMSHORT(30), 0);
     WinPostMsg(WinWindowFromID(hwnd, 105), EM_SETTEXTLIMIT, MPFROMSHORT(30), 0);
     WinPostMsg(WinWindowFromID(hwnd, 109), EM_SETTEXTLIMIT, MPFROMSHORT(30), 0);
     memset(&d->tun, '\0', sizeof(tune));
     if (amp_gettag(tagedit->full, NULL, &d->tun))
      {
      /* Has tag information */

      WinSetDlgItemText(hwnd, 103, d->tun.title);
      WinSetDlgItemText(hwnd, 104, d->tun.artist);
      WinSetDlgItemText(hwnd, 105, d->tun.album);
      WinSetDlgItemText(hwnd, 109, d->tun.comment);

      WinPostMsg(WinWindowFromID(hwnd, 101), LM_SELECTITEM, MPFROMSHORT(d->tun.gennum), MPFROMSHORT(TRUE));

      if(atoi(d->tun.year) > 0)
         WinPostMsg(WinWindowFromID(hwnd, 112), SPBM_SETCURRENTVALUE, MPFROMLONG(atoi(d->tun.year)-1900), 0);
      }
     else
      d->tun.gennum = GENRE_LARGEST;
      memcpy(&d->orgtun, &d->tun, sizeof(tune));
     break;

   case WM_DESTROY:
     focused = 0;
     WinQueryDlgItemText(hwnd, 103, 30, d->tun.title);
     WinQueryDlgItemText(hwnd, 104, 30, d->tun.artist);
     WinQueryDlgItemText(hwnd, 105, 30, d->tun.album);
     WinQueryDlgItemText(hwnd, 109, 30, d->tun.comment);

     WinSendMsg(WinWindowFromID(hwnd, 112), SPBM_QUERYVALUE, MPFROMP(d->tun.year), MPFROM2SHORT(5, SPBQ_DONOTUPDATE));
     if (strcmp(d->tun.year, "None") == 0)
        strcpy(d->tun.year, "");

     d->tun.gennum = SHORT1FROMMR(WinSendMsg(WinWindowFromID(hwnd, 101), LM_QUERYSELECTION, MPFROMSHORT(LIT_CURSOR), 0));
     if (d->tun.gennum == 65535 || d->tun.gennum == -1) { d->tun.gennum = GENRE_LARGEST; }

     if(strcmp(d->tun.title,d->orgtun.title) != 0 ||
        strcmp(d->tun.artist,d->orgtun.artist) != 0 ||
        strcmp(d->tun.album,d->orgtun.album) != 0 ||
        strcmp(d->tun.comment,d->orgtun.comment) != 0 ||
        strcmp(d->tun.genre,d->orgtun.genre) != 0 ||
        strcmp(d->tun.year,d->orgtun.year) != 0 ||
        d->tun.gennum != d->orgtun.gennum)
        amp_puttag(tagedit -> full, &d->tun);

     if (o_tag_open == 1 && amp_gettag(tagedit -> full, NULL, &d->tun) != 0)
      {
        PMYMPREC removearray[1];

//        dec_fileinfo(tagedit -> full, &decinfo, NULL);
        strcpy(buf, "");
        if (strcmp(d->tun.artist, "") != 0 && strcmp(d->tun.title, "") != 0)
           sprintf(buf, "%s: %s", d->tun.artist, d->tun.title);
        if (strcmp(d->tun.artist, "") == 0 && strcmp(d->tun.title, "") != 0)
           sprintf(buf, "%s", d->tun.title);
        if (strcmp(d->tun.artist, "") != 0 && strcmp(d->tun.title, "") == 0)
           sprintf(buf, "%s", d->tun.artist);

        if (tagedit -> songname)
           free(tagedit -> songname);
        tagedit -> songname = strdup(buf);

        strcpy(buf, "");
        if (strcmp(d->tun.album, "") != 0)
         {
         strcat(buf, d->tun.album);
         strcat(buf, " ");
         }
        if (strcmp(d->tun.year, "") != 0)
         {
         strcat(buf, d->tun.year);
         strcat(buf, ", ");
         }
        if (strcmp(d->tun.genre, "") != 0)
         {
         strcat(buf, d->tun.genre);
         strcat(buf, ", ");
         }

        if(tagedit->info_string != NULL)
           strcat(buf, tagedit->info_string);

        tagedit->comment == NULL;
        if(strcmp(d->tun.comment, "") != 0)
        {
          strcat(buf, ", comment: ");
          tagedit->comment = (char *) (strchr(buf,0)-buf);
          strcat(buf, d->tun.comment);
        }

        free(tagedit->info);
        tagedit->info = strdup(buf);
        if(tagedit->comment != NULL)
           tagedit->comment = tagedit->info + (int)tagedit->comment;

        removearray[0] = tagedit;
        WinSendMsg(container, CM_INVALIDATERECORD, MPFROMP(&removearray), MPFROM2SHORT(1, 0));

        if(tagedit == currentf)
           amp_gettag(tagedit->full, NULL, &curtun);
      }

     free(d);

     if(o_tag_open == 2)
      {
      amp_gettag(single.full, NULL, &curtun);
      free(single.full); single.full = NULL;
      free(single.songname); single.songname = NULL;
      free(single.length); single.length = NULL;
      free(single.time); single.time = NULL;
      free(single.info); single.info = NULL;
      }
     o_tag_open = 0;

     do_display_msg(filename);
     break;

   case WM_COMMAND:
      switch (COMMANDMSG(&msg) -> cmd)
      {
         case DID_OK:
            free(d);
            WinSendMsg(hwnd, WM_INITDLG, 0, 0);
            break;
         default:
            break;
      }
      break;
   default:
      return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }
   return 0;
}

PFNWP wpNb;

MRESULT EXPENTRY wpNbNoQuit(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
      // otherwize, this is going to post a WM_QUIT
      case WM_CLOSE:
        hwndFile = 0;
        WinDestroyWindow(WinQueryWindow(hwnd,QW_PARENT));
        return 0;
   }
   return wpNb(hwnd,msg,mp1,mp2);
}

void create_id3edit(int tagmode)
{
   ULONG frameFlags = FCF_TITLEBAR | FCF_SYSMENU | FCF_MINBUTTON | FCF_MAXBUTTON |
                      FCF_SIZEBORDER  /*| FCF_MENU | FCF_ACCELTABLE | FCF_ICON | */
                      /* FCF_SHELLPOSITION */ | FCF_TASKLIST /*| FCF_DLGBORDER*/;

   FRAMECDATA fcdata;

   HWND filebook;

   POINTL size = {285, 160};
   SWP frameswp = {0};

   char title[512];

   o_tag_open = tagmode;

   if(hwndFile != 0)
   {
      WinSetFocus(HWND_DESKTOP, hwndFile);
      return;
   }

   WinMapDlgPoints(HWND_DESKTOP, &size, 1, TRUE);
   WinQueryWindowPos(hwndFrame,&frameswp);

   fcdata.cb            = sizeof(FRAMECDATA);
   fcdata.flCreateFlags = frameFlags;
   fcdata.hmodResources = (HMODULE) NULL;
   fcdata.idResources   = 1;

   strcpy(title, "ID3 Tag Editor - ");
   fnameext(strchr(title,0), tagedit->full);

   hwndFile = WinCreateWindow(
               HWND_DESKTOP,    /* Frame-window parent        */
               WC_FRAME,        /* Frame-window class         */
               title,           /* Window title               */
               0,               /* Initially invisible        */
               0,0,0,0,         /* Size and position = 0      */
               0L,              /* No owner                   */
               HWND_TOP,        /* Top z-order position       */
               0,               /* Frame-window ID            */
               &fcdata,         /* Pointer to class data      */
               NULL);           /* No presentation parameters */

   filebook = WinCreateWindow(hwndFile, WC_NOTEBOOK, NULL,
           BKS_BACKPAGESTR | BKS_MAJORTABTOP |
           BKS_ROUNDEDTABS | BKS_STATUSTEXTCENTER |
           BKS_SPIRALBIND | BKS_TABTEXTLEFT |
           WS_GROUP | 0x800 | WS_VISIBLE,
           0, 0, 100, 100, hwndFile, HWND_BOTTOM, FID_CLIENT,
           NULL, NULL);

   wpNb = WinSubclassWindow(filebook,wpNbNoQuit);

   WinSendMsg(filebook, BKM_SETNOTEBOOKCOLORS, MPFROMLONG(SYSCLR_FIELDBACKGROUND), MPFROMSHORT(BKA_BACKGROUNDPAGECOLORINDEX));

   WinSetPresParam(filebook, PP_FONTNAMESIZE, strlen("10.Helv") + 1, "10.Helv");

   WinSendMsg(filebook, BKM_SETDIMENSIONS, MPFROM2SHORT(80, 30), MPFROMSHORT(BKA_MAJORTAB));

   fpage1 = WinLoadDlg(filebook, filebook, wpTagPage, NULLHANDLE, TAGWIN, NULL);

   fpageid = (ULONG) WinSendMsg(filebook, BKM_INSERTPAGE, MPFROMLONG(0),
             MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_MAJOR,
                BKA_FIRST));

   WinSendMsg(filebook, BKM_SETPAGEWINDOWHWND, MPFROMLONG(fpageid), MPFROMLONG(fpage1));
   fnameext(buf, tagedit->full);
   WinSendMsg(filebook, BKM_SETTABTEXT, MPFROMLONG(fpageid), MPFROMP(buf));

   WinSendMsg(filebook, BKM_TURNTOPAGE, MPFROMLONG(fpage1), 0);

   WinSetWindowPos(hwndFile, HWND_TOP, frameswp.x+20, frameswp.y+20, size.x, size.y, SWP_SIZE | SWP_SHOW | SWP_MOVE);
}



void amp_setradio(HWND hwnd, USHORT id, BOOL enable)
{
   WinSendDlgItemMsg(hwnd, id, BM_SETCHECK, MPFROMSHORT(enable), 0);
}

int amp_getradio(HWND hwnd, USHORT id)
{
 ULONG i;
 i = (ULONG)WinSendDlgItemMsg(hwnd, id, BM_QUERYCHECK, 0, 0);
 if (i == 0) return(FALSE); else return(TRUE);
}



BOOL show_add_plugin_dialog(HWND hwnd)
{
  FILEDLG filedialog;
  HWND hwndFDlg;
  char filez[CCHMAXPATH];

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_OPEN_DIALOG;
  filedialog.pszTitle = "Load a plugin";
  drivedir(filedialog.szFullFile,startpath);
  strcat(filedialog.szFullFile, "*.dll");

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  if (filedialog.lReturn == DID_OK)
     return add_plugin(filedialog.szFullFile);

  return FALSE;
}


// settings
MRESULT EXPENTRY wpConfigPage1(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   ULONG i;

   switch(msg)
   {
      case WM_INITDLG:
      {
         char buffer[128];

         amp_setradio(hwnd, CB_PLAYONLOAD, cfg.playonload);
         amp_setradio(hwnd, CB_AUTOUSEPL, cfg.autouse);
         amp_setradio(hwnd, CB_AUTOPLAYPL, cfg.playonuse);
         amp_setradio(hwnd, CB_TRASHONSEEK, cfg.trash);

         amp_setradio(hwnd, CB_DOCK, cfg.dock_windows);
         WinSendMsg(WinWindowFromID(hwnd, EF_DOCK), EM_SETTEXTLIMIT, MPFROMSHORT(2), 0);
         sprintf(buffer,"%d",cfg.dock_margin);
         WinSetDlgItemText(hwnd, EF_DOCK, buffer);

         amp_setradio(hwnd, RB_SCROLL_INFINITE+cfg.scroll*10, TRUE); /* scroll */

         amp_setradio(hwnd, RB_DISPLAY_FILENAME + cfg.viewmode*10, TRUE);


         WinSendMsg(WinWindowFromID(hwnd, EF_PROXY_URL), EM_SETTEXTLIMIT, MPFROMSHORT(1024), 0);
         WinSendMsg(WinWindowFromID(hwnd, EF_HTTP_AUTH), EM_SETTEXTLIMIT, MPFROMSHORT(256), 0);
         WinSetDlgItemText(hwnd, EF_PROXY_URL, cfg.proxy);
         WinSetDlgItemText(hwnd, EF_HTTP_AUTH, cfg.auth);

         amp_setradio(hwnd, CB_FILLBUFFER, cfg.bufwait);

         WinSendMsg(WinWindowFromID(hwnd, SB_BUFFERSIZE),
             SPBM_SETLIMITS,
             MPFROMLONG(2048),
             MPFROMLONG(0));

         WinSendMsg(WinWindowFromID(hwnd, SB_BUFFERSIZE),
             SPBM_SETCURRENTVALUE,
             MPFROMLONG(cfg.bufsize),
             0);

         return 0;
     }

     case WM_COMMAND:
     case WM_CONTROL:

         return 0;

     case WM_DESTROY:
     {
         char buffer[8];

         cfg.playonload = amp_getradio(hwnd, CB_PLAYONLOAD);
         cfg.autouse = amp_getradio(hwnd, CB_AUTOUSEPL);
         cfg.playonuse = amp_getradio(hwnd, CB_AUTOPLAYPL);
         cfg.trash = amp_getradio(hwnd, CB_TRASHONSEEK);

         cfg.dock_windows = amp_getradio(hwnd, CB_DOCK);
         WinQueryDlgItemText(hwnd, EF_DOCK, 8, buffer);
         cfg.dock_margin = atoi(buffer);

         if (amp_getradio(hwnd, RB_SCROLL_INFINITE)) cfg.scroll = 0;
         else if (amp_getradio(hwnd, RB_SCROLL_ONCE)) { cfg.scroll = 1; scroll_index = 0; scrolled = 0; }
         else if (amp_getradio(hwnd, RB_SCROLL_DISABLE)) { cfg.scroll = 2; scroll_index = 0; scrolled = 0; }

         if (amp_getradio(hwnd, RB_DISPLAY_FILENAME)) cfg.viewmode = 0;
         else if (amp_getradio(hwnd, RB_DISPLAY_ID3TAG)) cfg.viewmode = 1;
         else if (amp_getradio(hwnd, RB_DISPLAY_FILEINFO)) cfg.viewmode = 2;

         WinSendMsg(WinWindowFromID(hwnd, SB_BUFFERSIZE),
                 SPBM_QUERYVALUE,
                 MPFROMP(&i),
                 MPFROM2SHORT(0, SPBQ_DONOTUPDATE));
         cfg.bufsize = (int)i;

         WinQueryDlgItemText(hwnd, EF_PROXY_URL, 1024, cfg.proxy);
         WinQueryDlgItemText(hwnd, EF_HTTP_AUTH, 256,  cfg.auth);

         cfg.bufwait = amp_getradio(hwnd, CB_FILLBUFFER );

         return 0;
      }
   }
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

//plug-ins 1
MRESULT EXPENTRY wpConfigPage2(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   char buf1[256], buf2[256];
   int i;

   switch(msg)
   {
      case WM_INITDLG:

         (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG),
                     LM_DELETEALL,
                     0,
                     0);

         (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG),
                     LM_DELETEALL,
                     0,
                     0);

         for (i = 0; i < 32; i++)
         {
            if (strcmp(plugins[i].filename, "") != 0)
            {
               sprintf(buf1, "%s%s", sfname(plugins[i].filename), sext(plugins[i].filename));
               WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
            }
         }

         for (i = 0; i < num_decoders; i++)
         {
            fnameext(buf1, decoders[i].module_name);
            WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
         }

         return 0;

      case WM_CONTROL:
         switch(SHORT2FROMMP(mp1))
         {
            case LN_SELECT:
               if (SHORT1FROMMP(mp1) == LB_VISPLUG)
               {
                  i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG),
                                 LM_QUERYSELECTION,
                                 MPFROMSHORT(LIT_CURSOR),
                                 0);

                  sprintf(buf1, "Author: %s", plugins[i].author);
                  WinSetDlgItemText(hwnd, ST_VIS_AUTHOR, buf1);

                  sprintf(buf1, "Desc: %s", plugins[i].desc);
                  WinSetDlgItemText(hwnd, ST_VIS_DESC, buf1);

                  if (plugins[i].loaded)
                     WinSetDlgItemText(hwnd, PB_VIS_ENABLE, "Disabl~e");
                  else
                     WinSetDlgItemText(hwnd, PB_VIS_ENABLE, "~Enable");

                  if (plugins[i].configurable == 1)
                     WinEnableControl(hwnd, PB_VIS_CONFIG, TRUE);
                  else
                     WinEnableControl(hwnd, PB_VIS_CONFIG, FALSE);
               }
               else if (SHORT1FROMMP(mp1) == LB_DECPLUG)
               {
                  i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG),
                                 LM_QUERYSELECTION,
                                 MPFROMSHORT(LIT_CURSOR),
                                 0);

                  sprintf(buf1, "Author: %s", decoders[i].query_param.author);
                  WinSetDlgItemText(hwnd, ST_DEC_AUTHOR, buf1);

                  sprintf(buf1, "Desc: %s", decoders[i].query_param.desc);
                  WinSetDlgItemText(hwnd, ST_DEC_DESC, buf1);

                  if (decoders[i].enabled)
                     WinSetDlgItemText(hwnd, PB_DEC_ENABLE, "Disabl~e");
                  else
                     WinSetDlgItemText(hwnd, PB_DEC_ENABLE, "~Enable");

                  if (decoders[i].query_param.configurable)
                     WinEnableControl(hwnd, PB_DEC_CONFIG, TRUE);
                  else
                     WinEnableControl(hwnd, PB_DEC_CONFIG, FALSE);
               }
               break;
         }

         return 0;

   case WM_COMMAND:
      switch (COMMANDMSG(&msg) -> cmd)
      {
         case PB_VIS_ADD:
            amp_load_visual_plugin(hwnd);
            //WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Visual plug-ins can only be loaded from a skin.", "Doh.", 0, MB_INFORMATION | MB_OK);
            //break;

            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG),
                        LM_DELETEALL,
                        0,
                        0);

            for (i = 0; i < 32; i++)
            {
               if (strcmp(plugins[i].filename, "") != 0)
               {
                  sprintf(buf1, "%s%s", sfname(plugins[i].filename), sext(plugins[i].filename));
                  WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
               }
            }
            break;

         case PB_VIS_CONFIG:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            cfg_plugin(hwnd, i);
            break;

         case PB_VIS_ENABLE:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            if (plugins[i].loaded == 0)
               init_plugin(hwndClient, i);
            else
            {
               if ((plugins[i].type & PLUGIN_FILTER) && decoder_playing())
                  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Unloading filter plugins while playing is not allowed.", "Doh.", 0, MB_INFORMATION | MB_OK);
               else
                  deinit_plugin(hwndClient, i);
            }

            if (plugins[i].loaded)
               WinSetDlgItemText(hwnd, PB_VIS_ENABLE, "Disabl~e");
            else
               WinSetDlgItemText(hwnd, PB_VIS_ENABLE, "Enabl~e");
            break;

         case PB_VIS_UNLOAD:
           if (!decoder_playing())
           {
              i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG),
                         LM_QUERYSELECTION,
                         MPFROMSHORT(LIT_CURSOR),
                         0);
              if (i == LIT_NONE) return 0;

              free_plugin(i);
              i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_VISPLUG),
                         LM_DELETEITEM,
                         MPFROMSHORT(i),
                         0);
           }
           else
           {
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Unloading filter plugins while playing is not allowed.", "Doh.", 0, MB_INFORMATION | MB_OK);
           }
           break;

         case PB_DEC_ADD:
            show_add_plugin_dialog(hwnd);

            (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG),
                        LM_DELETEALL,
                        0,
                        0);

            for (i = 0; i < num_decoders; i++)
            {
               fnameext(buf1, decoders[i].module_name);
               WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
            }

            break;

         case PB_DEC_CONFIG:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            decoders[i].plugin_configure(hwnd, decoders[i].module);
            break;

         case PB_DEC_ENABLE:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            if (!decoders[i].enabled)
            {
               decoders[i].enabled = TRUE;
            }
            else
            {
               if (active_decoder == i)
               {
                  if(decoder_playing())
                     WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: Cannot disable currently in use decoder.", "Doh.", 0, MB_INFORMATION | MB_OK);
                  else
                  {
                     decoders[i].enabled = FALSE;
                     dec_set_name_active(NULL);
                  }
               }
               else
               {
                  decoders[i].enabled = FALSE;
                  dec_set_name_active(NULL);
               }
            }

            if (decoders[i].enabled)
               WinSetDlgItemText(hwnd, PB_DEC_ENABLE, "Disabl~e");
            else
               WinSetDlgItemText(hwnd, PB_DEC_ENABLE, "Enabl~e");
            break;

         case PB_DEC_UNLOAD:

           i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG),
                      LM_QUERYSELECTION,
                      MPFROMSHORT(LIT_CURSOR),
                      0);
           if (i == LIT_NONE) return 0;

           if (decoder_playing() && active_decoder == i)
           {
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: Cannot unload currently used decoder.", "Doh.", 0, MB_INFORMATION | MB_OK);
           }
           else
           {
              remove_decoder_plugin(&decoders[i]);

              i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_DECPLUG),
                         LM_DELETEITEM,
                         MPFROMSHORT(i),
                         0);
           }
           break;

      }
      return 0;


   }

   return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

//plug-ins 2
MRESULT EXPENTRY wpConfigPage3(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   char buf1[256], buf2[256];
   int i;

   switch(msg)
   {
      case WM_INITDLG:

         (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG),
                     LM_DELETEALL,
                     0,
                     0);

         (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG),
                     LM_DELETEALL,
                     0,
                     0);

         for (i = 0; i < num_outputs; i++)
         {
            fnameext(buf1, outputs[i].module_name);
            WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
         }

         for (i = 0; i < num_filters; i++)
         {
            fnameext(buf1, filters[i].module_name);
            WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
         }

         return 0;

      case WM_CONTROL:
         switch(SHORT2FROMMP(mp1))
         {
            case LN_SELECT:

               if (SHORT1FROMMP(mp1) == LB_OUTPLUG)
               {
                  i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG),
                                 LM_QUERYSELECTION,
                                 MPFROMSHORT(LIT_CURSOR),
                                 0);

                  sprintf(buf1, "Author: %s", outputs[i].query_param.author);
                  WinSetDlgItemText(hwnd, ST_OUT_AUTHOR, buf1);

                  sprintf(buf1, "Desc: %s", outputs[i].query_param.desc);
                  WinSetDlgItemText(hwnd, ST_OUT_DESC, buf1);

                  if (outputs[i].query_param.configurable)
                     WinEnableControl(hwnd, PB_OUT_CONFIG, TRUE);
                  else
                     WinEnableControl(hwnd, PB_OUT_CONFIG, FALSE);

                  if(active_output == i)
                     WinEnableControl(hwnd, PB_OUT_ACTIVATE, FALSE);
                  else
                     WinEnableControl(hwnd, PB_OUT_ACTIVATE, TRUE);
               }
               else if (SHORT1FROMMP(mp1) == LB_FILPLUG)
               {
                  i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG),
                                 LM_QUERYSELECTION,
                                 MPFROMSHORT(LIT_CURSOR),
                                 0);

                  sprintf(buf1, "Author: %s", filters[i].query_param.author);
                  WinSetDlgItemText(hwnd, ST_FIL_AUTHOR, buf1);

                  sprintf(buf1, "Desc: %s", filters[i].query_param.desc);
                  WinSetDlgItemText(hwnd, ST_FIL_DESC, buf1);

                  if (filters[i].enabled)
                     WinSetDlgItemText(hwnd, PB_FIL_ENABLE, "Disabl~e");
                  else
                     WinSetDlgItemText(hwnd, PB_FIL_ENABLE, "~Enable");

                  if (filters[i].query_param.configurable)
                     WinEnableControl(hwnd, PB_FIL_CONFIG, TRUE);
                  else
                     WinEnableControl(hwnd, PB_FIL_CONFIG, FALSE);
               }
               break;
         }

         return 0;

   case WM_COMMAND:
      switch (COMMANDMSG(&msg) -> cmd)
      {

         case PB_OUT_ADD:
            show_add_plugin_dialog(hwnd);

            (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG),
                        LM_DELETEALL,
                        0,
                        0);

            for (i = 0; i < num_outputs; i++)
            {
               fnameext(buf1, outputs[i].module_name);
               WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
            }

            break;

         case PB_OUT_CONFIG:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            outputs[i].plugin_configure(hwnd, outputs[i].module);
            break;

         case PB_OUT_ACTIVATE:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            if(decoder_playing())
               WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: Cannot change active output while playing.", "Doh.", 0, MB_INFORMATION | MB_OK);
            else
            {
               out_set_active(i);
               WinEnableControl(hwnd, PB_OUT_ACTIVATE, FALSE);
            }

            break;

         case PB_OUT_UNLOAD:

           i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG),
                      LM_QUERYSELECTION,
                      MPFROMSHORT(LIT_CURSOR),
                      0);
           if (i == LIT_NONE) return 0;

           if (decoder_playing() && active_output == i)
           {
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: Cannot unload currently used output.", "Doh.", 0, MB_INFORMATION | MB_OK);
           }
           else
           {
              remove_output_plugin(&outputs[i]);

              i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_OUTPLUG),
                         LM_DELETEITEM,
                         MPFROMSHORT(i),
                         0);
           }
           break;

         case PB_FIL_ADD:
         {
            BOOL loaded_something = show_add_plugin_dialog(hwnd);

            (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG),
                        LM_DELETEALL,
                        0,
                        0);

            for (i = 0; i < num_filters; i++)
            {
               fnameext(buf1, filters[i].module_name);
               WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG), LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(buf1));
            }

            if(decoder_playing() && loaded_something)
               WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: This filter will only be enabled after playback of the current file.", "Doh.", 0, MB_INFORMATION | MB_OK);

            break;
         }

         case PB_FIL_CONFIG:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            filters[i].plugin_configure(hwnd, filters[i].module);
            break;

         case PB_FIL_ENABLE:
            i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG),
                        LM_QUERYSELECTION,
                        MPFROMSHORT(LIT_CURSOR),
                        0);
            if (i == LIT_NONE) return 0;

            if (!filters[i].enabled)
            {
               filters[i].enabled = TRUE;
               if(decoder_playing())
                  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: This filter will only be enabled after playback of the current file.", "Doh.", 0, MB_INFORMATION | MB_OK);
            }
            else
            {
               filters[i].enabled = FALSE;
               if(decoder_playing())
                  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: This filter will only be disabled after playback of the current file.", "Doh.", 0, MB_INFORMATION | MB_OK);
            }

            if (filters[i].enabled)
               WinSetDlgItemText(hwnd, PB_FIL_ENABLE, "Disabl~e");
            else
               WinSetDlgItemText(hwnd, PB_FIL_ENABLE, "Enabl~e");
            break;

         case PB_FIL_UNLOAD:

           i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG),
                      LM_QUERYSELECTION,
                      MPFROMSHORT(LIT_CURSOR),
                      0);
           if (i == LIT_NONE) return 0;

           if (decoder_playing())
           {
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Information: Cannot unload currently used filter.", "Doh.", 0, MB_INFORMATION | MB_OK);
           }
           else
           {
              remove_filter_plugin(&filters[i]);

              i = (ULONG)WinSendMsg(WinWindowFromID(hwnd, LB_FILPLUG),
                         LM_DELETEITEM,
                         MPFROMSHORT(i),
                         0);
           }
           break;

      }
      return 0;


   }

   return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

// about
MRESULT EXPENTRY wpConfigPage4(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch (msg)
   {
      case WM_CHAR:
         if ((!(SHORT1FROMMP(mp1) & KC_KEYUP)) && (SHORT1FROMMP(mp1) & KC_VIRTUALKEY))
         {
            switch (SHORT2FROMMP(mp2))
            {
               case VK_ESC:
                  return (MRESULT)TRUE;
               break;
            }
            return (MRESULT)TRUE;
        }
        break;

      case WM_INITDLG:
         if (check_warpsans())
            WinSetPresParam(WinWindowFromID(hwnd, 111), PP_FONTNAMESIZE, strlen("9.WarpSans") + 1, "9.WarpSans");
         else
            WinSetPresParam(WinWindowFromID(hwnd, 111), PP_FONTNAMESIZE, strlen("8.Helv") + 1, "8.Helv");

         WinSetDlgItemText(hwnd, 111, SDG_MSG);

         return 0;
   }

   return WinDefDlgProc(hwnd, msg, mp1, mp2);
}


void defaultcfg(void) {

 /* Default to DART */
// cfg.soundsystem = 0;
 /* Default to stereo playing (no mixing) */
// cfg.mono = 0;
 /* Don't play file automatically on load */
 cfg.playonload = 0;
 /* Don't auto use playlist on load */
 cfg.autouse = 0;

 /* No 8-bit audio as default - 8 bit audio sucks! */
// cfg.eightbit = 0;
 /* Downmixing sucks! */
// cfg.downmix = 0;

// cfg.deviceno = 0; cfg.shared = 1;

// cfg.buffers = 32;
 cfg.trash = 1;

 /* Low priority by default */
 cfg.priority = 0;

 cfg.playonuse = 0; cfg.scroll = 0;
 cfg.bufsize      = 0;  /* 64kB rocks you */
 cfg.bufwait     = 1;   /* It's ok to fill the buffer first */
 strcpy(cfg.proxy, ""); /* No proxy */
 strcpy(cfg.auth, "");  /* No authentication */
 cfg.viewmode    = 0;   /* Filename owns you */

}

MRESULT EXPENTRY wpNbControlClose(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg)
   {
      // otherwize, this is going to post a WM_QUIT
      case WM_CLOSE:
        WinDestroyWindow(WinQueryWindow(hwnd,QW_PARENT));
        save_ini(); // <-
        return 0;
   }
   return wpNb(hwnd,msg,mp1,mp2);
}


//#define NOTEBOOK_ID 2001
#define NOTEBOOK_ID FID_CLIENT
MRESULT EXPENTRY wpNotebook(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   SWP swp, swp2;
   int ty, py, sy, z;
   MRESULT mrc;

   hwndCfg = hwnd;
   switch (msg)
   {
      case WM_COMMAND:
         switch (COMMANDMSG(&msg) -> cmd)
         {
            case 101:
               cfg = oldcfg;
               WinSendMsg(page1, WM_INITDLG, 0, 0);
               WinSendMsg(page2, WM_INITDLG, 0, 0);
               WinSendMsg(page3, WM_INITDLG, 0, 0);
               WinSendMsg(page4, WM_INITDLG, 0, 0);
               break;
            case 102:
               defaultcfg();
               WinSendMsg(page1, WM_INITDLG, 0, 0);
               WinSendMsg(page2, WM_INITDLG, 0, 0);
               WinSendMsg(page3, WM_INITDLG, 0, 0);
               WinSendMsg(page4, WM_INITDLG, 0, 0);
               break;
            case 103:
               WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Help system is not implemented. Refer to PM123 User's Guide.", "Information", 0, MB_INFORMATION | MB_OK);
               break;
            default: break;
         }
         break;

      case WM_DESTROY:
         cfg_hwnd = 0;
         break;

      case WM_INITDLG:
      {
         POINTL size = {279, 190};
         SWP frameswp = {0};

         WinMapDlgPoints(HWND_DESKTOP, &size, 1, TRUE);
         WinQueryWindowPos(hwndFrame,&frameswp);

         oldcfg = cfg;
         cfg_hwnd = hwnd;

         do_warpsans(hwnd);

         notebook = WinCreateWindow(hwnd, WC_NOTEBOOK, NULL, BKS_TABBEDDIALOG |
                      BKS_BACKPAGESTR | BKS_MAJORTABTOP |
                      BKS_ROUNDEDTABS | BKS_STATUSTEXTCENTER |
                      BKS_SPIRALBIND | BKS_TABTEXTLEFT |
                      WS_GROUP | WS_TABSTOP | WS_VISIBLE |
                      BKS_BUTTONAREA | BKS_TABBEDDIALOG,
                      0, 0, 0, 0, hwnd, HWND_TOP, NOTEBOOK_ID,
                      NULL, NULL);

         wpNb = WinSubclassWindow(notebook,wpNbControlClose);

         /* change colors for old style notebook not to look ugly */
         WinSendMsg(notebook, BKM_SETNOTEBOOKCOLORS, MPFROMLONG(SYSCLR_FIELDBACKGROUND),
                         MPFROMSHORT(BKA_BACKGROUNDPAGECOLORINDEX));

         /* change tab width for old style notebook to something OK for most font size */
         WinSendMsg(notebook, BKM_SETDIMENSIONS, MPFROM2SHORT(80,25),
                         MPFROMSHORT(BKA_MAJORTAB));

         /* no minor */
         WinSendMsg(notebook, BKM_SETDIMENSIONS, 0, MPFROMSHORT(BKA_MINORTAB));

         do_warpsans(notebook);


    // -- loading pages

         // settings
         page1 = WinLoadDlg(hwnd, hwnd, wpConfigPage1, NULLHANDLE, CONFIG_PAGE1, NULL);
         do_warpsans(page1);

         pageid = (ULONG) WinSendMsg(notebook, BKM_INSERTPAGE, MPFROMLONG(0),
                  MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_MAJOR | BKA_STATUSTEXTON,
                         BKA_FIRST));

         WinSendMsg(notebook, BKM_SETPAGEWINDOWHWND, MPFROMLONG(pageid), MPFROMLONG(page1));
         WinSendMsg(notebook, BKM_SETTABTEXT, MPFROMLONG(pageid), MPFROMP("~Settings"));
    //     WinSendMsg(notebook, BKM_SETSTATUSLINETEXT, MPFROMLONG(pageid), MPFROMP("Settings"));

         // plugins 1 of 2
         page2 = WinLoadDlg(hwnd, hwnd, wpConfigPage2, NULLHANDLE, CONFIG_PAGE2, NULL);
         do_warpsans(page2);

         pageid2 = (ULONG) WinSendMsg(notebook, BKM_INSERTPAGE, MPFROMLONG(0),
                               MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_MAJOR | BKA_MINOR | BKA_STATUSTEXTON, BKA_LAST));


         WinSendMsg(notebook, BKM_SETPAGEWINDOWHWND, MPFROMLONG(pageid2), MPFROMLONG(page2));
         WinSendMsg(notebook, BKM_SETTABTEXT, MPFROMLONG(pageid2), MPFROMP("~Plug-Ins"));
         WinSendMsg(notebook, BKM_SETSTATUSLINETEXT, MPFROMLONG(pageid2), MPFROMP("Page 1 of 2"));


         // plugins 2 of 2
         page3 = WinLoadDlg(hwnd, hwnd, wpConfigPage3, NULLHANDLE, CONFIG_PAGE3, NULL);
         do_warpsans(page3);

         pageid3 = (ULONG) WinSendMsg(notebook, BKM_INSERTPAGE, MPFROMLONG(pageid2),
                  MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_MINOR | BKA_STATUSTEXTON,
                         BKA_NEXT));

         WinSendMsg(notebook, BKM_SETPAGEWINDOWHWND, MPFROMLONG(pageid3), MPFROMLONG(page3));
         WinSendMsg(notebook, BKM_SETTABTEXT, MPFROMLONG(pageid3), MPFROMP("~Plug-Ins"));
         WinSendMsg(notebook, BKM_SETSTATUSLINETEXT, MPFROMLONG(pageid3), MPFROMP("Page 2 of 2"));

         // about dialog
         page4 = WinLoadDlg(hwnd, hwnd, wpConfigPage4, NULLHANDLE, ABOUTNB, NULL);
         do_warpsans(page4);

         pageid4 = (ULONG) WinSendMsg(notebook, BKM_INSERTPAGE, MPFROMLONG(0),
                   MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_MAJOR,
                      BKA_LAST));

         WinSendMsg(notebook, BKM_SETPAGEWINDOWHWND, MPFROMLONG(pageid4), MPFROMLONG(page4));
         WinSendMsg(notebook, BKM_SETTABTEXT, MPFROMLONG(pageid4), MPFROMP("~About"));

         WinSetParent(WinWindowFromID(hwnd,101),notebook,TRUE);
         WinSetParent(WinWindowFromID(hwnd,102),notebook,TRUE);
         WinSetParent(WinWindowFromID(hwnd,103),notebook,TRUE);

         WinSendMsg(notebook, BKM_TURNTOPAGE, MPFROMLONG(page1), 0);
         WinFocusChange(HWND_DESKTOP, page1, 0);
         WinSetWindowPos(hwnd, HWND_TOP, cfg.Properties.x,cfg.Properties.y,
                         size.x, size.y,
                         SWP_SIZE | SWP_SHOW | SWP_MOVE);
         break;
      }

      case WM_WINDOWPOSCHANGED:
      {
         SWP *swp = PVOIDFROMMP(mp1);

         if( ((swp->fl & SWP_SIZE) || (swp->fl & SWP_MOVE)) && WinIsWindowVisible(hwnd) )
            cfg.Properties = *swp;
         break;
      }

   }
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

void create_properties(void)
{
   if (cfg_hwnd == 0)
      WinDlgBox(HWND_DESKTOP, HWND_DESKTOP, wpNotebook, NULLHANDLE, NOTEDLG, NULL);
   else
      WinSetFocus(HWND_DESKTOP,cfg_hwnd);
}


void amp_notoper(void)
{
  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "This function is not implemented, sorry.", ":-(", 0, MB_INFORMATION | MB_OK);
}

void amp_writestring (HPS hps, HWND hwnd, int x, int y, int fg, int bg, char *font, char *text)
{
  POINTL ptl;

  WinSetPresParam (hwnd, PP_FONTNAMESIZE, strlen (font) + 1, font);
  GpiSetColor (hps, fg);
  GpiSetBackColor (hps, bg);
  ptl.x = x;
  ptl.y = y;
  GpiMove (hps, &ptl);
  GpiCharString (hps, strlen (text), text);
}


void amp_writestringpim(HPS hps, HWND hwnd, int x, int y, int cx, int cy, int fg, int bg, char *font, char *text)
{
  RECTL rcl;

  WinSetPresParam(hwnd, PP_FONTNAMESIZE, strlen(font) + 1, font);
  rcl.xLeft   = x - cx;
  rcl.xRight  = x;
  rcl.yTop    = y + cy;
  rcl.yBottom = y;
  WinDrawText(hps, strlen(text), text, &rcl, fg, bg, DT_RIGHT | DT_BOTTOM);
}



void pipe_thread(void *scrap)
{
  char         pipebuf[512], command[512], *zork, *dork, buf[512];
  ULONG     bytesread;
  APIRET    rc;
  HAB       haba;
  HMQ       hmq;
  HPS       hps;
  float     z;
  int       i;
  ULONG     ulCbActual;
  AVAILDATA avail;
  ULONG     ulPipeState;

  haba = WinInitialize(0);
  hmq = WinCreateMsgQueue(haba, 0);

  while (1 & 1)
   {
     DosDisConnectNPipe(piippu);
     DosConnectNPipe(piippu);

     memset(pipebuf, '\0', 512);

     rc = DosRead(piippu,
         pipebuf,
         512,
         &bytesread);

     blank_strip(pipebuf);

     if (bytesread > 0 && strcmp(pipebuf, "") != 0 && pipebuf[0] != '*')
        WinSendMsg(hwndClient, WM_LOADFILE, MPFROMP(strdup(pipebuf)), 0);
     else
     {
        if (bytesread > 0 && pipebuf[0] == '*') /* Your wish is my command */
        {
         strcpy(command, &pipebuf[1]); /* Strip the '*' character */
         blank_strip(command);
         zork = strtok(command, " "); /* Tokenize the string */
         if(zork == NULL)
            goto end;

         if (stricmp(zork, "status") == 0)
         {
          dork = strtok(NULL, " ");
          if(dork == NULL)
             goto end;

          if (dork != NULL && stricmp(dork, "file") == 0)
           {
            if(amp_playmode == AMP_NOFILE)
               pipe_write(piippu, "");
            else
               pipe_write(piippu, filename);
           }
          if (stricmp(dork, "tag") == 0)
           {
            if(amp_playmode == AMP_NOFILE)
               pipe_write(piippu, "");
            else
               pipe_write(piippu, construct_tag_info_string(&curtun));
           }
          if (stricmp(dork, "info") == 0)
           {
            if(amp_playmode == AMP_NOFILE)
               pipe_write(piippu, "");
            else
               pipe_write(piippu, current_decoder_info_string);
           }
         }
         if (stricmp(zork, "size") == 0)
         {
          dork = strtok(NULL, " ");
          if (stricmp(dork, "regular") == 0 || stricmp(dork, "0") == 0 || stricmp(dork, "normal") == 0)
           WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_NORMAL), 0);
          if (stricmp(dork, "small") == 0 || stricmp(dork, "1") == 0)
           WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_SMALL), 0);
          if (stricmp(dork, "tiny") == 0 || stricmp(dork, "2") == 0)
           WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_TINY), 0);
         }
         if (stricmp(zork, "rdir") == 0) /* Recursive dir add */
         {
             dork = (char *)(zork + strlen(zork));
          if (dork != NULL)
           {
               dork++;
               _beginthread(recursive_dir_add_thread, NULL, 1024*1024, strdup(dork));
              }
         }
         if (stricmp(zork, "dir") == 0) /* Non-recursive dir add */
         {
             dork = (char *)(zork + strlen(zork));
          if (dork != NULL)
           {
               dork++;
               _beginthread(dir_add_thread, NULL, 1024*1024, strdup(dork));
              }
         }
         if (stricmp(zork, "font") == 0) /* Font */
         {
          dork = strtok(NULL, " ");
          if (stricmp(dork, "1") == 0)
           WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_FONT1), 0);
          if (stricmp(dork, "2") == 0)
           WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_FONT2), 0);
         }
         if (stricmp(zork, "add") == 0) /* Add to playlist */
         {
             dork = (char *)(zork + strlen(zork));
             if (dork != NULL)
             {
                dork++;
                percent_encode(dork,sizeof(pipebuf)-(pipebuf-dork),";|");
                playlist_post_file(dork);
             }
         }
         if (stricmp(zork, "load") == 0) /* Load a single file */
         {
             dork = (char *)(zork + strlen(zork));
             if (dork != NULL)
             {
                dork++;
                WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_STOP), 0);
                WinSendMsg(hwndClient, WM_LOADFILE, MPFROMP(strdup(dork)), 0);
             }
         }

         if (stricmp(zork, "hide") == 0) /* Hide player */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_MINIMIZE), 0);

         if (stricmp(zork, "float") == 0) /* Toggle float on top */
         {
          dork = strtok(NULL, " ");
          if(dork == NULL)
             goto end;

          if (stricmp(dork, "off") == 0 || stricmp(dork, "0") == 0)
           if (cfg.floatontop) WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_FLOAT), 0);
          if (stricmp(dork, "on") == 0 || stricmp(dork, "1") == 0)
           if (!cfg.floatontop) WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(IDM_M_FLOAT), 0);
         }

         if (stricmp(zork, "use") == 0) /* Use playlist */
          WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);

         if (stricmp(zork, "clear") == 0) /* Clear playlist */
          WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_CLEAR), 0);

         if (stricmp(zork, "next") == 0) /* Next file in playlist */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_NEXT), 0);

         if (stricmp(zork, "forward") == 0) /* Fast forward */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_FWD), 0);

         if (stricmp(zork, "rewind") == 0) /* Fast forward */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_REW), 0);

         if (stricmp(zork, "jump") == 0) /* Jumps to position */
         {
          dork = strtok(NULL, " ");
          if(dork == NULL)
             goto end;

          i = atoi(dork);
          amp_msg(MSG_JUMP, &i, 0);
         }

         if (stricmp(zork, "previous") == 0) /* Previous file in playlist */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PREV), 0);

         if (stricmp(zork, "stop") == 0) /* Stop playback */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_STOP), MPFROMLONG(KC_NONE));

         if (stricmp(zork, "play") == 0) /* Start playback */
         {
             dork = (char *)(zork + strlen(zork));
             if (dork != NULL)
             {
                dork++;
                WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_STOP), MPFROMLONG(KC_NONE));
                WinSendMsg(hwndClient, WM_LOADFILE, MPFROMP(strdup(dork)), 0);
                if(!cfg.playonload)
                   WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), MPFROMLONG(KC_NONE));
             }
             else if(!decoder_playing())
                WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), MPFROMLONG(KC_NONE));
         }

         if (stricmp(zork, "pause") == 0) /* Toggle pause */
         {
          dork = strtok(NULL, " ");
          if(dork == NULL)
             goto end;

          if (stricmp(dork, "off") == 0 || stricmp(dork, "0") == 0)
           if (paused) WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PAUSE), 0);
          if (stricmp(dork, "on") == 0 || stricmp(dork, "1") == 0)
           if (!paused) WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PAUSE), 0);
         }

         if (stricmp(zork, "playonload") == 0) /* Toggle play on load */
         {
          dork = strtok(NULL, " ");
          if(dork == NULL)
             goto end;

          if (stricmp(dork, "off") == 0 || stricmp(dork, "0") == 0)
           cfg.playonload = 0;
          if (stricmp(dork, "on") == 0 || stricmp(dork, "1") == 0)
           cfg.playonload = 1;
         }

         if (stricmp(zork, "autouse") == 0) /* Toggle playlist auto use */
         {
          dork = strtok(NULL, " ");
          if(dork == NULL)
             goto end;

          if (stricmp(dork, "off") == 0 || stricmp(dork, "0") == 0)
           cfg.autouse = 0;
          if (stricmp(dork, "on") == 0 || stricmp(dork, "1") == 0)
           cfg.autouse = 1;
         }

         if (stricmp(zork, "playonuse") == 0) /* Toggle play on 'use playlist' */
         {
          dork = strtok(NULL, " ");
          if(dork == NULL)
             goto end;

          if (stricmp(dork, "off") == 0 || stricmp(dork, "0") == 0)
           cfg.playonuse = 0;
          if (stricmp(dork, "on") == 0 || stricmp(dork, "1") == 0)
           cfg.playonuse = 1;
         }
         if (stricmp(zork, "repeat") == 0) /* Toggle repeat */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_LOAD), 0);

         if (stricmp(zork, "shuffle") == 0) /* Toggle shuffle */
          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_LIST), 0);

         if (stricmp(zork, "volume") == 0) /* Set volume */
         {
          dork = strtok(NULL, " ");
          if(dork != NULL)
          {
             volume = atoi(dork);
             cfg.defaultvol = volume;
             hps = WinGetPS(hwndClient);

             if (!hvol)
              {
               if (cfg.defaultvol > 0)
                z = (cfg.defaultvol / 100.0) * bmp_y(1630);
               else z =0;
               amp_volumebar(hwndClient, hps, 9, 38, 15, (int)z);
              } else
               {
               if (cfg.defaultvol > 0)
                z = (cfg.defaultvol / 100.0) * bmp_x(1630);
               else z = 0;
               amp_volumebar(hwndClient, hps, 9, 38, 15, (int)z);
               }
             WinReleasePS(hps);

             if (!ffwding && !rewwing)
              volnorm();
               else
              vollow();
          }
          _itoa(volume,buf,10);
          pipe_write(piippu, buf);

         }

        }
      }

     update_now = 1;

end:

     DosPeekNPipe(piippu,&buf,0,&ulCbActual,&avail,&ulPipeState);
     while(ulPipeState == NP_STATE_CONNECTED) // wait for client to close pipe
     {
        DosSleep(50);
        DosPeekNPipe(piippu,&buf,0,&ulCbActual,&avail,&ulPipeState);
     }

   }
}

void display_thread(void *scrap)
{
/* DosSetPriority(PRTYS_THREAD, PRTYC_REGULAR, PRTYD_MINIMUM, 0); */

  for (;;)
   {
   if (msg_mode == MSG_SCROLL || update_now == 1)
   {
     if (amp_playmode == AMP_PLAYLIST && update_index == 1)
      {
        WinPostMsg(hwndClient, WM_UPDATE3, 0, 0);  /* WM_UPDATE3 */
        update_index = 0;
      }

     if (amp_playmode == AMP_SINGLE && update_index == 1)
      {
        WinPostMsg(hwndClient, WM_UPDATE3, 0, 0);  /* WM_UPDATE3 */
        update_index = 0;
      }

     if (update_now == 1 && strlen(display_msg) < 24)
      {
        WinPostMsg(hwndClient, WM_UPDATE4, 0, 0);  /* WM_UPDATE3 */
        update_now = 0;
      }

     if (strlen(display_msg) > maxmsglen)
      {
        update_now = 0;
        WinPostMsg(hwndClient, WM_UPDATE5, 0, 0);  /* WM_UPDATE3 */

        if (cfg.scroll != 2 && scrolled != 2)
         {
         if (scroll == 0)
           scroll_index++;
          else
           scroll_index--;

         if (scroll_index > strlen(display_msg))
          {
           scroll_index = 0; scrolled = 0;
           scroll = 0;
          }

         if ((((scroll_index + maxmsglen) > (strlen(display_msg))) || scroll_index == -1) && scrolled != 2)
         {
           if ((scroll_index + maxmsglen) > (strlen(display_msg)) && cfg.scroll == 1 && scrolled == 0)
            { scrolled = 1; }
            else
             if (scrolled == 1 && cfg.scroll == 1)
              { scrolled = 2; scroll_index = 0; }
             else {
            DosSleep(750L);
            scroll = !scroll;
            if (scroll == 0)
             scroll_index++;
            else
             scroll_index--; }
         }
        }
//       if (scrolled == 2 && scroll_index == 0) scrolled = 0;
      }
     }
     DosSleep(300L);
   }
}


// allows easy selection of a directory
MRESULT EXPENTRY wpFileDirDialog(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   char current_text[_MAX_PATH] = {0};

   switch(msg)
   {
      case WM_CONTROL:
         switch(SHORT2FROMMP(mp1))
         {
            case EN_CHANGE:
            {
               HWND hwndef = WinWindowFromID(hwnd,SHORT1FROMMP(mp1));
               WinQueryWindowText(hwndef,sizeof(current_text),current_text);
               // prevents DID_OK from being greyed out
               if(current_text[0] == 0)
                  return 0;
               break;
            }
         }
         break;

      case WM_COMMAND:
         switch(SHORT1FROMMP(mp1))
         {
            case DID_OK:
               if(current_text[0] == 0 ||
                  strcmp(current_text, "*.*") == 0 ||
                  strcmp(current_text, "*") == 0 )
               {
                  // we check the directory the user has selected
                  // it must be the current directory for this to work also
                  // since the file dialog will then accept "../path" kinda thing
                  // since it doesn't accept empty filenames in the entry field
                  char path[_MAX_PATH+4] = "../";
                  SHORT selection = SHORT1FROMMR(WinSendMsg(WinWindowFromID(hwnd,264),
                                    LM_QUERYSELECTION,MPFROMLONG(LIT_FIRST),0));
                  if(selection != LIT_NONE)
                  {
                     // 264 is the directory list box
                     WinSendMsg(WinWindowFromID(hwnd,264),LM_QUERYITEMTEXT,
                               MPFROM2SHORT(selection,sizeof(path)-3), MPFROMP(path+3));

                     if(path[4] == ':' && (path[5] == '\\' || path[5] == '/'))
                     {
                        // We are on the root, let's just use that, with a dot!
                        path[6] = '.';
                        path[7] = 0;
                        WinSetWindowText(WinWindowFromID(hwnd,258),path+3);
                     }
                     else
                     {
                        // 258 is the filename entry field
                        WinSetWindowText(WinWindowFromID(hwnd,258),path);
                     }
                  }
               }
               break;
         }
         break;
   }
   return WinDefFileDlgProc(hwnd,msg,mp1,mp2);
}


void amp_addfiles(HWND hwnd)
{
  HWND hwndFDlg;
  FILEDLG filedialog;
  int i = 0, dex = 0;
  RECORDINSERT insert;
  PMYMPREC core;
  struct stat tats;
  int sizefilz = 32768;

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_OPEN_DIALOG | FDS_MULTIPLESEL;
  sprintf(srceName, "Add file(s) to playlist...");
  filedialog.pszTitle = srceName;
  strcpy(filedialog.szFullFile, "");
  strcat(filedialog.szFullFile, cfg.filedir);
  strcat(filedialog.szFullFile, "*.*");
  filedialog.pfnDlgProc = wpFileDirDialog;

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  dirs_found = 0;
  filz = malloc(sizefilz);
  files_found = 0;
  files_inc = 0;

  if (filedialog.lReturn == DID_OK)
  {
     dex = 0;
     if (filedialog.ulFQFCount > 1)
     {
        strcpy(*filedialog.papszFQFilename[dex], filedialog.szFullFile);
        strcpy(filez, filedialog.szFullFile);
     }
     else
     {
        strcpy(filez, filedialog.szFullFile);
     }
     drivedir(cfg.filedir, filez);
     while (dex < filedialog.ulFQFCount)
     {
/*      filez is the filename */
        if (filez == NULL)
           return;
        drivedir(pathName, filez);
        fnameext(srceName, filez);

        strcpy(lastdir, pathName);

        sprintf(buf, "%s%s", pathName, srceName);

        if (is_playlist(buf))
        {
           load_playlist(container, hwnd, buf, 1);
        }
        else
        {
           stat(filez, &tats);
           if(tats.st_mode & S_IFDIR)
           {
             dirs[dirs_found] = strdup(filez);
             dirs_found++;
           }
           else
           {
              //playlist_post_file(buf);
              //pl_add_song(buf, (PMYMPREC)CMA_END);
              if(sizefilz < files_inc + strlen(buf) + 2)
              {
                 sizefilz += 32768;
                 realloc(filz,sizefilz);
              }
              percent_encode(buf,sizeof(buf),";|");
              strncpy(&filz[files_inc], buf, strlen(buf));
              filz[files_inc + strlen(buf)] = ';';
              files_found++;
              files_inc += (strlen(buf) + 1);
           }
        }
        dex++;
        if (dex >= filedialog.ulFQFCount)
        {
           break;
        }
        else
        {
           strcpy(filez, *filedialog.papszFQFilename[dex]);
        }
     }
  }
  WinFreeFileDlgList(filedialog.papszFQFilename);

   // user probably selected that dir only, so let's save that
   if(dirs_found == 1)
   {
      strcpy(cfg.filedir,dirs[0]);
      strcat(cfg.filedir,"\\");
   }

   if (dirs_found > 0)
   {
      POINTL mousepos;
      WinQueryPointerPos(HWND_DESKTOP, &mousepos);
      //WinMapWindowPoints(HWND_DESKTOP, hwnd, &mousepos, 1);

      if (menu_directory == 0)
         menu_directory = WinLoadMenu(hwnd, 0, DIRECTORY_MENU);

      WinPopupMenu(HWND_DESKTOP, hwnd,
                menu_directory,
                mousepos.x,
                mousepos.y,
                0,
                PU_HCONSTRAIN | PU_VCONSTRAIN |
                PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
                PU_KEYBOARD);
   }

   if (files_found > 0)
   {
      filz[files_inc] = '\0';
      playlist_post_file(filz);
   }
   free(filz);
}

void amp_loadfile(HWND hwnd)
{
  FILEDLG filedialog;
  HWND hwndFDlg;
  FILE *playlist;
  int i = 0, dex = 0;
  char filez[CCHMAXPATH];
  RECORDINSERT insert;
  PMYMPREC core;

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_OPEN_DIALOG;
  sprintf(srceName, "Load file");
  filedialog.pszTitle = srceName;
  strcpy(filedialog.szFullFile, cfg.filedir);
  strcat(filedialog.szFullFile, "*.*");

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  if (filedialog.lReturn == DID_OK)
  {
     drivedir(cfg.filedir, filedialog.szFullFile);
     load_singlefile(filedialog.szFullFile, container, hwndPlaylist);
  }
}

void amp_load_visual_plugin(HWND hwnd)
{
  FILEDLG filedialog;
  HWND hwndFDlg;
  int i = 0;

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_OPEN_DIALOG;
  sprintf(srceName, "Load a Visual Plug-in");
  filedialog.pszTitle = srceName;
  drivedir(filedialog.szFullFile,startpath);
  strcat(filedialog.szFullFile, "*.dll");

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  if (filedialog.lReturn == DID_OK)
   {
    if (!plugin_loaded(filedialog.szFullFile))
     {
#if 0
      i = plugindex;
      strcpy(plugins[i].filename, filedialog.szFullFile);
      plugins[i].x = 0;
      plugins[i].y = 0;
      plugins[i].cx = 0; // non-skin visual plug-in
      plugins[i].cy = 0;
      plugins[i].param[0] = 0;
      init_plugin(hwnd, i);
#endif
     }
     else
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "The plugin is already loaded!", "Whoopsie!", 0, MB_INFORMATION | MB_OK);
   }
}


void amp_loadskin(HWND hwnd, HPS hps)
{
  FILEDLG filedialog;
  HWND hwndFDlg;
  FILE *playlist;
  int i = 0, dex = 0;
  char filez[CCHMAXPATH];
  RECORDINSERT insert;
  PMYMPREC core;

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_OPEN_DIALOG;
  sprintf(srceName, "Load PM123 skin");
  filedialog.pszTitle = srceName;
  drivedir(filedialog.szFullFile, cfg.defaultskin);
  strcat(filedialog.szFullFile, "*.skn");

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  if (filedialog.lReturn == DID_OK)
   {
     for (i = 0; i < 8000; i++)
       /*if (bmp_cache[i] != 0)*/ GpiDeleteBitmap(bmp_cache[i]);
     init_skins(filedialog.szFullFile, hwndClient, hps);
     strcpy(cfg.defaultskin, filedialog.szFullFile);
     skinned = 1;
   }
}


void amp_savelist(HWND hwnd, HWND container)
{
  FILEDLG filedialog;
  HWND hwndFDlg;
  FILE *playlist;
  int i = 0, dex = 0;
  char filez[CCHMAXPATH];
  RECORDINSERT insert;
  PMYMPREC core;

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_SAVEAS_DIALOG;
  sprintf(srceName, "Save playlist as...");
  filedialog.pszTitle = srceName;
  strcpy(filedialog.szFullFile, cfg.listdir);
  strcat(filedialog.szFullFile, "*.LST");

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  if (filedialog.lReturn == DID_OK)
   {
     drivedir(cfg.listdir, filedialog.szFullFile);
     strcpy(filez, filedialog.szFullFile);
     if (strcmp(sext(filez), "") == 0) strcat(filez, ".lst");
     playlist = fopen(filez, "w");
     if (playlist == NULL)
        return;
     fprintf(playlist, "#\n# Playlist created with %s\n# Do not modify!\n# Lines starting with '>' are used by Playlist Manager.\n#\n", VERSION);

     core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
     while (core != NULL)
     {
       fprintf(playlist, "# %s, %s, %s\n%s\n>%u,%u,%u,%u,%lu\n", core -> length, core -> time, core -> info, core -> full, core->bitrate, core->freq, core->mode, core->size, core->secs);
       core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(core), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
     }
     fprintf(playlist, "# End of playlist\n");
     fclose(playlist);
   }
}

BOOL amp_save_eq(HWND hwnd, float *gains, BOOL *mutes, float preamp)
{
  FILEDLG filedialog;
  HWND hwndFDlg;
  FILE *file;
  int i = 0, dex = 0;
  char filez[CCHMAXPATH];

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_SAVEAS_DIALOG;
  filedialog.pszTitle = "Save Equalizer as...";
  if(cfg.lasteq[0] == 0)
     strcpy(filedialog.szFullFile, "*.EQ");
  else
     strcpy(filedialog.szFullFile, cfg.lasteq);

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  if (filedialog.lReturn == DID_OK)
  {
     strcpy(cfg.lasteq, filedialog.szFullFile);
     file = fopen(filedialog.szFullFile, "w");
     if (file == NULL)
        return FALSE;

     fprintf(file, "#\n# Equalizer created with %s\n# Do not modify!\n#\n", VERSION);
     fprintf(file, "# Band gains\n");
     for (i = 0; i < 20; i++)
      fprintf(file, "%g\n", gains[i]);
     fprintf(file, "# Mutes\n");
     for (i = 0; i < 20; i++)
      fprintf(file, "%u\n", mutes[i]);
     fprintf(file, "# Preamplifier\n");
     fprintf(file, "%g\n", preamp);

     fprintf(file, "# End of equalizer\n");
     fclose(file);
     return TRUE;
   }
   return FALSE;
}

BOOL amp_load_eq_file(char *filename, float *gains, BOOL *mutes, float *preamp)
{
   int i;
   FILE *file;
   char vz[CCHMAXPATH];

   file = fopen(filename, "r");
   if (file == NULL)
      return FALSE;
   i = 0;
   while (!feof(file))
   {
      fgets(vz, sizeof(vz), file);
      blank_strip(vz);
      if (*vz && vz[0] != '#' && vz[0] != ';' && i < 41)
      {
         if (i < 20) gains[i] = atof(vz);
         if (i > 19 && i < 40) { mutes[i-20] = atoi(vz);  }
         if (i == 40) { *preamp = atof(vz); }
         i++;
      }
   }
   fclose(file);
   return TRUE;
}


BOOL amp_load_eq(HWND hwnd, float *gains, BOOL *mutes, float *preamp)
{
   HWND hwndFDlg;
   FILEDLG filedialog;

   memset(&filedialog, 0, sizeof(FILEDLG));
   filedialog.cbSize = sizeof(FILEDLG);
   filedialog.fl = FDS_CENTER | FDS_OPEN_DIALOG;
   filedialog.pszTitle = "Load Equalizer";
   drivedir(filedialog.szFullFile, cfg.lasteq);
   strcat(filedialog.szFullFile, "*.EQ");

   hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

   if (filedialog.lReturn == DID_OK)
   {
      strcpy(cfg.lasteq, filedialog.szFullFile);
      return amp_load_eq_file(filedialog.szFullFile, gains, mutes, preamp);
   }
   return FALSE;
}


void amp_loadlist(HWND hwnd, HWND container)
{
  HWND hwndFDlg;
  FILEDLG filedialog;
  FILE *playlist;
  int i = 0, dex = 0;
  RECORDINSERT insert;
  PMYMPREC core;

  memset(&filedialog, 0, sizeof(FILEDLG));
  filedialog.cbSize = sizeof(FILEDLG);
  filedialog.fl = FDS_CENTER | FDS_OPEN_DIALOG;
  filedialog.pszTitle = "Load Playlist";
  strcpy(filedialog.szFullFile, cfg.listdir);
  strcat(filedialog.szFullFile, "*.LST;*.MPL;*.M3U;*.PLS");

  hwndFDlg = WinFileDlg(HWND_DESKTOP, HWND_DESKTOP, &filedialog);

  if (filedialog.lReturn == DID_OK)
   {
     drivedir(cfg.listdir, filedialog.szFullFile);
     WinSendMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_PL_CLEAR), 0);
#if 0
     WinSendMsg(container, CM_REMOVERECORD, MPFROMP(NULL), MPFROM2SHORT(0, CMA_FREE | CMA_INVALIDATE));
     playlist_total = 0;
     playlist_index = 0;
#endif

     if (is_playlist(filedialog.szFullFile))
        load_playlist(container, hwnd, filedialog.szFullFile, 0);
   }
  WinSendMsg(container, CM_INVALIDATERECORD, MPFROMP(NULL), MPFROM2SHORT(0, 0));
}

// returns if the save stream feature has been enabled
BOOL amp_save_stream(HWND hwnd, BOOL enable)
{
   if(enable)
   {
      FILEDLG filedialog;
      HWND hwndFDlg;
      char srceName[80];

      memset(&filedialog, 0, sizeof(FILEDLG));
      filedialog.cbSize = sizeof(FILEDLG);
      filedialog.fl = FDS_CENTER | FDS_SAVEAS_DIALOG;
      sprintf(srceName, "Save stream as...");
      filedialog.pszTitle = srceName;
      strcpy(filedialog.szFullFile, cfg.savedir);
      strcat(filedialog.szFullFile, "*.*");

      hwndFDlg = WinFileDlg(HWND_DESKTOP, hwnd, &filedialog);

      if(filedialog.lReturn == DID_OK)
      {
         amp_msg(MSG_SAVE, filedialog.szFullFile, 0);
         drivedir(cfg.savedir, filedialog.szFullFile);
         return TRUE;
      }
   }
   else
   {
      amp_msg(MSG_SAVE, NULL, 0);
   }
   return FALSE;
}


void amp_cleanshuffle(void)
{
   PMYMPREC currentf;
   int i;

   currentf = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
   if (currentf != NULL)
      currentf -> played = 0;
   while (currentf != NULL)
   {
      currentf = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(currentf), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
      if (currentf != NULL)
         currentf -> played = 0;
   }
   WinPostMsg(container, CM_INVALIDATERECORD, MPFROMP(NULL), MPFROM2SHORT(0, CMA_TEXTCHANGED));
}

void amp_pl_next(int index)
{
   int i;
   currentf = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
   for (i = 0; i < index; i++)
   {
      currentf = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(currentf), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
   }
}

void amp_pl_next_random(void)
{
   if (shuffling == 1 && amp_playmode == AMP_PLAYLIST)
   {
      int h = 0, d = 0;

      PMYMPREC core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (core != NULL && d == 0)
      {
         core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(core), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
         if (core != NULL && core->played == 0)
            d = 1;
      }

      if(d == 0)
      {
         amp_cleanshuffle();
         amp_pl_next((playlist_index = rand() % playlist_total));
      }
      else
      {
         amp_pl_next((h = rand() % playlist_total));

         while (currentf -> played == 1 || currentf == NULL)
         {
            h = rand() % playlist_total;
            amp_pl_next(h);
         }

         playlist_index = h;
      }
   }
}


int amp_index(PMYMPREC aasi)
{
  int i;
  PMYMPREC foorec;
  foorec = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
  if (foorec == aasi)
   return (0);
  for (i = 0; i < playlist_total; i++)
   {
     foorec = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(currentf), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
     if (foorec == aasi)
   return (i + 1);
   }
  return (0);
}

void free_record(PMYMPREC core)
{
   free(core->songname);
   free(core->length);
   free(core->time);
   free(core->info);
   free(core->full);
   free(core->info_string);
}

void remove_record(PMYMPREC core, HWND container)
{
   PMYMPREC removearray[1];
   removearray[0] = core;
   free_record(core);
   WinSendMsg(container, CM_REMOVERECORD, MPFROMP(&removearray), MPFROM2SHORT(1, CMA_FREE | CMA_INVALIDATE));
}

void free_all_records(HWND container)
{
   PMYMPREC core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
   while (core != NULL)
   {
      free_record(core);
      core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(core), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
   }

   WinSendMsg(container, CM_REMOVERECORD, MPFROMP(NULL), MPFROM2SHORT(0, CMA_FREE | CMA_INVALIDATE));
}

MRESULT EXPENTRY UrlDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  int sx, sy;
  SWP swp;
  static int focused = 0;

  switch (msg)
   {
   case WM_PAINT:
     if (!focused) { WinFocusChange(HWND_DESKTOP, WinWindowFromID(hwnd, 101), 0); focused = 1; }
     break;
   case WM_INITDLG:
     sx = WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);
     sy = WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN);
     WinQueryWindowPos(hwnd, &swp);
     WinSetWindowPos(hwnd, HWND_TOP, (sx - swp.cx) / 2, (sy - swp.cy) / 2, 0, 0, SWP_MOVE | SWP_ACTIVATE);
     WinPostMsg(WinWindowFromID(hwnd, 101), EM_SETTEXTLIMIT, MPFROMSHORT(256), 0);
     break;
   case WM_COMMAND:
     switch (COMMANDMSG(&msg) -> cmd)
   {
   case DID_OK:
     WinQueryDlgItemText(hwnd, 101, 1024, url);
     if (strnicmp(url, "http://", 7) != 0)
      {
        WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Only HTTP protocol supported for streaming.", "Whoops!", 0, MB_INFORMATION | MB_OK);
      }
     else
      {
        load_singlefile(url, container, hwndPlaylist);
      }
     WinDismissDlg(hwnd, 0);
     return 0;
     break;
   default:
     break;
   }
     break;
   default:
     break;
   }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

MRESULT EXPENTRY UrlAddDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  int sx, sy;
  SWP swp;
  static int focused = 0;

  switch (msg)
   {
   case WM_PAINT:
     if (!focused) { WinFocusChange(HWND_DESKTOP, WinWindowFromID(hwnd, 101), 0); focused = 1; }
     break;
   case WM_INITDLG:
     sx = WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);
     sy = WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN);
     WinQueryWindowPos(hwnd, &swp);
     WinSetWindowPos(hwnd, HWND_TOP, (sx - swp.cx) / 2, (sy - swp.cy) / 2, 0, 0, SWP_MOVE | SWP_ACTIVATE);
     WinPostMsg(WinWindowFromID(hwnd, 101), EM_SETTEXTLIMIT, MPFROMSHORT(256), 0);
     break;
   case WM_COMMAND:
     switch (COMMANDMSG(&msg) -> cmd)
   {
   case DID_OK:
     WinQueryDlgItemText(hwnd, 101, 1024, url);
     if (strnicmp(url, "http://", 7) != 0)
      {
        WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Only HTTP protocol supported for streaming.", "Whoops!", 0, MB_INFORMATION | MB_OK);
      }
     else
      {
       if (is_playlist(url))
        {
         load_playlist(container, hwnd, url, 0);
        }
        else
         pl_add_song(url, (PMYMPREC)CMA_END, NULL);
      }
     WinDismissDlg(hwnd, 0);
     return 0;
     break;
   default:
     break;
   }
     break;
   default:
     break;
   }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

typedef struct
{
   enum TRACKDLG_TYPE {TRACKDLG_SINGLE, TRACKDLG_MULTIPLE} type;
} TRACKDLG_INFO;

MRESULT EXPENTRY TrackDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   TRACKDLG_INFO *info = WinQueryWindowPtr(hwnd,0);
   HWND hListbox = WinWindowFromID(hwnd,LB_TRACKS);
   HWND hDrives = WinWindowFromID(hwnd,CB_DRIVE);

   switch (msg)
   {
      case WM_INITDLG:
      {
         ULONG rc, i;
         HFILE CDDevice;
         ULONG action;
         ULONG len;
         struct
         {
            USHORT CountCD;
            USHORT FirstCD;
         } CDInfo;
         SHORT sSelectItem;

         info = PVOIDFROMMP(mp2);
         WinSetWindowPtr(hwnd, 0, info);

         len = sizeof(CDInfo);
         if(!DosOpen("\\DEV\\CD-ROM2$", &CDDevice, &action, 0,
                     FILE_NORMAL, OPEN_ACTION_OPEN_IF_EXISTS,
                     OPEN_SHARE_DENYNONE | OPEN_ACCESS_READONLY, NULL))
         {
            if(!DosDevIOCtl(CDDevice, 0x82, 0x60, NULL, 0, NULL, &CDInfo, len, &len))
            {
               for(i = 0; i < CDInfo.CountCD; i++)
               {
                  char driveLetter[3] = { (char) ('A' + CDInfo.FirstCD + i), ':', 0};
                  WinSendDlgItemMsg(hwnd, CB_DRIVE, LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(driveLetter));
               }
            }
            DosClose(CDDevice);
         }

         switch(info->type)
         {
            case TRACKDLG_SINGLE:
               WinSetWindowBits(hListbox,QWL_STYLE,0,LS_MULTIPLESEL);
               WinSetWindowText(hwnd,"Load Track");
               break;

            case TRACKDLG_MULTIPLE:
            {
               WinSetWindowBits(hListbox,QWL_STYLE,1,LS_MULTIPLESEL);
               WinSetWindowBits(hListbox,QWL_STYLE,1,LS_EXTENDEDSEL);
               WinSetWindowText(hwnd,"Add Tracks");
               break;
            }

            default:
               fprintf(stderr,"Unknown TRACKDLG_TYPE in TrackDlgProc.");
               break;
         }

         if(cfg.cddrive[0] == 0)
         {
            cfg.cddrive[0] = (char) ('A' + CDInfo.FirstCD);
            cfg.cddrive[1] = ':';
            cfg.cddrive[2] = 0;
         }
         WinSetDlgItemText(hDrives, CBID_EDIT, cfg.cddrive);
         WinSendMsg(hwnd,WM_COMMAND,MPFROMSHORT(PB_REFRESH),0);

         return 0;
      }

      case WM_COMMAND:
         switch(SHORT1FROMMP(mp1))
         {
            case DID_OK:
            {
               char drive[4];

               WinQueryDlgItemText(WinWindowFromID(hwnd, CB_DRIVE), CBID_EDIT, sizeof(drive), drive);
               drive[1] = ':';
               drive[2] = 0;

               strcpy(cfg.cddrive,drive);

               switch(info->type)
               {
                  case TRACKDLG_SINGLE:
                  {
                     char track = SHORT1FROMMR(WinSendMsg(hListbox, LM_QUERYSELECTION, MPFROMSHORT(LIT_FIRST), 0))+1;
                     load_singletrack(drive, track);
                     break;
                  }

                  case TRACKDLG_MULTIPLE:
                  {
                     char tracks[4096] = ""; // maximum of 256 tracks so this should be safe
                     SHORT sItemSelected = SHORT1FROMMR(WinSendMsg(hListbox,LM_QUERYSELECTION,MPFROMSHORT(LIT_FIRST),0));
                     LONG ulTrackNum = LONGFROMMR(WinSendMsg(hListbox,LM_QUERYITEMHANDLE,MPFROMSHORT(sItemSelected),0));
                     while(sItemSelected != LIT_NONE)
                     {
                        sprintf(strchr(tracks,0),"cd:///%s\\Track %d;",drive,ulTrackNum);

                        sItemSelected = SHORT1FROMMR(WinSendMsg(hListbox,LM_QUERYSELECTION,MPFROMSHORT(sItemSelected),0));
                        ulTrackNum = LONGFROMMR(WinSendMsg(hListbox,LM_QUERYITEMHANDLE,MPFROMSHORT(sItemSelected),0));
                     }

                     playlist_post_file(tracks);

                     break;
                  }

                  default:
                     fprintf(stderr,"Unknown TRACKDLG_TYPE in TrackDlgProc.");
                     break;
               }

               return WinDefDlgProc(hwnd, msg, mp1, mp2);
            }

            case PB_REFRESH:
            {
               char drive[4];
               DECODER_CDINFO cdinfo;

               WinQueryDlgItemText(WinWindowFromID(hwnd, CB_DRIVE), CBID_EDIT, sizeof(drive), drive);
               drive[1] = ':';
               drive[2] = 0;

               if(dec_cdinfo(drive,&cdinfo) == 0)
               {
                  int i;
                  WinSendDlgItemMsg(hwnd, LB_TRACKS, LM_DELETEALL, 0, 0);
                  if(cdinfo.firsttrack != 0)
                     for(i = cdinfo.firsttrack; i <= cdinfo.lasttrack; i++)
                     {
                        SHORT sIndexInserted;

                        char temp[24];
                        sprintf(temp,"Track %d", i);

                        sIndexInserted = SHORT1FROMMR(WinSendMsg(hListbox, LM_INSERTITEM, MPFROMSHORT(LIT_END), MPFROMP(temp)));
                        if(sIndexInserted == LIT_MEMERROR || sIndexInserted == LIT_ERROR)
                        {
                           WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Error filling up Track Listbox.", "Error detected", 0, MB_ERROR | MB_OK);
                           break;
                        }
                        WinSendMsg(hListbox, LM_SETITEMHANDLE, MPFROMSHORT(sIndexInserted), MPFROMLONG(i));
                        if(info->type == TRACKDLG_MULTIPLE)
                           WinSendMsg(hListbox,LM_SELECTITEM,MPFROMSHORT(sIndexInserted),MPFROMLONG(TRUE));
                     }
               }
               else
                  WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, "Cannot find decoder that supports CD tracks.", "Error detected", 0, MB_ERROR | MB_OK);

               return 0;
            }
         }

   }
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
}


MRESULT EXPENTRY MyListProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  int i, o;
  static int focused = 1;
  PDRAGINFO pDInfo, dirpDInfo;
  PDRAGITEM pDItem;
  DRAGINFO draginfo;
  DRAGIMAGE dragimage;
  DRAGITEM dragitem;
  RECORDINSERT insert;
  PMYMPREC core, drag, sarvi;
  PCNRDRAGINFO cnrdrag;
  struct stat tats;
  HWND hwndDest;
  static HACCEL haccel = 0;
  MENUITEM mi;
  PNOTIFYRECORDENTER pEnter;
  QUERYRECORDRECT qrr;
  ULONG pp;
  MRESULT mrc;
  int sizefilz;
  DECODER_INFO decinfo = {0};

  hwndPlaylist = hwnd;

  switch (msg)
   {

   case WM_DOCKWINDOW:
      // if the playlist is docked, forward the request to the main frame.
      // WM_UNDOCKWINDOW is not forwared, as the way it works at the moment
      // is that WM_UNDOCKWINDOW is sent to every visible frame, so the main
      // window gets notified anyway.  If we were to forward WM_UNDOCKWINDOW,
      // we would get problems when the external window would want to dock
      // directly to the main frame, since WM_UNDOCKWINDOW would be forwared
      // right after through this window...
      if(list_search(dock_list,(void*)hwnd) != NULL)
         WinPostMsg(hwndFrame,msg,mp1,mp2);
      return 0;

   case WM_ADJUSTWINDOWPOS:
   {
      PSWP pswplist = (PSWP) mp1;
      SWP swpmain;

      // user does not want docking
      if(cfg.dock_windows == 0)
         return WinDefDlgProc(hwnd, msg, mp1, mp2);

      // we only want to process the MOVE messages
      if(!(pswplist->fl & SWP_MOVE))
         return WinDefDlgProc(hwnd, msg, mp1, mp2);

      if(!WinQueryWindowPos(hwndFrame,&swpmain))
      {
         //DosBeep(600,200);
         return WinDefDlgProc(hwnd, msg, mp1, mp2);
      }

      if(dockWindow(pswplist,&swpmain,cfg.dock_margin))
         WinPostMsg(hwndFrame, WM_DOCKWINDOW, MPFROMHWND(hwnd), 0);
      else
         WinPostMsg(hwndFrame, WM_UNDOCKWINDOW, MPFROMHWND(hwnd), 0);

      return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

   case WM_PRESPARAMCHANGED:
     WinInvalidateRect(hwnd, NULL, 1);
     break;
   case WM_DESTROY:
     WinSetAccelTable(haba, hwnd, (HACCEL)0);
     WinDestroyAccelTable(haccel);
     return (MRESULT)FALSE;
     break;
   case WM_MINMAXFRAME:
     playlist_open = 2;
     focused = 0;
     break;
   case WM_CLOSE:
     cfg.show_playlist = 0;
     playlist_open = 2;
     focused = 0;
     swits = WinQuerySwitchHandle(hwnd, 0);
     WinQuerySwitchEntry(swits, &sdata);
     sdata.uchVisibility = SWL_INVISIBLE;
     WinChangeSwitchEntry(swits, &sdata);

#ifdef HIDEWINDOWS
     WinSetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0, SWP_HIDE);
#else
     WinSetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0, SWP_MINIMIZE);
#endif
     return (MRESULT)TRUE;
     break;
   case WM_COMMAND:
     switch (COMMANDMSG(&msg) -> cmd)
   {
   case IDM_PL_LAST + 1:
   case IDM_PL_LAST + 2:
   case IDM_PL_LAST + 3:
   case IDM_PL_LAST + 4:
   case IDM_PL_LAST + 5:
   case IDM_PL_LAST + 6:
   case IDM_PL_LAST + 7:
   case IDM_PL_LAST + 8:
   case IDM_PL_LAST + 9:
   case IDM_PL_LAST + 10:
      i = (COMMANDMSG(&msg)->cmd - IDM_PL_LAST - 1);
      strcpy(buf, cfg.list[i]);
      for (o = i+1; o < 10; o++)
       strcpy(cfg.list[o-1], cfg.list[o]);
      if (is_playlist(buf))
      load_playlist(container, hwnd, buf, 1);
     break;
   case IDM_DIR_CANCEL:
     break;
   case IDM_DIR_RECURSE:
     for (i = 0; i < dirs_found; i++)
      {
      strcpy(add_dir, dirs[i]);
      sprintf(buf, "%s", add_dir);
//      playlist_post_file(buf);
      _beginthread(recursive_dir_add_thread, NULL, 1024*1024, strdup(buf));
      free(dirs[i]);
      }
     break;
   case IDM_DIR_SINGLE:
     for (i = 0; i < dirs_found; i++)
      {
      strcpy(add_dir, dirs[i]);
      sprintf(buf, "%s", add_dir);
//      playlist_post_file(buf);
      _beginthread(dir_add_thread, NULL, 1024*1024, strdup(buf));
      free(dirs[i]);
      }
     break;
   case IDM_PL_MENUCONT:
      keyboard_activated_shit = 1;
     WinSendMsg(hwnd, WM_CONTROL, MPFROM2SHORT(CNR_PLAYLIST, CN_CONTEXTMENU), PVOIDFROMMP(NULL));
     break;
   case IDM_PL_MENU:
     core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORDEMPHASIS, MPFROMLONG(CMA_FIRST), MPFROMSHORT(CRA_SELECTED)));
     if (core == NULL)
      {
         keyboard_activated_shit = 1;
         WinSendMsg(hwnd, WM_CONTROL, MPFROM2SHORT(CNR_PLAYLIST, CN_CONTEXTMENU), PVOIDFROMMP(core));
      }
        else
      {
        WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
        if (menu_playlists == 0)
         menu_playlists = WinLoadMenu(HWND_OBJECT, 0, PLAYLISTS_MENU);

        qrr.cb = sizeof(QUERYRECORDRECT);
        qrr.pRecord = (PRECORDCORE)core;
        qrr.fRightSplitWindow = TRUE;
        qrr.fsExtent = CMA_TEXT;

          WinSendMsg(container, CM_QUERYRECORDRECT, MPFROMP(&rcl), MPFROMP(&qrr));

        WinPopupMenu(hwnd, hwnd,
                  menu_playlists,
                  rcl.xLeft,
                  rcl.yBottom,
                  0,
                  PU_HCONSTRAIN | PU_VCONSTRAIN |
                  PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
                  PU_KEYBOARD);
      }

     break;
   case IDM_PL_SORT_RANDOM:
     amp_pl_next(playlist_index);
     WinSendMsg(container, CM_SORTRECORD, MPFROMP(pfnCompareRandom), 0);
     if (amp_playmode == AMP_PLAYLIST)
      {
      i = 0;
      sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (sarvi)
       {
        if(sarvi == currentf) break;
        i++;
        sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
       }
/*        amp_pl_next(i); */
      amp_playcurrentf();
      playlist_index = i;
//      WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
      }
     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_PL_SORT_SIZE:
     amp_pl_next(playlist_index);
     WinSendMsg(container, CM_SORTRECORD, MPFROMP(pfnCompareSize), 0);
     if (amp_playmode == AMP_PLAYLIST)
      {
      i = 0;
      sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (sarvi)
       {
        if (sarvi == currentf) break;
        i++;
        sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
       }
      amp_pl_next(i);
      amp_playcurrentf();
      playlist_index = i;
//      WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
      }
     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_PL_SORT_PLTIME:
     amp_pl_next(playlist_index);
     WinSendMsg(container, CM_SORTRECORD, MPFROMP(pfnCompareTime), 0);
     if (amp_playmode == AMP_PLAYLIST)
      {
      i = 0;
      sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (sarvi)
       {
        if (sarvi == currentf) break;
        i++;
        sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
       }
      amp_pl_next(i);
      amp_playcurrentf();
      playlist_index = i;
//      WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
      }
     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_PL_SORT_NAME:
     amp_pl_next(playlist_index);
     WinSendMsg(container, CM_SORTRECORD, MPFROMP(pfnCompareAlphabet), 0);
     if (amp_playmode == AMP_PLAYLIST)
      {
      i = 0;
      sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (sarvi)
       {
        if (sarvi == currentf) break;
        i++;
        sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
       }
      amp_pl_next(i);
      amp_playcurrentf();
      playlist_index = i;
//      WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
      }
     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_PL_SORT_SONG:
     amp_pl_next(playlist_index);
     WinSendMsg(container, CM_SORTRECORD, MPFROMP(pfnCompareSongname), 0);
     if (amp_playmode == AMP_PLAYLIST)
      {
      i = 0;
      sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (sarvi)
       {
        if (sarvi == currentf) break;
        i++;
        sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
       }
      amp_pl_next(i);
      amp_playcurrentf();
      playlist_index = i;
//      WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);
      }
     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_PL_SAVE:
     if (!o_save_list)
      {
      o_save_list = 1;
      if (playlist_total > 0)
        amp_savelist(hwnd, container);
      o_save_list = 0;
      }
     break;
   case IDM_PL_LOADL:
     if (!o_load_list)
      {
      o_load_list = 1;
      amp_loadlist(hwnd, container);
      o_load_list = 0;
      }
     break;
   case IDM_PL_USE:
     if (playlist_total > 0)
      {
        if (amp_playmode == AMP_SINGLE) {
         if (decoder_playing())
          {
           dont_continue = 1;
           StopWait();
          }
        }

        amp_playmode = AMP_PLAYLIST;

        if (!decoder_playing())
        {
           if (shuffling)
              amp_pl_next_random();
           else
           {
              playlist_index = 0;
              amp_pl_next(0);
           }
        }

        if (currentf != NULL && strcmp(currentf->full, "") != 0)
        {
           strcpy(filename, currentf->full);
           strcpy(decoder_needed,currentf->decoder_module_name);
           out_params.formatinfo = currentf->format;
        }

        dec_fileinfo(filename, &decinfo, NULL);
        current_length = (int)decinfo.songlength/1000;
        current_bitrate = decinfo.bitrate;
        current_channels = decinfo.mode;
        current_freq = decinfo.format.samplerate;
        current_track = currentf->track;
        strncpy(current_cd_drive, currentf->cd_drive, sizeof(current_cd_drive));
        strcpy(current_decoder_info_string,currentf->info_string);

        memset(&curtun,0,sizeof(curtun));
        if(currentf->songname != NULL)
           strncpy(curtun.title,currentf->songname,sizeof(curtun.title));
        amp_gettag(filename, &decinfo, &curtun);

        do_display_msg(filename);

        if (repeat == 0) playlist_length = calc_listlength(NULL, FALSE); else
                     playlist_length = 0;

        WinInvalidateRect(hwndClient, NULL, 1);

        update_index = 1;
        update_now = 1;
        scroll = 0;
        scroll_index = 0; scrolled = 0;

        if (cfg.playonuse == 1 && !decoder_playing())
           WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
      }
     break;
   case IDM_PL_CLEAR:
     if (amp_playmode == AMP_PLAYLIST && decoder_playing())
      {
        dont_continue = 1;
        StopWait();
      }
     playlist_total = 0;
     playlist_index = 0;
     playlist_length = 0;
     if (amp_playmode == AMP_PLAYLIST)
      {
        amp_playmode = AMP_NOFILE;
        currentf = NULL;
        current_bitrate = 0;
        current_channels = -1;
        current_length = 0;
        current_decoder_info_string[0] = 0;
        current_freq = 0;
        current_track = 0;
        current_cd_drive[0] = 0;
        no_file_loaded();
        }
     update_index = 1;
     update_now = 1;
     WinInvalidateRect(hwndClient, NULL, 1);
     free_all_records(container);
     break;
   case IDM_PL_LOAD:
     if (!o_add_file)
      {
      o_add_file = 1;
      amp_addfiles(hwnd);
      o_add_file = 0;
      }
     break;
   case IDM_PL_URL:
     WinDlgBox(HWND_DESKTOP, HWND_DESKTOP, UrlAddDlgProc, NULLHANDLE, URLDLG, NULL);
     break;

   case IDM_PL_TRACK:
   {
     TRACKDLG_INFO info = {TRACKDLG_MULTIPLE};
     WinDlgBox(HWND_DESKTOP, HWND_DESKTOP, TrackDlgProc, NULLHANDLE, TRACKDLG, &info);
     break;
   }

   case IDM_PL_S_PLAY:
     //dont_continue = 1;  why??
     dont_continue = 0;
     StopWait();

     core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORDEMPHASIS, MPFROMLONG(CMA_FIRST), MPFROMSHORT(CRA_SELECTED)));
      if (amp_playmode != AMP_PLAYLIST && core)
      {
         if(core->cd_drive[0] != 0 && core->track != 0)
            load_singletrack(core->cd_drive, core->track);
         else
            load_singlefile(core->full, container, hwndPlaylist);
      }

      if (core != NULL && amp_playmode == AMP_PLAYLIST)
      {
       i = 0;
       sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
       while (sarvi)
        {
         if (sarvi == core) break;
         i++;
         sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
        }
       amp_pl_next(i);
       amp_playcurrentf();
       playlist_index = i;

       if (!decoder_playing() && cfg.playonload == 1)
         {
         WinStopTimer(haba, hwndClient, TID_USERMAX - 1);
         WinStartTimer(haba, hwndClient, TID_USERMAX - 1, 100);
         WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
        }
        else if (decoder_playing())
         {
         WinStopTimer(haba, hwndClient, TID_USERMAX - 1);
         WinStartTimer(haba, hwndClient, TID_USERMAX - 1, 100);
         WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0); /* Play */
         }
       update_now = 1;
       update_index = 1;
       WinInvalidateRect(hwndClient, NULL, 1);
      }
     break;
   case IDM_PL_S_TAG:
       core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORDEMPHASIS, MPFROMLONG(CMA_FIRST), MPFROMSHORT(CRA_SELECTED)));
       if (core != NULL)
       {
         tagedit = core;
         create_id3edit(1);
       }
     break;
   case IDM_PL_S_DTAG:
     core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORDEMPHASIS, MPFROMLONG(CMA_FIRST), MPFROMSHORT(CRA_SELECTED)));
     if (core != NULL)
      {
        amp_wipetag(core->full);

        dec_fileinfo(buf, &decinfo, NULL);
        core -> bitrate = decinfo.bitrate;
        core -> channels = decinfo.mode;
        core -> secs = (int)decinfo.songlength/1000;

        /* Songname */
        if (core -> songname != NULL) free(core->songname);
        core -> songname = NULL;

        if (core -> info != NULL) free(core->info);
        sprintf(_buf, "%u kb/s, %.1f kHz, %s", decinfo.bitrate, (decinfo.format.samplerate/1000.0), modes[decinfo.mode]);
        core -> info = strdup(_buf);

        removearray[0] = core;
        WinPostMsg(container, CM_INVALIDATERECORD, MPFROMP(&removearray), MPFROM2SHORT(1, 0));
      }
     break;
   case IDM_PL_S_DEL:
     core = NULL;
     core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORDEMPHASIS, MPFROMLONG(CMA_FIRST), MPFROMSHORT(CRA_SELECTED)));
     if (core != NULL)
     {
        if (currentf == core && decoder_playing())
        {

        }
        else
        {
           int index = find_index(core);
           if(index < playlist_index)
              playlist_index--;

           remove_record(core,container);
           playlist_total--;

           update_index = 1;
           update_now = 1;

           if(index == playlist_index && playlist_total > 0)
           {
              amp_pl_next(index);
              amp_playcurrentf();
           }
           else if(playlist_total <= 0)
           {
              amp_playmode = AMP_NOFILE;
              currentf = NULL;

              playlist_total = 0;
              playlist_index = 0;
              playlist_length = 0;

              current_bitrate = 0;
              current_channels = -1;
              current_length = 0;
              current_decoder_info_string[0] = 0;
              current_freq = 0;
              current_track = 0;
              current_cd_drive[0] = 0;
              no_file_loaded();

              WinInvalidateRect(hwndClient, NULL, 1);
           }
        }
     }

     if (repeat == 0)
        playlist_length = calc_listlength(NULL, FALSE);
     else
        playlist_length = 0;

     break;

   default:
     return WinDefDlgProc(hwnd, msg, mp1, mp2);
     break;
   }
     break;
   case WM_CONTROL:
     switch (SHORT2FROMMP(mp1))
   {
   case CN_ENTER:
     pEnter = (PNOTIFYRECORDENTER)mp2;
     if (pEnter)
      {
      WinSendMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_PL_S_PLAY), 0);
//        if (decoderPlaying() == 0 && cfg.playonload == 0)
//         {
//          WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
//         }
      }
     break;
   case CN_INITDRAG:
     drag = (PMYMPREC) (((PCNRDRAGINIT) mp2) -> pRecord);
     if (drag != NULL)
      {
        dragitem.hwndItem = hwnd;
        dragitem.ulItemID = 1;
        dragitem.hstrType = DrgAddStrHandle(DRT_BINDATA);
        dragitem.hstrRMF = DrgAddStrHandle("<DRM_OS2FILE,DRF_UNKNOWN>");
        drivedir(drag_container, drag->full);
        dragitem.hstrContainerName = DrgAddStrHandle(drag_container);
        fnameext(drag_filename, drag->full);
        dragitem.hstrSourceName = DrgAddStrHandle(drag_filename);
        dragitem.fsControl = 0;

        pDInfo = DrgAllocDraginfo(1);

        /* Fill DRAGIMAGE structure */
        dragimage.cb = sizeof(DRAGIMAGE);
        dragimage.cptl = 0;
        dragimage.hImage = (LHANDLE) mp3;
        dragimage.fl = DRG_ICON;
        dragimage.cxOffset = 8;
        dragimage.cyOffset = 8;

        DrgSetDragitem(pDInfo, &dragitem, sizeof(DRAGITEM), 0);

        if(find_index(drag) == playlist_index)
           pl_entry_move_playing = 1;

        /* Execute drag operation */
        hwndDest = DrgDrag(hwnd,
                      pDInfo,
                      &dragimage,
                      1,
                      VK_ENDDRAG,
                      NULL);

        if (hwndDest != hwndMain && hwndDest != NULLHANDLE)
         {
         removearray[0] = (PMYMPREC) (((PCNRDRAGINIT) mp2) -> pRecord);
         if (removearray[0] != NULL)
          {
           int index = find_index(removearray[0]);
           if(index < playlist_index)
              playlist_index--;

           remove_record(removearray[0],container);
           playlist_total--;
           update_index = 1;
           update_now = 1;
          }
         }
      }
     break;
   case CN_CONTEXTMENU:
     switch (SHORT1FROMMP(mp1))
      {
      case CNR_PLAYLIST:
        if (PVOIDFROMMP(mp2) == NULL)
      {
        WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
        if (menu_playlist == 0)
         menu_playlist = WinLoadMenu(HWND_OBJECT, 0, PLAYLIST_MENU);

        /* Update regulars */
        WinSendMsg(menu_playlist, MM_QUERYITEM, MPFROM2SHORT(IDM_PL_LAST, TRUE), (MPARAM)&mi);
        hwndTemp = mi.hwndSubMenu;
        if (strcmp(cfg.list[0], "") != 0)
         {
         WinSendMsg(menu_playlist, MM_SETITEMATTR, MPFROM2SHORT(IDM_PL_LAST, TRUE), MPFROM2SHORT(MIA_DISABLED, 0));

         for (i = 0; i < 9; i++)
          WinSendMsg(hwndTemp, MM_DELETEITEM, MPFROM2SHORT((IDM_PL_LAST + 1) + i, TRUE), NULL);

         for (i = 0; i < 9; i++)
          {
           if (strcmp(cfg.list[i], "") != 0)
            {
            if (strnicmp(cfg.list[i], "http://", 7) == 0)
              sprintf(buf, "[http] %s%s", sfname(cfg.list[i]), sext(cfg.list[i]));
             else
              sprintf(buf, "%s%s", sfname(cfg.list[i]), sext(cfg.list[i]));
            mi.iPosition = MIT_END;
            mi.afStyle = MIS_TEXT;
            mi.afAttribute = 0;
            mi.id = (IDM_PL_LAST + 1) + i;
            mi.hwndSubMenu = (HWND)NULLHANDLE;
            mi.hItem = 0;
            WinSendMsg(hwndTemp, MM_INSERTITEM, (MPARAM)&mi, (MPARAM)buf);
            }
          }
         } else {
          WinSendMsg(menu_playlist, MM_SETITEMATTR, MPFROM2SHORT(IDM_PL_LAST, TRUE), MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));
         }

          if (keyboard_activated_shit)
           {
            WinQueryWindowPos(hwnd, &swp);
            ptlMouse.x = swp.cx / 2;
            ptlMouse.y = swp.cy / 2;
            keyboard_activated_shit = 0;
           }

          WinPopupMenu(HWND_DESKTOP, hwnd,
               menu_playlist,
                   ptlMouse.x,
                   ptlMouse.y,
                   0,
               PU_HCONSTRAIN | PU_VCONSTRAIN |
               PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
                   PU_KEYBOARD);
      }
        else
      {
        WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
        if (menu_playlists == 0)
         menu_playlists = WinLoadMenu(HWND_OBJECT, 0, PLAYLISTS_MENU);

          if (keyboard_activated_shit)
           {
            WinQueryWindowPos(hwnd, &swp);
            ptlMouse.x = swp.cx / 2;
            ptlMouse.y = swp.cy / 2;
            keyboard_activated_shit = 0;
           }

        WinPopupMenu(HWND_DESKTOP, hwnd,
               menu_playlists,
               ptlMouse.x,
               ptlMouse.y,
               0,
               PU_HCONSTRAIN | PU_VCONSTRAIN |
               PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
               PU_KEYBOARD);
      }
      default:
        break;
      }
     break;
   case CN_DRAGOVER:
     cnrdrag = (PCNRDRAGINFO) mp2;
     if (cnrdrag == NULL)
      return 0;

     pDInfo = ((PCNRDRAGINFO) mp2) -> pDragInfo;
     DrgAccessDraginfo(pDInfo);
     pDItem = DrgQueryDragitemPtr(pDInfo, 0);
     for (i=0; i < pDInfo->cditem; i++) {
      DrgQueryStrName(pDItem->hstrRMF, CCHMAXPATH, buf);
      if (!(strstr(buf, "DRM_OS2FILE")) && !(strstr(buf, "DRM_OBJECT")) ) {
       return (MPFROM2SHORT(DOR_NEVERDROP, DO_UNKNOWN));
      }
      pDItem++;
     }
     DrgFreeDraginfo(pDInfo);
     return (MPFROM2SHORT(DOR_DROP, DO_UNKNOWN));
     break;
   case CN_DROP:
     cnrdrag = (PCNRDRAGINFO) mp2;
     if (cnrdrag == NULL)
      return 0;

     pDInfo = ((PCNRDRAGINFO) mp2) -> pDragInfo;
     DrgAccessDraginfo(pDInfo);
     pDItem = DrgQueryDragitemPtr(pDInfo, 0);

     dirs_found = 0;
     sizefilz = 32768;
     filz = malloc(sizefilz);
     files_found = 0;
     files_inc = 0;

     for (i = 0; i < pDInfo -> cditem; i++)
      {
        DrgQueryStrName(pDItem->hstrSourceName, CCHMAXPATH, srceName);
        DrgQueryStrName(pDItem->hstrContainerName, CCHMAXPATH, pathName);
        DrgQueryStrName(pDItem->hstrRMF, CCHMAXPATH, RMF);
        DrgQueryStrName(pDItem->hstrTargetName, CCHMAXPATH, buf);
        if (strstr(RMF, "DRM_OS2FILE"))
         {
         sprintf(buf, "%s%s", pathName, srceName);

         stat(buf, &tats);
         if(tats.st_mode & S_IFDIR)
         {
           dirs[dirs_found] = strdup(buf);
           dirs_found++;
         } else {

       if (is_playlist(buf))
        {
          if (!open_a_fucking_temp_list) { load_playlist(container, hwnd, buf, 0); } else { load_playlist(container, hwnd, buf, 0); }

          if (open_a_fucking_temp_list == 1) {
            open_a_fucking_temp_list = 0;
            remove("pm123tmp.lst");
         }
         }
        else
         {
          if (cnrdrag->pRecord != NULL)
            {
               tmprec = (PMYMPREC)pl_add_song(buf, (PMYMPREC)cnrdrag->pRecord, NULL);
               if(pl_entry_move_playing)
               {
                  playlist_index = find_index(tmprec);
                  update_index = 1;
                  update_now = 1;

                  pl_entry_move_playing = 0;
               }

            }
           else
            {
            /*tmprec = (PMYMPREC)pl_add_song(buf, (PMYMPREC)CMA_END);*/
            //playlist_post_file(buf);
            if(sizefilz < files_inc + strlen(buf) + 2)
            {
               sizefilz += 32768;
               realloc(filz,sizefilz);
            }
            percent_encode(buf,sizeof(buf),";|");
            strncpy(&filz[files_inc], buf, strlen(buf));
            filz[files_inc + strlen(buf)] = ';';
            files_found++;
            files_inc += (strlen(buf) + 1);
            }
         }
        }
        }
        pDItem++;
      }

     if (dirs_found > 0)
      {
      if (menu_directory == 0)
        menu_directory = WinLoadMenu(HWND_OBJECT, 0, DIRECTORY_MENU);

      WinPopupMenu(HWND_DESKTOP, hwnd,
                menu_directory,
                pDInfo->xDrop,
                pDInfo->yDrop,
                0,
                PU_HCONSTRAIN | PU_VCONSTRAIN |
                PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
                PU_KEYBOARD);
      }
     DrgFreeDraginfo(pDInfo);

     if (files_found > 0)
      {
      filz[files_inc] = '\0';
      playlist_post_file(filz);
      }
     free(filz);

     pl_entry_move_playing = 0;

     break;

   default:
     break;
   }
     break;
   case WM_INITDLG:

     haccel = WinLoadAccelTable(haba, NULLHANDLE, 8001);
     if (haccel == NULLHANDLE) DosBeep(500, 100);
     if (!WinSetAccelTable(haba, haccel, hwnd)) DosBeep(500, 100);

     if (playlist_open == 3)
   {
     playlist_open = 2;
     swits = WinQuerySwitchHandle(hwnd, 0);
     WinQuerySwitchEntry(swits, &sdata);
     sdata.uchVisibility = SWL_INVISIBLE;
     WinChangeSwitchEntry(swits, &sdata);

#ifdef HIDEWINDOWS
     WinSetWindowPos(hwnd, HWND_TOP, cfg.Playlist.x, cfg.Playlist.y, cfg.Playlist.cx, cfg.Playlist.cy,
           SWP_MOVE | SWP_SIZE);
     WinSetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0, SWP_HIDE);
#else
     WinSetWindowPos(hwnd, HWND_TOP, cfg.Playlist.x, cfg.Playlist.y, cfg.Playlist.cx, cfg.Playlist.cy,
           SWP_MOVE | SWP_SIZE | SWP_MINIMIZE);
#endif
   }
     else
   {
     WinSetWindowPos(hwnd, HWND_TOP, cfg.Playlist.x, cfg.Playlist.y, cfg.Playlist.cx, cfg.Playlist.cy,
           SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW | SWP_ZORDER);
   }

     container = amp_listcontainer(hwnd);

     menu_playlist = WinLoadMenu(HWND_OBJECT, 0, PLAYLIST_MENU);
     menu_playlists = WinLoadMenu(HWND_OBJECT, 0, PLAYLISTS_MENU);

     if (open_a_fucking_temp_list == 1)
      {
      open_a_fucking_temp_list = 0;
      amp_addplaylist(container, hwndPlaylist, "pm123tmp.lst", 0);
      remove("pm123tmp.lst");
      }

     if (argument != NULL)
      {
      load_singlefile(argument, container, hwndPlaylist);
      }

      if(cfg.show_playlist == 1)
      {
         // it seems we can't do more than one WinSetWindowPos
         // in the WM_INITDLG ... WinSendMsg doesn't work... ???
         WinPostMsg(hwndMain, WM_COMMAND, MPFROMSHORT(BMP_PL), 0);
      }

      break;

   case WM_PAINT:
     if (!focused) { WinFocusChange(HWND_DESKTOP, hwnd, 0); focused = 1; }

#if 0
     WinQueryPresParam(hwnd,
                  PP_BACKGROUNDCOLOR,
                  0,
                  NULL,
                  sizeof(cfg.pl_bg_color),
                  &cfg.pl_bg_color,
                  0);

     WinQueryPresParam(hwnd,
                  PP_FONTNAMESIZE,
                  0,
                  NULL,
                  sizeof(cfg.pl_font),
                  &cfg.pl_font,
                  0);
#endif
      mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);

      amp_resizelist(hwnd, container, kill, title);

      return ((MRESULT)mrc);

   case WM_WINDOWPOSCHANGED:
   {
      //WinQueryWindowPos(hwnd, &swp);
      //if (swp.x != -32000 && swp.y != -32000)
      //   cfg.Playlist = swp;

      SWP *swp = PVOIDFROMMP(mp1);

      if( ((swp->fl & SWP_SIZE) || (swp->fl & SWP_MOVE)) && WinIsWindowVisible(hwnd)
         && (swp->x != -32000 && swp->y != -32000))
            cfg.Playlist = *swp;
      return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

   case WM_ERASEBACKGROUND:
      return FALSE;

   case WM_CHAR:
     WinSetAccelTable(haba, haccel, hwnd);

     if ((!(SHORT1FROMMP(mp1) & KC_KEYUP)) && (SHORT1FROMMP(mp1) & KC_VIRTUALKEY))
      {
      switch (SHORT2FROMMP(mp2))
       {
         case VK_ESC:
          WinPostMsg(hwnd, WM_CLOSE, 0, 0);
          return (MRESULT)TRUE;
          break;
         case VK_DELETE:
          WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_PL_S_DEL, 0), 0);
          break;
         case VK_INSERT:
          WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_PL_LOAD, 0), 0);
          break;
         default:
          return WinDefDlgProc(hwnd, msg, mp1, mp2);
          break;
       }
      return (MRESULT)TRUE;
      }
     return WinDefDlgProc(hwnd, msg, mp1, mp2);
     break;

   default:
     return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }
   return 0;
}

void amp_cleartimer(HWND hwnd)
{
  hps = WinGetPS(hwnd);
  if (!seek_drag && !seeking && !WindowSmall) amp_drawtimer(hps, 204, 47, 0);
  WinReleasePS(hps);
}

void amp_playstop(HWND hwnd)
{
  int h, d;
  PMYMPREC fizi;
  DECODER_INFO decinfo = {0};
  MSG_PLAY_STRUCT msgplayinfo = {0};

  playback_start = 0;
  amp_cleartimer(hwnd);

  if (amp_playmode == AMP_SINGLE && repeat && !dont_continue)
  {
     WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
  }

  d = 1;
  /* Playlist; start playing next file */
  if (amp_playmode == AMP_PLAYLIST && dont_continue == 0)
  {
     if (shuffling == 0)
     {
        if (updated == 0)
           playlist_index++;
        else
           updated = 0;
     }
     else
     {
        PMYMPREC core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
        d = 0;
        while (core != NULL && d == 0)
        {
           core = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(core), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
           if (core != NULL && core->played == 0)
              d = 1;
        }

        /* Repeat */
        if (d == 0 && repeat)
        {
           total_played = 0;
           amp_cleanshuffle();
           d = 1;
           playlist_length = 0;
           total_played = 0;
        }

        if (d == 0)
        {
           if (repeat == 0)
              playlist_length = calc_listlength(NULL, FALSE);
           else
              playlist_length = 0;

           playlist_index = 0;
           currentf = NULL;
           amp_pl_next(0);
           if (currentf != NULL && strcmp(currentf->full, "") != 0)
           {
              strcpy(filename, currentf->full);
              strcpy(decoder_needed,currentf->decoder_module_name);
              out_params.formatinfo = currentf->format;
           }

           scroll = 0;
           scroll_index = 0; scrolled = 0;
           update_now = 1;
           currentf = NULL;
           dont_continue = 0;
           total_played = 0;
           amp_cleanshuffle();

           do_display_msg(filename);
           strcpy(timeout_msg, display_msg);

           WinSendMsg(WinWindowFromID(hwnd, BMP_PLAY), WM_DEPRESS, 0, 0);
        }
        else
        {
           amp_pl_next((h = rand() % playlist_total));

           while (currentf -> played == 1 || currentf == NULL)
           {
              h = rand() % playlist_total;
              amp_pl_next(h);
           }

           playlist_index = h;
        }
     }
     update_index = 1;

     if (d == 1 && playlist_index == playlist_total && repeat)
        playlist_index = 0;

     if (playlist_index < playlist_total && d == 1)
     {
        amp_pl_next(playlist_index);

        if (shuffling == 1)
        {
           currentf -> played = 1;
           if (repeat == 0)
              playlist_length = calc_listlength(NULL, TRUE);
           else
              playlist_length = 0;
        }
        else
           playlist_length = calc_listlength(currentf, FALSE);

        if (currentf != NULL && strcmp(currentf->full, "") != 0)
        {
           strcpy(filename, currentf -> full);
           strcpy(decoder_needed,currentf->decoder_module_name);
           out_params.formatinfo = currentf->format;
        }

        current_bitrate = currentf -> bitrate;
        current_channels = currentf -> channels;
        dec_fileinfo(filename, &decinfo, NULL);
        current_length = (int)decinfo.songlength/1000;
        current_freq = decinfo.format.samplerate;
        current_track = currentf->track;
        strncpy(current_cd_drive, currentf->cd_drive, sizeof(current_cd_drive));
        strcpy(current_decoder_info_string,currentf->info_string);

        scroll = 0;
        scroll_index = 0; scrolled = 0;
        update_now = 1;

        memset(&curtun,0,sizeof(curtun));
        if(currentf->songname != NULL)
           strncpy(curtun.title,currentf->songname,sizeof(curtun.title));
        amp_gettag(currentf -> full, &decinfo, &curtun);

        do_display_msg(filename);
        strcpy(timeout_msg, display_msg);

        WinStopTimer(haba, hwndClient, TID_USERMAX - 1);
        WinStartTimer(haba, hwndClient, TID_USERMAX - 1, 100);

        msgplayinfo.filename = filename;
        msgplayinfo.drive = current_cd_drive;
        msgplayinfo.track = current_track;
        msgplayinfo.out_filename = filename;
        msgplayinfo.hMain = hwndClient;
        msgplayinfo.decoder_needed = decoder_needed;
        amp_msg(MSG_PLAY, &msgplayinfo, 0);

        WinInvalidateRect(hwndClient, NULL, 1);
     }
     else
     {
        playlist_index = 0;
        currentf = NULL;

        amp_pl_next(0);

        if (currentf != NULL && strcmp(currentf->full, "") != 0)
        {
           strcpy(filename, currentf->full);
           strcpy(decoder_needed,currentf->decoder_module_name);
           out_params.formatinfo = currentf->format;
        }

        do_display_msg(filename);
        strcpy(timeout_msg, display_msg);

        scroll = 0;
        scroll_index = 0; scrolled = 0;
        update_now = 1;

        total_played = 0;

        dont_continue = 0;
        amp_msg(MSG_STOP, 0, 0); // nothing to play, close sound card
     }
  }
  else
  {
     amp_msg(MSG_STOP, 0, 0); // nothing to play, close sound card
  }
  dont_continue = 0;
}


// equalizer stuff
float gains[20];
BOOL  mutes[20];
float preamp;

MRESULT EXPENTRY wpEqualizer(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   int i;
   MRESULT mrc;
   static ULONG slider_range;
   static BOOL nottheuser = FALSE;

   switch (msg)
   {
      case WM_PAINT:
         mrc = WinDefDlgProc(hwnd, msg, mp1, mp2);

         WinQueryWindowPos(hwnd, &swp);
         if (swp.x != -32000 && swp.y != -32000)
            cfg.Equalizer = swp;

         return((MRESULT)mrc);
         break;

      case WM_CLOSE:
         eq_open = 2;
         eqSwits = WinQuerySwitchHandle(hwnd, 0);
         WinQuerySwitchEntry(eqSwits, &eqSdata);
         eqSdata.uchVisibility = SWL_INVISIBLE;
         WinChangeSwitchEntry(eqSwits, &eqSdata);

#ifdef HIDEWINDOWS
         WinSetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0,
               SWP_HIDE);
#else
         WinSetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0,
               SWP_MINIMIZE);
#endif

         return (MRESULT)TRUE;
         break;

      case WM_REFRESH_CONTROLS:
      {
         float db;
         ULONG value;

         nottheuser = TRUE;

         _control87(EM_INVALID | EM_DENORMAL | EM_ZERODIVIDE | EM_OVERFLOW | EM_UNDERFLOW | EM_INEXACT, MCW_EM);

         for (i = 0; i < 10; i++)
         {
            db = 20*log10(gains[i]);
            value = (db * slider_range/2)/12 + slider_range/2;

            WinSendMsg(WinWindowFromID(hwnd, 101 + i),
                    SLM_SETSLIDERINFO,
                    MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_RANGEVALUE),
                    MPFROMSHORT(value));

            WinSendMsg(WinWindowFromID(hwnd, 125 + i),
                    BM_SETCHECK,
                    MPFROMSHORT(mutes[i]),
                    0);
         }
         db = 20*log10(preamp);
         value = (db * slider_range/2)/12 + slider_range/2;

         WinSendMsg(WinWindowFromID(hwnd, 139),
                 SLM_SETSLIDERINFO,
                 MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_RANGEVALUE),
                 MPFROMSHORT(value));

         WinSendMsg(WinWindowFromID(hwnd, 121),
                 BM_SETCHECK,
                 MPFROMSHORT(cfg.eq_enabled),
                 0);

         nottheuser = FALSE;

         break;
      }

      case WM_COMMAND:
         switch (COMMANDMSG(&msg) -> cmd)
         {
            case 123:
               if(amp_load_eq(hwnd, gains, mutes, &preamp))
                  WinSendMsg(hwnd,WM_REFRESH_CONTROLS,0,0);

               if(amp_getradio(hwnd, 121))
                  equalize_sound(gains, mutes, preamp, 1);

               break;

            case 124:
               amp_save_eq(hwnd, gains, mutes, preamp);
               break;

            case 122:
               for (i = 0; i < 20; i++) gains[i] = 1.0;
               for (i = 0; i < 20; i++) mutes[i] = 0;

               for (i = 0; i < 10; i++)
                  WinSendMsg(WinWindowFromID(hwnd, 101 + i), SLM_SETSLIDERINFO, MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG(slider_range/2));
               for (i = 0; i < 10; i++)
                  WinSendMsg(WinWindowFromID(hwnd, 125 + i), BM_SETCHECK, MPFROMSHORT(FALSE), 0);

               WinSendMsg(WinWindowFromID(hwnd, 139), SLM_SETSLIDERINFO, MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG(slider_range/2));

               if(amp_getradio(hwnd, 121))
                  equalize_sound(gains, mutes, preamp, 1);
               else
                  equalize_sound(gains, mutes, preamp, 0);
               break;
         }
         break;

      case WM_CONTROL:
      {
         int id = SHORT1FROMMP(mp1);
         if(nottheuser) break;

         if (SHORT2FROMMP(mp1) == BN_CLICKED)
         {
            if (id > 124 && id < 135) /* Mute */
            {
               mutes[id - 125] = amp_getradio(hwnd, id);      // left
               mutes[id - 125 + 10] = amp_getradio(hwnd, id); // right

               if(amp_getradio(hwnd, 121))
                  equalize_sound(gains, mutes, preamp, 1);
               break;
            }

            if (id == 121)
            {
               cfg.eq_enabled = amp_getradio(hwnd, 121);
               equalize_sound(gains, mutes, preamp, cfg.eq_enabled);
               break;
            }
         }

         switch (SHORT2FROMMP(mp1))
         {
            case SLN_CHANGE:
               /* Slider adjust */
               if ((id > 100 && id < 111) || id == 139)
               {
                  float g2;

                  _control87(EM_INVALID | EM_DENORMAL | EM_ZERODIVIDE | EM_OVERFLOW | EM_UNDERFLOW | EM_INEXACT, MCW_EM);
                  g2 = ((float)LONGFROMMP(mp2) - slider_range/2)/ (slider_range/2) *12; // -12 to 12 dB
                  g2 = pow(10.0, g2/20.0); // transforming into voltage gain

                  if(id == 139)
                     preamp = g2;
                  else
                  {
                     gains[SHORT1FROMMP(mp1) - 101] = g2;      // left
                     gains[SHORT1FROMMP(mp1) - 101 + 10] = g2; // right
                  }

                  if(amp_getradio(hwnd, 121))
                     equalize_sound(gains, mutes, preamp, 1);
               }
               break;
         }
         break;
      }

      case WM_INITDLG:
         nottheuser = TRUE;

         hwndEq = hwnd;

         do_warpsans(hwnd);

         if (cfg.Equalizer.x > 0 && cfg.Equalizer.y > 0)
            WinSetWindowPos(hwnd, HWND_TOP, cfg.Equalizer.x, cfg.Equalizer.y, 0, 0,
                            SWP_ACTIVATE | SWP_MOVE | SWP_SHOW | SWP_ZORDER);

         slider_range = HIUSHORT(WinSendMsg(WinWindowFromID(hwnd, 139), SLM_QUERYSLIDERINFO, MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG(0)))-1;

         eq_open = 1;
         for (i = 101; i < 111; i++)
         {
            WinSendMsg(WinWindowFromID(hwnd, i), SLM_ADDDETENT, MPFROMSHORT(0), 0);
            WinSendMsg(WinWindowFromID(hwnd, i), SLM_ADDDETENT, MPFROMSHORT(slider_range/4), 0);
            WinSendMsg(WinWindowFromID(hwnd, i), SLM_ADDDETENT, MPFROMSHORT(slider_range/2), 0);
            WinSendMsg(WinWindowFromID(hwnd, i), SLM_ADDDETENT, MPFROMSHORT(3*slider_range/4), 0);
            WinSendMsg(WinWindowFromID(hwnd, i), SLM_ADDDETENT, MPFROMSHORT(slider_range), 0);

            WinSendMsg(WinWindowFromID(hwnd, i), SLM_SETSLIDERINFO, MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG(slider_range/2));
         }
         WinSendMsg(WinWindowFromID(hwnd, 110), SLM_SETTICKSIZE, MPFROM2SHORT(SMA_SETALLTICKS, 0), 0);

         WinSendMsg(WinWindowFromID(hwnd, 139), SLM_ADDDETENT, MPFROMSHORT(0), 0);
         WinSendMsg(WinWindowFromID(hwnd, 139), SLM_ADDDETENT, MPFROMSHORT(slider_range/4), 0);
         WinSendMsg(WinWindowFromID(hwnd, 139), SLM_ADDDETENT, MPFROMSHORT(slider_range/2), 0);
         WinSendMsg(WinWindowFromID(hwnd, 139), SLM_ADDDETENT, MPFROMSHORT(3*slider_range/4), 0);
         WinSendMsg(WinWindowFromID(hwnd, 139), SLM_ADDDETENT, MPFROMSHORT(slider_range), 0);
         WinSendMsg(WinWindowFromID(hwnd, 139), SLM_SETSLIDERINFO, MPFROM2SHORT(SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG(slider_range/2));

         WinSendMsg(hwnd,WM_REFRESH_CONTROLS,0,0);

         nottheuser = FALSE;

         break;

      default:
         return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }
   return 0;
}

MRESULT EXPENTRY MyWinProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  int       i, values = 0;
  ULONG     o;
  APIRET    rc;
  POINTL    ptl;
  char         *foo;
  HPOINTER     lame;
  static int   palette_init;
  PMYMPREC     sarvi;
  float     z;
  static double maxval = 0;
  MENUITEM     mi;
  char         srceName[CCHMAXPATH], pathName[CCHMAXPATH], RMF[CCHMAXPATH], buf1[256], buf2[256], *tas;
  PDRAGINFO    pDInfo;
  PDRAGITEM    pDItem;
  SWP       *swappi;
  static HACCEL haccel = 0;
  static int   focused = 0;
  RECTL     r;
  int       bands[32];
  int       tmpx, tmpy;
  TRACKINFO    TrackInfo;
  PSZ       szApp   = "PM123";
  PSZ       szTopic   = "Control";
  PSZ       szItem     = "Dunno";
  PSZ       szSstatus = "RUNNING";
  float     *table;
  SWP       menuSwp;
  DECODER_INFO decinfo = {0};

  hwndMain = hwnd;

  switch (msg)
   {
   case WM_DDE_INITIATE:
     break;
   case WM_LOADFILE:
     tas = (char *)mp1;
     load_singlefile(tas, container, hwndPlaylist);
     free(tas);
     tas = NULL;
     break;
   case WM_MINMAXFRAME:
     /* make the app just behind us active when we are minimizing */
     swappi = PVOIDFROMMP(mp1);
     if (swappi->fl & SWP_MINIMIZE)
     /* first gets the next frame on top (frame behind this frame, this API
       is a tricky one) then sets that window active */
       WinSetActiveWindow(HWND_DESKTOP, WinQueryWindow(hwnd, QW_NEXTTOP));

     if (swappi->fl & SWP_RESTORE)
      WinInvalidateRect(hwndClient, NULL, 1);

     return 0;
     break;
   case WM_FOCUSCHANGE:
     if (SHORT1FROMMP(mp2) == TRUE)
      {
//      WinFocusChange(HWND_DESKTOP, hwndClient, FC_NOBRINGTOTOP);

      hps = WinGetPS(hwndClient);
      i_have_focus = 1;
      if (WindowSmall && !WindowTiny) {
        amp_drawled(hps, 8, 44, TRUE);
      } else if (!WindowSmall) amp_drawled(hps, 7, 90, TRUE);
      WinReleasePS(hps);
      } else
      {
      hps = WinGetPS(hwndClient);
      i_have_focus = 0;
      if (WindowSmall && !WindowTiny) {
        amp_drawled(hps, 8, 44, FALSE);
      } else if (!WindowSmall) amp_drawled(hps, 7, 90, FALSE);
      WinReleasePS(hps);
      }
      return WinDefWindowProc(hwnd, msg, mp1, mp2);
     break;
   case 0x041e:
//    WinFocusChange(HWND_DESKTOP, hwndClient, FC_NOBRINGTOTOP);
     hps = WinGetPS(hwndClient);
     if (WindowSmall && !WindowTiny) {
      amp_drawled(hps, 8, 44, TRUE);
     } else if (!WindowSmall) amp_drawled(hps, 7, 90, TRUE);
     WinReleasePS(hps);
     break;
   case 0x041f:
     hps = WinGetPS(hwndClient);
     if (WindowSmall && !WindowTiny) {
      amp_drawled(hps, 8, 44, FALSE);
     } else if (!WindowSmall) amp_drawled(hps, 7, 90, FALSE);
     WinReleasePS(hps);
     break;
   case WM_PLAYERROR:
//      do {
        if (dec_status() == DECODER_STOPPED || !out_playing_data())
        {
           WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_STOP), MPFROMLONG(KC_NONE));
           if (last_error[0] != 0)
           {
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, last_error, "Error detected", 0, MB_ERROR | MB_OK);
              last_error[0] = 0;
           }
        }

//      } while (foo != NULL);
     break;

   case WM_DISPLAYMSG:
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PVOIDFROMMP(mp1), "Information from plug-in", 0, MB_INFORMATION | MB_OK);
      break;

   case WM_UPDATE5:
     hps = WinGetPS(hwndClient);

     if (strlen(display_msg) > maxmsglen)
      {
       strcpy(scrollbuf, "");
       if (scroll_index < strlen(display_msg))
         strncat(scrollbuf, &display_msg[scroll_index], maxmsglen);
        else
         strncat(scrollbuf, display_msg, maxmsglen);

       lamepad(tempbuf, maxmsglen, scrollbuf);

       strcpy(scrollbuf, tempbuf);
      }
      else
      {
       strcpy(scrollbuf, display_msg);
      }

/*    lamepad(scrollbuf, maxmsglen, display_msg); */
     if (!WindowSmall)
      amp_drawstring(hps, bmp_pos[13].x, bmp_pos[13].y, strlwr(scrollbuf), maxmsglen);
     else if (!WindowTiny)
      amp_drawstring(hps, bmp_pos[14].x, bmp_pos[14].y, strlwr(scrollbuf), maxmsglen);

     WinReleasePS(hps);
     break;
   case WM_UPDATE4:
     hps = WinGetPS(hwndClient);
     lamepad(scrollbuf, maxmsglen, display_msg);
     if (!WindowSmall)
      amp_drawstring(hps, bmp_pos[13].x, bmp_pos[13].y, strlwr(scrollbuf), maxmsglen);
     else if (!WindowTiny)
      amp_drawstring(hps, bmp_pos[14].x, bmp_pos[14].y, strlwr(scrollbuf), maxmsglen);
     WinReleasePS(hps);
     break;
   case WM_UPDATE3:
     hps = WinGetPS(hwnd);
//    if (!WindowSmall)
//     {
      /* Erase playlist indicator */
//      amp_drawbk(hps, 152, 49, 200, 57, 1905);
//     }
     if (amp_playmode == AMP_PLAYLIST && playlist_total > 0 && !WindowSmall)
      {
      if (!new_plind)
       {
        sprintf(__buf, "%02u of %02u", playlist_index + 1, playlist_total);
        foocol = (songC.bRed * 65536) + (songC.bGreen * 256) + songC.bBlue;
        i = GpiQueryColorIndex(hps, 0, foocol);
        amp_writestring(hps, hwndClient, 158, 45 + 5, i, CLR_BLACK, "7.Helv", __buf);
      } else amp_drawplind(hps, playlist_index + 1, playlist_total);
      amp_drawrate(hps, 174, 15 + 44 + 5, current_bitrate);
      amp_drawchannels(hps, 157, 15 + 44 + 5, current_channels);
      }

     if (amp_playmode == AMP_PLAYLIST && !WindowSmall && stat_mode == 0)
      amp_drawbmp(hps, bmp_pos[21].x, bmp_pos[21].y, BMP_LISTPLAY);
     if (amp_playmode == AMP_SINGLE && !WindowSmall && stat_mode == 0)
      amp_drawbmp(hps, bmp_pos[21].x, bmp_pos[21].y, BMP_SINGLEPLAY);
     if (amp_playmode == AMP_NOFILE && !WindowSmall && stat_mode == 0)
      amp_drawbmp(hps, bmp_pos[21].x, bmp_pos[21].y, BMP_NOFILE);

     if (!WindowSmall)
      {
      amp_drawrate(hps, 174, 15 + 44 + 5, current_bitrate);
      amp_drawchannels(hps, 157, 15 + 44 + 5, current_channels);
      }

     if (stat_mode == 0)
      {
      if (amp_playmode == AMP_PLAYLIST) {
        if (repeat)
         playlist_length = 0;
        else
        {
          if (shuffling == 1)
             playlist_length = calc_listlength(NULL, TRUE);
          else
          {
             if (decoder_playing())
                playlist_length = calc_listlength(currentf, FALSE);
             else
                playlist_length = calc_listlength(NULL, FALSE);
           }
        }

        if (repeat)
         { if (!WindowSmall) { amp_drawtinytimer(hps, 115, 47, 0); } }
         else
         { if (!WindowSmall) { if (!decoder_playing()) { playback_start = 0; total_played = 0; } amp_drawtinytimer(hps, 115, 47, playlist_length - total_played - playback_start);  } }
      } else if (!WindowSmall) amp_drawtinytimer(hps, 115, 47, 0);
      }

     if (stat_mode == 0 && !WindowSmall)
      {
      if (!decoder_playing())
        amp_drawtinytimer(hps, 115, 63, current_length);
       else
        amp_drawtinytimer(hps, 115, 63, TotalTime() - TimePlayed());
      }

     WinReleasePS(hps);
     break;
   case WM_UPDATE2:
     hps = WinGetPS(hwndClient);
     lamepad(tempbuf, maxmsglen, " ");
     if (!WindowSmall)
      amp_drawstring(hps, bmp_pos[13].x, bmp_pos[13].y, tempbuf, maxmsglen);
     else if (!WindowTiny)
      amp_drawstring(hps, bmp_pos[14].x, bmp_pos[14].y, tempbuf, maxmsglen);

     WinReleasePS(hps);
     break;
   case WM_UPDATE1:
     hps = WinGetPS(hwndClient);
     if (!WindowSmall)
      amp_drawstring(hps, bmp_pos[13].x, bmp_pos[13].y, strlwr(display_msg), maxmsglen);
     else if (!WindowTiny)
      amp_drawstring(hps, bmp_pos[14].x, bmp_pos[14].y, strlwr(display_msg), maxmsglen);
     WinReleasePS(hps);
     break;
   case WM_CONTEXTMENU:
     hps = WinGetPS(hwnd);
     if (WindowSmall && !WindowTiny) {
      amp_drawled(hps, 8, 44, FALSE);
     } else if (!WindowSmall) amp_drawled(hps, 7, 90, FALSE);
     WinReleasePS(hps);

     WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);

     /* Update regulars */
     WinSendMsg(main_menu, MM_QUERYITEM, MPFROM2SHORT(IDM_M_LAST, TRUE), (MPARAM)&mi);
     hwndTemp = mi.hwndSubMenu;
     if (strcmp(cfg.last[0], "") != 0)
      {
      WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_LAST, TRUE), MPFROM2SHORT(MIA_DISABLED, 0));

      for (i = 0; i < 9; i++)
       WinSendMsg(hwndTemp, MM_DELETEITEM, MPFROM2SHORT((IDM_M_LAST + 1) + i, TRUE), NULL);

      for (i = 0; i < 9; i++)
       {
        if (strcmp(cfg.last[i], "") != 0)
         {
         if (strnicmp(cfg.last[i], "http://", 7) == 0)
          sprintf(buf, "[http] %s%s", sfname(cfg.last[i]), sext(cfg.last[i]));
           else
          sprintf(buf, "%s%s", sfname(cfg.last[i]), sext(cfg.last[i]));
         mi.iPosition = MIT_END;
         mi.afStyle = MIS_TEXT;
         mi.afAttribute = 0;
         mi.id = (IDM_M_LAST + 1) + i;
         mi.hwndSubMenu = (HWND)NULLHANDLE;
         mi.hItem = 0;
         WinSendMsg(hwndTemp, MM_INSERTITEM, (MPARAM)&mi, (MPARAM)buf);
         }
       }
      } else {
       WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_LAST, TRUE), MPFROM2SHORT(MIA_DISABLED, MIA_DISABLED));
      }

     /* Update bookmarks */
     WinSendMsg(main_menu, MM_QUERYITEM, MPFROM2SHORT(IDM_M_BOOKMARKS, TRUE), (MPARAM)&mi);
     hwndTemp = mi.hwndSubMenu;
     load_bookmark_menu(hwndTemp);

     /* Update plug-ins */
     WinSendMsg(main_menu, MM_QUERYITEM, MPFROM2SHORT(IDM_M_PLUG, TRUE), (MPARAM)&mi);
     hwndTemp = mi.hwndSubMenu;
     load_plugin_menu(hwndTemp);

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_EQUALIZE, TRUE), MPFROM2SHORT(MIA_DISABLED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_MANAGER, TRUE), MPFROM2SHORT(MIA_DISABLED, 0));

     WinQueryWindowPos(hwndFrame, &swp);
     if (SHORT2FROMMP(mp2))
     WinPopupMenu(HWND_DESKTOP, hwnd,
         main_menu,
         swp.x + 2,
         swp.y + 2,
         0,
         PU_HCONSTRAIN | PU_VCONSTRAIN |
         PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
         PU_KEYBOARD);
      else
     WinPopupMenu(HWND_DESKTOP, hwnd,
         main_menu,
         ptlMouse.x,
         ptlMouse.y,
         0,
         PU_HCONSTRAIN | PU_VCONSTRAIN |
         PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
         PU_KEYBOARD);
     break;
   case WM_SEEKSTOP:
//    WinSendMsg(WinWindowFromID(hwnd, BMP_FWD), WM_DEPRESS, 0, 0);
//    WinSendMsg(WinWindowFromID(hwnd, BMP_REW), WM_DEPRESS, 0, 0);
//    ffwding = FALSE; rewwing = FALSE;
     seeking = FALSE;
     break;

   case WM_CHANGEBR:

      current_bitrate = LONGFROMMP(mp1);
      if(!WindowSmall)
      {
         hps = WinGetPS(hwnd);
         amp_drawrate(hps, 174, 15 + 44 + 5, current_bitrate);
         WinReleasePS(hps);
      }
      break;

   case WM_METADATA:
   {
     char *metadata = PVOIDFROMMP(mp1);
     if(metadata != NULL)
     {
        char *titlepos = strstr(metadata,"StreamTitle='")+13;
        if(titlepos != (char*)NULL+13)
        {
           char *sep;
           curtun.title[sizeof(curtun.title)-1] = 0;
           strncpy(curtun.title,titlepos,sizeof(curtun.title)-1);
           sep = strchr(curtun.title,';');
           if(sep != NULL)
              *(sep-1) = 0; // the stupid '
           do_display_msg(filename);
           scroll_index = 0;
           msg_mode = MSG_SCROLL;
           update_now = 1;
        }

        if(currentf != NULL)
        {
           char buf[512] = "";
           PMYMPREC updatearray[1];

           if (strcmp(curtun.artist, "") != 0 && strcmp(curtun.title, "") != 0)
              sprintf(buf, "%s: %s", curtun.artist, curtun.title);
           if (strcmp(curtun.artist, "") == 0 && strcmp(curtun.title, "") != 0)
              sprintf(buf, "%s", curtun.title);
           if (strcmp(curtun.artist, "") != 0 && strcmp(curtun.title, "") == 0)
              sprintf(buf, "%s", curtun.artist);

           free(currentf->songname);
           currentf->songname = strdup(buf);

           updatearray[0] = currentf;
           WinSendMsg(container, CM_INVALIDATERECORD, MPFROMP(&updatearray), MPFROM2SHORT(1, CMA_TEXTCHANGED));
        }
     }
     break;
   }

   // sent by decoder
   case WM_PLAYSTOP:
     decoder_finished = TRUE;

     // if output is always hungry, WM_OUTPUT_OUTOFDATA will not be posted again
     // so we go there by our selves
     if(!out_params.always_hungry)
        break;

   // sent by output
   case WM_OUTPUT_OUTOFDATA:
     if(decoder_finished)
     {
       WinSendMsg(WinWindowFromID(hwnd, BMP_PLAY), WM_DEPRESS, 0, 0);
       WinSendMsg(WinWindowFromID(hwnd, BMP_PAUSE), WM_DEPRESS, 0, 0);
       WinSendMsg(WinWindowFromID(hwnd, BMP_FWD), WM_DEPRESS, 0, 0);
       WinSendMsg(WinWindowFromID(hwnd, BMP_REW), WM_DEPRESS, 0, 0);
       set_bubbletext(BMP_PLAY, "Starts playing");
       if (ffwding) { ffwding = FALSE; forwarding = FALSE; }
       if (rewwing) { rewwing = FALSE; rewinding  = FALSE;}
       seeking = FALSE;

       amp_playstop(hwnd);
       if (!decoder_playing())
       {
         hps = WinGetPS(hwnd);
         if (!seek_drag && !seeking && !WindowSmall) amp_drawtimer(hps, 204, 47, 0);
         if (!WindowSmall) amp_drawtinytimer(hps, 115, 63, (current_length != 0 ? current_length - playback_start : 0));
         amp_drawindicator(hps, 0);
         WinReleasePS(hps);
         seek_drag = FALSE;
       }
     }
     decoder_finished = FALSE;
     break;

   case DM_DRAGOVER:
     pDInfo = (PDRAGINFO)mp1;
     DrgAccessDraginfo(pDInfo);
     pDItem = DrgQueryDragitemPtr(pDInfo, 0);
     for (i=0; i < pDInfo->cditem; i++) {
      DrgQueryStrName(pDItem->hstrRMF, CCHMAXPATH, buf);
      if (!(strstr(buf, "DRM_OS2FILE"))) {
       return (MPFROM2SHORT(DOR_NEVERDROP, DO_UNKNOWN));
      }
      pDItem++;
     }
     DrgFreeDraginfo(pDInfo);
     return (MPFROM2SHORT(DOR_DROP, DO_UNKNOWN));
     break;
/* dragdrop */
   case DM_DROP:
     hwndTemp = amp_drop_mainwin(hwnd, mp1, __buf, sizeof(__buf));
     if (hwndTemp == hwndPlaylist && amp_playmode == AMP_PLAYLIST)
      {
      i = 0;
      sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (sarvi)
       {
        if (strcmp(sarvi->full, __buf) == 0) break;
        i++;
        sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
       }
       amp_pl_next(i);
       amp_playcurrentf();
       playlist_index = i;
       update_now = 1;

       if (!decoder_playing() && cfg.playonload == 1)
         {
         WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
         WinSendMsg(WinWindowFromID(hwndClient, BMP_PLAY), WM_PRESS, 0, 0);
        }
        else if (decoder_playing())
         {
         //dont_continue = 1; why??
         dont_continue = 0;
         StopWait();
         amp_pl_next(i);
         amp_playcurrentf();
         playlist_index = i;
         update_now = 1;
         WinPostMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
         WinSendMsg(WinWindowFromID(hwndClient, BMP_PLAY), WM_PRESS, 0, 0);
         }

      } else if (strcmp(__buf, "") != 0)
         load_singlefile(__buf, container, hwndPlaylist);
     scroll = 0;
     scroll_index = 0; scrolled = 0;
     update_index = 1;
     update_now = 1;
     break;
    case WM_TIMER:
     if (LONGFROMMP(mp1) == (TID_USERMAX - 10))
      {
        /* Ramp volume */
        if (ramp_volume > 1) ramp_volume -= 2; else ramp_volume = 0;
        i = ramp_volume;
        if (i > 100) i = 100;
        audioSetVolume(i);
        if (ramp_volume == 0)
         {
          WinSendMsg(hwnd, WM_COMMAND, MPFROMSHORT(BMP_STOP), 0);
          volnorm();
         WinStopTimer(haba, hwndClient, TID_USERMAX - 10);
         }
      }
     if (LONGFROMMP(mp1) == (TID_USERMAX - 3))
      {
      WinSetWindowPos(hwndFrame, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER);
      }
     if (LONGFROMMP(mp1) == (TID_USERMAX - 1) && decoder_playing())
      {
      playback_start = TimePlayed();

      if (playback_start > 0)
        {
         hps = WinGetPS(hwnd);

         if (!WindowSmall) {
           if (!seek_drag && !seeking) amp_drawtimer(hps, 204, 47, playback_start);
           if (stat_mode == 0 && !WindowSmall) amp_drawtinytimer(hps, 115, 63, (TotalTime() != 0 ? TotalTime() - playback_start : 0));

           if (TotalTime() > 0)
              z = (((float)TimePlayed() / (float)TotalTime()) * slider_width);
           else
              z = 0;
           z += 1;
           if (!seek_drag && !seeking) amp_drawindicator(hps, (int)z);

           if (amp_playmode == AMP_PLAYLIST && stat_mode == 0 && !WindowSmall)
            {
            if (!repeat) amp_drawtinytimer(hps, 115, 47, playlist_length - total_played - playback_start); else
                      amp_drawtinytimer(hps, 115, 47, 0);
            }
         }

         WinReleasePS(hps);
        }
     }
     return (MRESULT)FALSE;
     break;
   case WM_COMMAND:
     WinSetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER | SWP_ACTIVATE);
     if(COMMANDMSG(&msg)->source == CMDSRC_MENU)
        process_possible_bookmark(COMMANDMSG(&msg)->cmd);
        process_possible_plugin(COMMANDMSG(&msg)->cmd);

     switch (COMMANDMSG(&msg) -> cmd)
   {
   case IDM_M_MANAGER:
     if (!o_manager)
      {
        o_manager = 1;
        WinDlgBox(HWND_DESKTOP, HWND_DESKTOP, PmDlgProc, NULLHANDLE, PMDLG, NULL);
        o_manager = 0;
      }
      else
      {
       if (manager_open == 2)
        {
#ifdef HIDEWINDOWS
         WinSetWindowPos(hwndManager, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER | SWP_SHOW | SWP_ACTIVATE);
#else
         WinSetWindowPos(hwndManager, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER | SWP_RESTORE | SWP_ACTIVATE);
#endif
         manager_open = 1;
         mgrSdata.uchVisibility = SWL_VISIBLE;
         WinChangeSwitchEntry(mgrSwits, &mgrSdata);
        }
        else if(manager_open == 1)
           WinSetFocus(HWND_DESKTOP, hwndManager);
      }

     break;
   case IDM_M_LAST + 1:
   case IDM_M_LAST + 2:
   case IDM_M_LAST + 3:
   case IDM_M_LAST + 4:
   case IDM_M_LAST + 5:
   case IDM_M_LAST + 6:
   case IDM_M_LAST + 7:
   case IDM_M_LAST + 8:
   case IDM_M_LAST + 9:
   case IDM_M_LAST + 10:
/*    do_not_recall = 1; */
      i = (COMMANDMSG(&msg)->cmd - IDM_M_LAST - 1);
      strcpy(buf, cfg.last[i]);
      for (o = i+1; o < 10; o++)
       strcpy(cfg.last[o-1], cfg.last[o]);
      load_singlefile(buf, container, hwndPlaylist);
      break;

   case IDM_M_ADDBOOK:
      add_bookmark(filename,display_msg);
      break;

   case IDM_M_EDITBOOK:
   {
      static HWND hBookmark = 0;
      if(hBookmark == 0)
      {
         hBookmark = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP, wpBookmark, NULLHANDLE, BOOKMARK_DLG, NULL);
         WinProcessDlg(hBookmark);
         WinDestroyWindow(hBookmark);
         hBookmark = 0;
      }
      else
         WinFocusChange(HWND_DESKTOP, hBookmark, 0);

      break;
   }

   case IDM_M_TAG:
     if (amp_playmode != AMP_NOFILE)
      {
      switch (amp_playmode)
       {
        case AMP_SINGLE:
                      single.full = strdup(filename);
                      tagedit = &single;
                      create_id3edit(2);
                      break;
        case AMP_PLAYLIST:
                      tagedit = currentf;
                      create_id3edit(1);
                      break;
        default: break;
       }
      }
      break;

   case IDM_M_SAVE:
   {
      USHORT usAttrib;

      usAttrib = SHORT1FROMMR(
          WinSendMsg(main_menu,          /* Submenu window        */
          MM_QUERYITEMATTR,              /* Message               */
          (MPARAM)IDM_M_SAVE,            /* Item identifier       */
          (MPARAM)MIA_CHECKED            /* Attribute mask        */
          ));

      usAttrib = amp_save_stream(hwnd,!usAttrib) ? MIA_CHECKED : 0;

      WinSendMsg(main_menu,                     /* Submenu window        */
          MM_SETITEMATTR,                       /* Message               */
          (MPARAM)IDM_M_SAVE,                   /* Item identifier       */
          MPFROM2SHORT(MIA_CHECKED, usAttrib)); /* Attribute mask, value */

      break;
   }

   case IDM_M_EQUALIZE:
     if (!eq_open)
      {
         eq_open = 1;
         WinDlgBox(HWND_DESKTOP, HWND_DESKTOP, wpEqualizer, NULLHANDLE, EQUALIZER, NULL);
         eq_open = 0;
      }
      else
      {
       if (eq_open == 2)
        {
#ifdef HIDEWINDOWS
         WinSetWindowPos(hwndEq, HWND_TOP, cfg.Equalizer.x, cfg.Equalizer.y, cfg.Equalizer.cx, cfg.Equalizer.cy, SWP_ZORDER | SWP_SHOW | SWP_ACTIVATE | SWP_SIZE | SWP_MOVE);
#else
         WinSetWindowPos(hwndEq, HWND_TOP, cfg.Equalizer.x, cfg.Equalizer.y, cfg.Equalizer.cx, cfg.Equalizer.cy, SWP_ZORDER | SWP_RESTORE | SWP_ACTIVATE | SWP_SIZE | SWP_MOVE);
#endif
         eq_open = 1;
         eqSdata.uchVisibility = SWL_VISIBLE;
         WinChangeSwitchEntry(eqSwits, &eqSdata);
        }
        else if(eq_open == 1)
           WinSetFocus(HWND_DESKTOP,hwndEq);
      }
     break;
   case IDM_M_FLOAT:
    cfg.floatontop = !cfg.floatontop;
    if (cfg.floatontop)
      WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FLOAT,   TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
     else
      WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FLOAT,   TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

    if (!cfg.floatontop)
      WinStopTimer(haba, hwndClient, TID_USERMAX - 3);
     else
      {
      WinStopTimer(haba, hwndClient, TID_USERMAX - 3);
      WinStartTimer(haba, hwndClient, TID_USERMAX - 3, 100);
      }

    break;
   case IDM_M_PRHIGH:
    WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRLOW,  TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
    WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRHIGH, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

    WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRHIGH, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
    cfg.priority = 1;
    break;
   case IDM_M_PRLOW:
    WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRLOW,  TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
    WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRHIGH, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

    WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRLOW, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
    cfg.priority = 0;
    break;
   case BMP_PL:
     if (playlist_open == 0)
      {
        playlist_open = 1;
//       amp_listwindow(hwnd);
      }
     if (playlist_open == 2)
      {
#ifdef HIDEWINDOWS
        WinSetWindowPos(hwndPlaylist, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER | SWP_SHOW | SWP_ACTIVATE);
#else
        WinSetWindowPos(hwndPlaylist, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER | SWP_RESTORE | SWP_ACTIVATE);
#endif
        cfg.show_playlist = 1;
        playlist_open = 1;
        sdata.uchVisibility = SWL_VISIBLE;
        WinChangeSwitchEntry(swits, &sdata);
      }
      else if (playlist_open == 1)
       {
         WinSendMsg(hwndPlaylist, WM_CLOSE, 0, 0);
       }
     break;
   case IDM_M_URL:
     WinDlgBox(HWND_DESKTOP, HWND_DESKTOP, UrlDlgProc, NULLHANDLE, URLDLG, NULL);
     break;
   case IDM_M_TRACK:
   {
     TRACKDLG_INFO info = {TRACKDLG_SINGLE};
     WinDlgBox(HWND_DESKTOP, HWND_DESKTOP, TrackDlgProc, NULLHANDLE, TRACKDLG, &info);
     break;
   }

   case IDM_M_FONT1:
     gui_font     = 0;
     cfg.font     = 0;
     scroll_index = 0; scrolled = 0;
     fontrise     = 0;

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT1, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT2, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT3, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT1, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));

     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_M_FONT2:
     gui_font     = 1;
     cfg.font     = 1;
     scroll_index = 0; scrolled = 0;
     fontrise     = 0;

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT1, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT2, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT3, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT2, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));

     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_M_FONT3:
     gui_font     = 2;
     cfg.font     = 2;
     scroll_index = 0; scrolled = 0;
     fontrise     = 1;

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT1, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT2, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT3, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT3, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));

     WinInvalidateRect(hwndClient, NULL, 1);
     break;
   case IDM_M_TINY:
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_NORMAL, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_SMALL,  TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_TINY,   TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_TINY,   TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));

     WindowSmall = TRUE;
     WindowTiny = TRUE;
     WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, bmp_pos[31].x, bmp_pos[31].y,
           SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
     cfg.mode = 2;
     for (i = 0; i < 32; i++)
        if(plugins[i].cx > 0 && plugins[i].cy > 0)
           deinit_vis_plugin(hwnd, i);
     reflow_and_resize();
     break;
   case IDM_M_NORMAL:
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_NORMAL, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_SMALL,  TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_TINY,   TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_NORMAL, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
     WindowSmall = FALSE;
     WindowTiny = FALSE;
     WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, bmp_pos[2].x, bmp_pos[2].y,
                 SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
     for (i = 0; i < 32; i++)
        init_plugin(hwnd, i);
     cfg.mode = 0;
     maxmsglen = nmaxmsg;
     reflow_and_resize();
     break;
   case IDM_M_SMALL:
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_NORMAL, TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_SMALL,  TRUE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_TINY,   TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_SMALL,  TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
     WindowSmall = TRUE;
     WindowTiny = FALSE;
     WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, bmp_pos[30].x, bmp_pos[30].y,
           SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
     for (i = 0; i < 32; i++)
        if(plugins[i].cx > 0 && plugins[i].cy > 0)
           deinit_vis_plugin(hwnd, i);
     cfg.mode = 1;
     maxmsglen = smaxmsg;
     reflow_and_resize();
     break;
   case IDM_M_MINIMIZE:
     WinSetWindowPos(hwndFrame, HWND_DESKTOP, 0, 0, 0, 0, SWP_HIDE);
     WinSetActiveWindow(HWND_DESKTOP, WinQueryWindow(hwnd, QW_NEXTTOP));
     break;
   case IDM_M_SKIN:
     hps = WinGetPS(hwnd);
     amp_loadskin(hwnd, hps);
     WinReleasePS(hps);
     WinInvalidateRect(hwndClient, NULL, 1);
      break;
   case IDM_M_LOAD:
     if (!o_open_file)
      {
      o_open_file = 1;
      amp_loadfile(hwnd);
      o_open_file = 0;
      update_index = 1;
      update_now = 1;
      }
     break;
   case IDM_M_CFG:
     create_properties();
     break;
   case BMP_LOAD:
     repeat = !repeat;
     cfg.rpt = repeat;
     if (repeat)
      WinSendMsg(WinWindowFromID(hwnd, BMP_LOAD), WM_PRESS, 0, 0);
      else
      WinSendMsg(WinWindowFromID(hwnd, BMP_LOAD), WM_DEPRESS, 0, 0);
     if (amp_playmode == AMP_PLAYLIST) {
      if (repeat == 1) playlist_length = 0; else
      {
        if (shuffling == 1) playlist_length = calc_listlength(NULL, TRUE); else
                       playlist_length = calc_listlength(currentf, FALSE);
      }
     }
     update_index = 1;
     update_now = 1;
     break;
   case BMP_LIST:
    if (!shuffling)
    {
       if (playlist_total > 0 && amp_playmode == AMP_PLAYLIST)
          amp_cleanshuffle();
       shuffling = 1;
       WinSendMsg(WinWindowFromID(hwnd, BMP_LIST), WM_PRESS, 0, 0);
    }
    else
    {
       if (amp_playmode == AMP_PLAYLIST)
          amp_cleanshuffle();
       shuffling = 0;
       WinSendMsg(WinWindowFromID(hwnd, BMP_LIST), WM_DEPRESS, 0, 0);
    }
    cfg.shf = shuffling;

#if 0
      if (/*amp_playmode == AMP_PLAYLIST*/playlist_total > 0)
      {
      if (decoder_playing())
         { dont_continue = 1; StopWait(); }

      WinSendMsg(container, CM_SORTRECORD, MPFROMP(pfnCompareRandom), 0);

/*      amp_pl_next(0);
      strcpy(buf, currentf->full);

      WinSendMsg(container, CM_SORTRECORD, MPFROMP(pfnCompareRandom), 0);
      i = 0;
      sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, NULL, MPFROM2SHORT(CMA_FIRST, CMA_ITEMORDER)));
      while (sarvi)
       {
        if (strcmp(sarvi->full, buf) == 0) break;
        i++;
        sarvi = (PMYMPREC) PVOIDFROMMR(WinSendMsg(container, CM_QUERYRECORD, MPFROMP(sarvi), MPFROM2SHORT(CMA_NEXT, CMA_ITEMORDER)));
       } */

      amp_pl_next(0);
      amp_playcurrentf();
      playlist_index = 0;

      WinSendMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(IDM_PL_USE), 0);

/*      WinSendMsg(WinWindowFromID(hwnd, BMP_LIST), WM_DEPRESS, 0, 0);
      if (decoderPlaying() == 1)
       {
        StopWait();
        WinPostMsg(hwndPlaylist, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);
       } */

      } else { WinSendMsg(WinWindowFromID(hwnd, BMP_LIST), WM_DEPRESS, 0, 0); }
#endif

     break;
   case IDM_M_PLAYLIST:
     if (playlist_open == 0)
      {
        playlist_open = 1;
        amp_listwindow(hwnd);
      }
     if (playlist_open == 2)
      {
#ifdef HIDEWINDOWS
        WinSetWindowPos(hwndPlaylist, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER | SWP_SHOW);
#else
        WinSetWindowPos(hwndPlaylist, HWND_TOP, 0, 0, 0, 0, SWP_ZORDER | SWP_RESTORE);
#endif
        playlist_open = 1;
        sdata.uchVisibility = SWL_VISIBLE;
        WinChangeSwitchEntry(swits, &sdata);
      }
     if (playlist_open == 1)
      {
        WinSetFocus(HWND_DESKTOP, hwndPlaylist);
      }
     break;
   case BMP_POWER:
      amp_quit(hwnd, haba, hmq);
      break;
   case BMP_PLAY:
     if (!decoder_playing())
     {
        MSG_PLAY_STRUCT msgplayinfo = {0};

        if (amp_playmode == AMP_SINGLE || amp_playmode == AMP_PLAYLIST)
        {
           char track_filename[128];
           playback_start = 0;
           dont_continue = 0;

           WinStopTimer(haba, hwndClient, TID_USERMAX - 1);
           WinStartTimer(haba, hwndClient, TID_USERMAX - 1, 100);

           msgplayinfo.filename = filename;
           if(current_cd_drive[0] != 0 && current_track != 0 && filename[0] == 0)
           {
              sprintf(track_filename, "%s\\Track %d",current_cd_drive,current_track);
              msgplayinfo.out_filename = track_filename;
           }
           else
              msgplayinfo.out_filename = filename;
           msgplayinfo.drive = current_cd_drive;
           msgplayinfo.track = current_track;
           msgplayinfo.hMain = hwnd;
           msgplayinfo.decoder_needed = decoder_needed;

           amp_msg(MSG_PLAY, &msgplayinfo, 0);

           rewwing = FALSE; ffwding = FALSE; paused = FALSE;
           WinSendMsg(WinWindowFromID(hwnd, BMP_FWD),   WM_DEPRESS, 0, 0);
           WinSendMsg(WinWindowFromID(hwnd, BMP_REW),   WM_DEPRESS, 0, 0);
           WinSendMsg(WinWindowFromID(hwnd, BMP_PAUSE), WM_DEPRESS, 0, 0);

           if (amp_playmode == AMP_PLAYLIST)
           {
              if(currentf != NULL)
                 currentf -> played = 1;

              if (repeat == 0)
                 playlist_length = calc_listlength(NULL, TRUE);
              else
                 playlist_length = 0;
              update_index = 1;
              update_now = 1;
           }
        }
        else
        {
           WinSendMsg(WinWindowFromID(hwnd, BMP_PLAY), WM_DEPRESS, 0, 0);
        }
     }
     else
     {
        WinSendMsg(hwnd, WM_COMMAND, MPFROMSHORT(BMP_STOP), MPFROMLONG(mp2));

/* ???
        if(paused)
           WinSendMsg(WinWindowFromID(hwnd, BMP_PLAY), WM_PRESS, 0, 0);
         //WinSendMsg(WinWindowFromID(hwnd, BMP_PLAY), WM_DEPRESS, 0, 0);
*/

     }
     break;

   case BMP_PAUSE:
     if ( decoder_playing() && !ffwding && !rewwing)
      {
        amp_msg(MSG_PAUSE, 0, 0);
        paused = !paused;
        if (paused == 1)
        {
          WinSendMsg(WinWindowFromID(hwnd, BMP_PAUSE), WM_PRESS, 0, 0);
          pause_time = time(NULL) - playback_start;
        }
        else
        {
          WinSendMsg(WinWindowFromID(hwnd, BMP_PAUSE), WM_DEPRESS, 0, 0);
          playback_start = time(NULL) - pause_time;
        }
      }
      else
      {
         WinSendMsg(WinWindowFromID(hwnd, BMP_PAUSE), WM_DEPRESS, 0, 0);
      }
     break;
   case BMP_FLOAD:
   case BMP_N_FLOAD:
     if (!o_open_file)
      {
      o_open_file = 1;
      amp_loadfile(hwnd);
      o_open_file = 0;
      update_index = 1;
      update_now = 1;
      }
     break;
   case BMP_N_STOP:
   case BMP_STOP:
     if (decoder_playing())
      {
        if(paused)
           WinSendMsg(hwnd, WM_COMMAND, MPFROMSHORT(BMP_PAUSE), 0);

        amp_cleanshuffle();
        playback_start = 0;
        if (amp_playmode == AMP_PLAYLIST || (amp_playmode == AMP_SINGLE && repeat))
          dont_continue = 1;

          if (LONGFROMMP(mp2) == KC_NONE)
            StopWait();
           else
            {
             ramp_volume = cfg.defaultvol;
             WinStartTimer(haba, hwndClient, TID_USERMAX - 10, 100);
            }

        WinSendMsg(WinWindowFromID(hwnd, BMP_PLAY), WM_DEPRESS, 0, 0);
        amp_msg(MSG_STOP, 0, 0);
        set_bubbletext(BMP_PLAY, "Starts playing");
      }
     break;
   case BMP_NEXT:
      if (amp_playmode == AMP_PLAYLIST && (playlist_index < playlist_total || shuffling))
      {
         BOOL decoder_was_playing = decoder_playing();

         if (decoder_was_playing)
            StopWait();

         if(shuffling)
         {
            amp_pl_next_random();
         }
         else
         {
            amp_cleanshuffle();
            playlist_index++;
            if (playlist_index == playlist_total)
               playlist_index = 0;

            amp_pl_next(playlist_index);
         }

         if (currentf != NULL && strcmp(currentf->full, "") != 0)
         {
           strcpy(filename, currentf -> full);
           strcpy(decoder_needed,currentf->decoder_module_name);
           out_params.formatinfo = currentf->format;
         }

         current_bitrate = currentf -> bitrate;
         current_channels = currentf -> channels;
         dec_fileinfo(filename, &decinfo, NULL);
         current_length = (int)decinfo.songlength/1000;
         current_freq = currentf->freq;
         current_track = currentf->track;
         strncpy(current_cd_drive, currentf->cd_drive, sizeof(current_cd_drive));
         strcpy(current_decoder_info_string,currentf->info_string);
         scroll = 0;
         scroll_index = 0; scrolled = 0;
         update_index = 1;
         update_now = 1;

         memset(&curtun,0,sizeof(curtun));
         if(currentf->songname != NULL)
            strncpy(curtun.title,currentf->songname,sizeof(curtun.title));
         amp_gettag(filename, &decinfo, &curtun);

         do_display_msg(filename);
         strcpy(timeout_msg, display_msg);

         if(decoder_was_playing)
            WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);

         playback_start = 0;

         msg_mode = MSG_SCROLL;
      }
      else
      {
         if (amp_playmode == AMP_PLAYLIST)
         {
            playback_start = 0;
            if (decoder_playing())
               StopWait();
            playlist_index = 0;
         }
      }
      break;
   case BMP_PREV:
      if (amp_playmode == AMP_PLAYLIST)
      {
         BOOL decoder_was_playing = decoder_playing();

         if (decoder_was_playing)
            StopWait();

         if(shuffling)
         {
            amp_pl_next_random();
         }
         else
         {
            amp_cleanshuffle();
            playlist_index--;
            //updated = 1;
            if (playlist_index < 0)
               playlist_index = playlist_total - 1;
            amp_pl_next(playlist_index);
         }

         if (currentf != NULL && strcmp(currentf->full, "") != 0)
         {
           strcpy(filename, currentf -> full);
           strcpy(decoder_needed,currentf->decoder_module_name);
           out_params.formatinfo = currentf->format;
         }
         current_bitrate = currentf->bitrate;
         current_channels = currentf->channels;
         dec_fileinfo(filename, &decinfo, NULL);
         current_length = (int)decinfo.songlength/1000;
         current_freq = decinfo.format.samplerate;
         current_track = currentf->track;
         strncpy(current_cd_drive, currentf->cd_drive, sizeof(current_cd_drive));
         strcpy(current_decoder_info_string,currentf->info_string);
         scroll = 0;
         scroll_index = 0; scrolled = 0;
         update_index = 1;
         update_now = 1;

         memset(&curtun,0,sizeof(curtun));
         if(currentf->songname != NULL)
            strncpy(curtun.title,currentf->songname,sizeof(curtun.title));
         amp_gettag(filename, &decinfo, &curtun);

         do_display_msg(filename);
         strcpy(timeout_msg, display_msg);

         if(decoder_was_playing)
            WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(BMP_PLAY), 0);

         playback_start = 0;
         msg_mode = MSG_SCROLL;
      }
      else
      {
         if (amp_playmode == AMP_PLAYLIST)
         {
            playback_start = 0;
            updated = 1;
            if (decoder_playing())
               StopWait();
         }
      }
      break;
   case BMP_FWD:
     if (decoder_playing() && !rewwing && !paused)
      {
        amp_msg(MSG_FWD, 0, 0);
        ffwding = !ffwding;
        if (ffwding)
         {
         WinSendMsg(WinWindowFromID(hwnd, BMP_FWD), WM_PRESS, 0, 0);
         vollow();
         seek_vol = TRUE;

         WinStopTimer(haba, hwndClient, TID_USERMAX - 1);
         WinStartTimer(haba, hwndClient, TID_USERMAX - 1, 100);
         }
        else
         {
         WinSendMsg(WinWindowFromID(hwnd, BMP_FWD), WM_DEPRESS, 0, 0);
         volnorm();
         seek_vol = FALSE;
         WinStopTimer(haba, hwndClient, TID_USERMAX - 1);
         WinStartTimer(haba, hwndClient, TID_USERMAX - 1, 100);
         }
        } else { ffwding = FALSE; WinSendMsg(WinWindowFromID(hwnd, BMP_FWD), WM_DEPRESS, 0, 0); }

     break;
   case BMP_REW:
     if (decoder_playing() && !ffwding && !paused)
      {
        amp_msg(MSG_REW, 0, 0);
        rewwing = !rewwing;
        if (rewwing)
         {
         WinSendMsg(WinWindowFromID(hwnd, BMP_REW), WM_PRESS, 0, 0);
         vollow();
         seek_vol = TRUE;

         WinStopTimer(haba, hwnd, TID_USERMAX - 1);
         WinStartTimer(haba, hwnd, TID_USERMAX - 1, 100);
         }
         else
         {
         WinSendMsg(WinWindowFromID(hwnd, BMP_REW), WM_DEPRESS, 0, 0);
         volnorm();
         seek_vol = FALSE;
         WinStopTimer(haba, hwnd, TID_USERMAX - 1);
         WinStartTimer(haba, hwnd, TID_USERMAX - 1, 100);
         }
        } else { rewwing = FALSE; WinSendMsg(WinWindowFromID(hwnd, BMP_REW), WM_DEPRESS, 0, 0); }
     break;
   default:
     break;
   }
     break;
   case WM_CREATE:
     hps = WinGetPS(hwnd);
     init_skins(cfg.defaultskin, hwnd, hps);
     skinned = 1;
     WinReleasePS(hps);

     amp_createmainwin(hwnd);
     main_menu = WinLoadMenu(HWND_OBJECT, 0, MAIN_MENU);
     amp_priochange(main_menu, cfg.priority);

     _beginthread(display_thread, NULL, 1024*1024, NULL);

     switch (cfg.font)
      {
       case 0: WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT1, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
             gui_font = 0;
             fontrise = 0;
             break;
       case 1: WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT2, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
             gui_font = 1;
             fontrise = 0;
             break;
       case 2: WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FONT3, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
             gui_font = 2;
             fontrise = 1;
             break;
       default: break;
      }

     if (cfg.priority == 0) WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRLOW, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
     if (cfg.priority == 1) WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_PRHIGH, TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));

     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_NORMAL, FALSE), MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_SMALL, FALSE),  MPFROM2SHORT(MIA_CHECKED, 0));
     WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_TINY, FALSE),   MPFROM2SHORT(MIA_CHECKED, 0));
     if (cfg.mode == 0) WinEnableMenuItem(main_menu, IDM_M_NORMAL, TRUE);
     if (cfg.mode == 1) WinEnableMenuItem(main_menu, IDM_M_SMALL, TRUE);
     if (cfg.mode == 2) WinEnableMenuItem(main_menu, IDM_M_TINY, TRUE);

     if (cfg.floatontop)
      WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FLOAT,  TRUE), MPFROM2SHORT(MIA_CHECKED, MIA_CHECKED));
     else
      WinSendMsg(main_menu, MM_SETITEMATTR, MPFROM2SHORT(IDM_M_FLOAT,  TRUE), MPFROM2SHORT(MIA_CHECKED, 0));

     WinSendMsg(hwnd, WM_UPDATE3, 0, 0);

     DosSetPriority(PRTYS_THREAD, PRTYC_TIMECRITICAL, 16, 0);

      if (cfg.floatontop) /* fl0atz */
       {
        WinStopTimer(haba, hwndClient, TID_USERMAX - 3);
      WinStartTimer(haba, hwndClient, TID_USERMAX - 3, 100);
       }

     if(cfg.rpt)
        WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_LOAD), 0);

     if(cfg.shf)
        WinSendMsg(hwndClient, WM_COMMAND, MPFROMSHORT(BMP_LIST), 0);

     break;
   case WM_ERASEBACKGROUND:
     return ((MRESULT) 0);
     break;
   case WM_REALIZEPALETTE:
//      WinInvalidateRect(hwndFrame, NULL, 1);
      plugin_broadcast(msg, mp1, mp2);
     break;
   case WM_PAINT:
     if (!focused) { WinFocusChange(HWND_DESKTOP, hwndClient, 0); focused = 1; }

     if (skinned)
      {
      reflow_and_resize();
      skinned = 0;
      /* Refresh palette */
        hpal = amp_dopalette(haba, hwndClient);
      }

     hps = amp_beginpaint(hwnd);
     foocol = (shadeB.bRed * 65536) + (shadeB.bGreen * 256) + shadeB.bBlue;
     mainBright = GpiQueryColorIndex(hps, 0, foocol);
     foocol = (shadeD.bRed * 65536) + (shadeD.bGreen * 256) + shadeD.bBlue;
     mainDark   = GpiQueryColorIndex(hps, 0, foocol);

     amp_drawbackground(hps, hwnd, mainFg);

     if (!WindowSmall)
      WindowHeight = 109;
     else if (!WindowTiny)
      WindowHeight = 69;
     else
      WindowHeight = 36;

     if (main_shade) amp_thick3d(hps, 0, 0, 299, WindowHeight, mainBright, mainDark);

     if (!WindowSmall)
      {
       playback_start = TimePlayed();
       if (playback_start > 0 && decoder_playing())
        {
         if (!seek_drag && !seeking) amp_drawtimer(hps, 204, 47, playback_start);
        }
       else
        {
         if (!seek_drag && !seeking) amp_drawtimer(hps, 204, 47, 0);
        }

       if (stat_mode == 0 && !WindowSmall)
        {
         if (decoder_playing())
            amp_drawtinytimer(hps, 115, 63, (current_length != 0 ? current_length - playback_start : 0));
         else
            amp_drawtinytimer(hps, 115, 63, current_length);
        }

       if (amp_playmode == AMP_PLAYLIST && !WindowSmall && stat_mode == 0) {
         if (repeat)
          amp_drawtinytimer(hps, 115, 47, 0);
         else
          amp_drawtinytimer(hps, 115, 47, playlist_length - total_played - playback_start);
      } else {
        if (!WindowSmall && stat_mode == 0) amp_drawtinytimer(hps, 115, 47, 0);
      }
      }

     /* Cool volume bar */
     if (!WindowSmall)
      {
      if (vol_shade) amp_thick3d(hps, 7, 36, 13, 50, mainDark, mainBright);

      /* Even cooler bitrate bitmap */
      amp_drawrate(hps, 174, 15 + 44 + 5, current_bitrate);
      amp_drawchannels(hps, 157, 15 + 44 + 5, current_channels);

      if (stat_mode == 0)
       {
         if (amp_playmode == AMP_NOFILE)
           amp_drawbmp(hps, bmp_pos[15].x, bmp_pos[15].y, BMP_NOTL);
         else
           amp_drawbmp(hps, bmp_pos[16].x, bmp_pos[16].y, BMP_TL);

         if (amp_playmode == AMP_PLAYLIST)
           amp_drawbmp(hps, bmp_pos[18].x, bmp_pos[18].y, BMP_PLIST);
          else
           amp_drawbmp(hps, bmp_pos[17].x, bmp_pos[17].y, BMP_NOPLIST);
       }
      }

     /* Error led */
     if (WindowSmall && !WindowTiny) {
      if (i_have_focus) amp_drawled(hps, 8, 44, TRUE); else amp_drawled(hps, 8, 44, FALSE);
     } else if (!WindowSmall) if (i_have_focus) amp_drawled(hps, 7, 90, TRUE); else amp_drawled(hps, 7, 90, FALSE);

     if (decoder_playing())
      {
      if (TotalTime() > 0)
        z = (((float)TimePlayed() / (float)TotalTime()) * slider_width);
       else
        z = 0;
      z += 1;
      if (!seek_drag && !seeking) amp_drawindicator(hps, (int)z);
      } else amp_drawindicator(hps, 0);

//    GpiSelectPalette(hps, NULLHANDLE);

     if (!WindowSmall)
      if (!hvol)
      {
        if (cfg.defaultvol > 0)
         z = (cfg.defaultvol / 100.0) * bmp_y(1630);
        else z =0;
       amp_volumebar(hwnd, hps, 9, 38, 15, (int)z);
      } else
       {
        if (cfg.defaultvol > 0)
         z = (cfg.defaultvol / 100.0) * bmp_x(1630);
        else z = 0;
        amp_volumebar(hwnd, hps, 9, 38, 15, (int)z);
       }

     amp_endpaint(hps);
     update_index = 1;
      WinSendMsg(hwnd, WM_UPDATE5, 0, 0);

      return 0;

    case WM_BUTTON1DBLCLK:
    case WM_BUTTON1CLICK:
     hps = WinGetPS(hwnd);

     WinQueryWindowPos(hwndFrame, &swp);
     WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
     ptlMouse.x -= swp.x;
     ptlMouse.y -= swp.y;

     if (ptlMouse.x > (bmp_pos[25].x - 1) && ptlMouse.x < (bmp_pos[25].x + bmp_x(1630) + 1) &&
        ptlMouse.y > (bmp_pos[25].y - 1) && ptlMouse.y < (bmp_pos[25].y + bmp_y(1630) + 1) && !WindowSmall)
       {
         if (!hvol)
         {
          volume = (ptlMouse.y - bmp_pos[25].y) + 1;
          volsave = volume;

          if (volume > bmp_y(1630)) volume = bmp_y(1630);
          z = (double)((100.0 / bmp_y(1630)) * (double)volume);
          volume = (int)z;

          if (volume > 100)
           volume = 100;
          if (volume < 0)
           volume = 0;
         }
         else
          {
           volume = (ptlMouse.x - bmp_pos[25].x) + 1; volsave = volume;

           if (volume > bmp_x(1630)) volume = bmp_x(1630);
           z = ((100.0 / bmp_x(1630)) * volume);
           volume = (int)z;

           if (volume > 100) volume = 100;
           if (volume < 0) volume = 0;
          }

         cfg.defaultvol = volume;

        if (!ffwding && !rewwing)
         volnorm();
        else
         vollow();

        amp_volumebar(hwnd, hps, 9, 38, 15, volsave);
      }
     else
      {
        if (!WindowSmall) { tmpx = bmp_pos[13].x; tmpy = bmp_pos[13].y; } else
                     { tmpx = bmp_pos[14].x; tmpy = bmp_pos[14].y; }

        if (ptlMouse.y > (tmpy - 1) && ptlMouse.y < (tmpy + char_height() + 1) && ptlMouse.x > (tmpx - 1)  && ptlMouse.x < (tmpx + (char_width() * maxmsglen) + 1) && amp_playmode != AMP_NOFILE && !WindowTiny)
        {
             WinSendMsg(hwnd, WM_UPDATE2, 0, 0);
             next_display_mode();
          update_now = 1;
          WinSendMsg(hwnd, WM_UPDATE5, 0, 0);
         }
      }

     WinReleasePS(hps);
     break;
   case WM_MOUSEMOVE:
     if (volume_drag)
      {
      hps = WinGetPS(hwnd);
      WinQueryWindowPos(hwndFrame, &swp);
      WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
      ptlMouse.x -= swp.x;
      ptlMouse.y -= swp.y;
      if (!hvol)
       {
        volume = (ptlMouse.y - bmp_pos[25].y) + 1; volsave = volume;

        if (volume > bmp_y(1630)) volume = bmp_y(1630);
        volume = (int)((100.0 / bmp_y(1630)) * volume);

        if (volume > 100)
         volume = 100;
        if (volume < 0)
         volume = 0;
       }
       else
        {
         volume = (ptlMouse.x - bmp_pos[25].x) + 1;
         volsave = volume;

         if (volume > bmp_x(1630)) volume = bmp_x(1630);
         volume = (int)((100.0 / bmp_x(1630)) * volume);

         if (volume > 100) volume = 100;
         if (volume <  0) volume = 0;
        }
      cfg.defaultvol = volume;
      if (!ffwding && !rewwing)
       volnorm();
        else
       vollow();

      amp_volumebar(hwnd, hps, 9, 38, 15, volsave);
      WinReleasePS(hps);
      }
      if (seek_drag)
      {
       hps = WinGetPS(hwnd);
       WinQueryWindowPos(hwndFrame, &swp);
       WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
       ptlMouse.x -= swp.x;
       ptlMouse.y -= swp.y;

       i = (ptlMouse.x - bmp_pos[24].x);
       if (i < 0) i = 0;
       if (i > slider_width) i = slider_width;
       amp_drawindicator(hps, i);

       z = (float)(((float)TotalTime() / slider_width) * (float)i);
       if (!WindowSmall) amp_drawtimer(hps, 204, 47, (int)z);

       WinReleasePS(hps);
      }
      lame = WinQuerySysPointer(HWND_DESKTOP, SPTR_ARROW, FALSE);
      WinSetPointer(HWND_DESKTOP, lame);
     break;
/* trackrect */
   case WM_BUTTON1MOTIONEND:
     hps = WinGetPS(hwnd);
     WinQueryWindowPos(hwndFrame, &swp);
     WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
     ptlMouse.x -= swp.x;
     ptlMouse.y -= swp.y;

     if (volume_drag)
      {
      if (!hvol)
       {
        volume = (ptlMouse.y - bmp_pos[25].y) + 1;
        volsave = volume;

        if (volume > bmp_y(1630)) volume = bmp_y(1630);
        volume = (int)((100.0 / bmp_y(1630)) * volume);

        if (volume > 100)
         volume = 100;
        if (volume < 0)
         volume = 0;
       } else
        {
         volume = (ptlMouse.x - bmp_pos[25].x) + 1; volsave = volume;

         if (volume > bmp_x(1630)) volume = bmp_x(1630);
         volume = (int)((100.0 / bmp_x(1630)) * volume);

         if (volume > 100) volume = 100;
         if (volume <  0) volume = 0;
        }

       cfg.defaultvol = volume;

       if (!ffwding && !rewwing)
        volnorm();
         else
        vollow();

       amp_volumebar(hwnd, hps, 9, 38, 15, volsave);
       volume_drag = FALSE;
      }
     if (seek_drag)
      {
       WinQueryWindowPos(hwndFrame, &swp);
       WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
       ptlMouse.x -= swp.x;
       ptlMouse.y -= swp.y;

       i = (ptlMouse.x - bmp_pos[24].x);
       if (i < 0) i = 0;
       if (i > slider_width) i = slider_width;
       amp_drawindicator(hps, i);

       z = (float)(((float)TotalTime() / slider_width) * (float)i);
       if (!WindowSmall) amp_drawtimer(hps, 204, 47, (int)z);

       i = (int)z;
       seeking = TRUE;
       amp_msg(MSG_JUMP, &i, 0);
       seek_drag = FALSE;
      }
     WinReleasePS(hps);
     break;
   case WM_BUTTON1MOTIONSTART:
     WinQueryWindowPos(hwndFrame, &swp);
     WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
     ptlMouse.x -= swp.x;
     ptlMouse.y -= swp.y;

      if (ptlMouse.x > (bmp_pos[25].x - 1) && ptlMouse.x < (bmp_pos[25].x + bmp_x(1630) + 1) && ptlMouse.y > (bmp_pos[25].y - 1) && ptlMouse.y < (bmp_pos[25].y + bmp_y(1630) + 1) && !WindowSmall)
      {
        volume_drag = TRUE;
      } else
      {
       if (ptlMouse.x > (bmp_pos[24].x - 1) && ptlMouse.x < (bmp_pos[24].x + slider_width + bmp_x(1610) + 1) && ptlMouse.y > (bmp_pos[24].y - 1) && ptlMouse.y < (bmp_pos[24].y + bmp_y(1610) + 1) && decoder_playing() && !ffwding && !rewwing)
        {
/*        rcl.xLeft   = bmp_pos[24].x - 1;
         rcl.xRight  = bmp_pos[24].x + slider_width + bmp_x(1610) + 1;
         rcl.yBottom = bmp_pos[24].y - 1;
         rcl.yTop    = bmp_pos[24].y + bmp_y(1610);
         hps = WinGetPS(hwnd);
         WinFillRect(hps, &rcl, CLR_GREEN);
         WinReleasePS(hps); */
         seek_drag = TRUE;
        }
      }
     break;
    case WM_BUTTON2MOTIONSTART:
     WinQueryWindowPos(hwndFrame, &swp);
     WinQueryPointerPos(HWND_DESKTOP, &ptlMouse);
     ptlMouse.x -= swp.x;
     ptlMouse.y -= swp.y;

     amp_movewindow(hwndFrame);
     WinQueryWindowPos(hwndFrame, &cfg.Main);
     for (i = 0; i < 32; i++)
      {
      if (plugins[i].type != PLUGIN_NULL)
       WinSetWindowPos(plugins[i].hwnd, HWND_TOP, plugins[i].x, plugins[i].y, plugins[i].cx, plugins[i].cy, SWP_ZORDER | SWP_ACTIVATE | SWP_MOVE | SWP_SIZE);
      }
     break;
   case WM_CHAR:
      if (SHORT1FROMMP(mp1) & KC_KEYUP || SHORT2FROMMP(mp2) == VK_F4) return ((MRESULT)0);

      if (!(SHORT1FROMMP(mp1) & KC_KEYUP))
      {
      if (!(SHORT1FROMMP(mp1) & KC_VIRTUALKEY) && (SHORT1FROMMP(mp1) & KC_SCANCODE) && !(SHORT1FROMMP(mp1) & KC_CHAR) && !(SHORT1FROMMP(mp1) & KC_ALT))
       {
        switch (SHORT2FROMMP(mp1) >> 8)
         {
         // 5 from the numpad
         case 76:
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(BMP_PAUSE, 0), 0);
           break;
         default:
           return WinDefWindowProc(hwnd, msg, mp1, mp2); break;
         }
        return (MRESULT)TRUE;
       }

      if ((SHORT1FROMMP(mp1) & KC_VIRTUALKEY) && !(SHORT1FROMMP(mp1) & KC_ALT))
       {
        switch (SHORT2FROMMP(mp2))
        {
        case VK_ESC:
         seek_drag = FALSE;
         break;
        case VK_DOWN:
         WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(BMP_NEXT, 0), 0);
         break;
        case VK_UP:
         WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(BMP_PREV, 0), 0);
         break;
        case VK_LEFT:
         WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(BMP_REW, 0), 0);
         break;
        case VK_RIGHT:
         WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(BMP_FWD, 0), 0);
         break;
        case VK_NEWLINE:
        case VK_ENTER:
         WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(BMP_PLAY, 0), 0);
         break;
        case VK_SPACE:
         hps = WinGetPS(hwnd);
         if (WindowSmall && !WindowTiny) {
           amp_drawled(hps, 8, 44, FALSE);
         } else if (!WindowSmall) amp_drawled(hps, 7, 90, FALSE);
         WinReleasePS(hps);
         WinQueryWindowPos(hwndFrame, &swp);
         WinQueryWindowPos(main_menu, &menuSwp);
         WinPopupMenu(hwnd, hwnd,
             main_menu,
             (swp.cx - menuSwp.cx) / 2,
             1,
             0,
             PU_HCONSTRAIN | PU_VCONSTRAIN |
             PU_MOUSEBUTTON1 | PU_MOUSEBUTTON2 |
             PU_KEYBOARD);
         break;
        default:
         return WinDefWindowProc(hwnd, msg, mp1, mp2);
         break;
        }
        return (MRESULT)TRUE;
       }

      if (SHORT1FROMMP(mp1) & KC_ALT)
        {
         switch ((char) toupper((char) SHORT1FROMMP(mp2)))
         {
         case '3':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_TAG, 0), 0);
           break;
         case '1':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_FONT1, 0), 0);
           break;
         case '2':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_FONT2, 0), 0);
           break;
         case 'O':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(BMP_PL, 0), 0);
           break;
         case 'L':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_LOAD, 0), 0);
           break;
         case 'U':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_URL, 0), 0);
           break;
         case 'S':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_SKIN, 0), 0);
           break;
         case 'P':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_CFG, 0), 0);
           break;
         case 'H':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_MINIMIZE, 0), 0);
           break;
         case 'T':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_TINY, 0), 0);
           break;
         case 'M':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_SMALL, 0), 0);
           break;
         case 'R':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_NORMAL, 0), 0);
           break;
         case 'A':
           WinPostMsg(hwnd, WM_COMMAND, MPFROM2SHORT(IDM_M_MANAGER, 0), 0);
           break;
         default:
           return WinDefWindowProc(hwnd, msg, mp1, mp2);
           break;
         }
        return (MRESULT)TRUE;
       }

      if (!(SHORT1FROMMP(mp1) & KC_KEYUP) && (SHORT1FROMMP(mp1) & KC_CHAR))
       {
       switch ((char) toupper((char) SHORT1FROMMP(mp2)))
        {
        case '+':
         cfg.defaultvol += 5;
         if (cfg.defaultvol > 100) cfg.defaultvol = 100;
         volume = cfg.defaultvol;
         hps = WinGetPS(hwnd);
         if (!WindowSmall)
         {
            if(hvol)
               amp_volumebar(hwnd, hps, 9, 38, 15, volume*bmp_x(1630)/100.0);
            else
               amp_volumebar(hwnd, hps, 9, 38, 15, volume*bmp_y(1630)/100.0);
         }
         WinReleasePS(hps);
         if (ffwding || rewwing)
           vollow();
         else
           volnorm();
         break;
        case '-':
         cfg.defaultvol -= 5;
         if (cfg.defaultvol < 0) cfg.defaultvol = 0;
         volume = cfg.defaultvol;
         hps = WinGetPS(hwnd);
         if (!WindowSmall)
         {
            if(hvol)
               amp_volumebar(hwnd, hps, 9, 38, 15, volume*bmp_x(1630)/100.0);
            else
               amp_volumebar(hwnd, hps, 9, 38, 15, volume*bmp_y(1630)/100.0);
         }
         WinReleasePS(hps);
         if (ffwding || rewwing)
           vollow();
         else
           volnorm();
         break;
        default:
         return WinDefWindowProc(hwnd, msg, mp1, mp2);
         break;
        }
       return (MRESULT)TRUE;
      }
     }
     return WinDefWindowProc(hwnd, msg, mp1, mp2);
     break;
   default:
     return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }
   return 0;
}

ULONG MyTermHandler(PEXCEPTIONREPORTRECORD       p1,
               PEXCEPTIONREGISTRATIONRECORD p2,
               PCONTEXTRECORD           p3,
               PVOID                 p4)
{
 switch (p1->ExceptionNum)
  {
   case XCPT_BREAKPOINT:
   return XCPT_CONTINUE_EXECUTION;
   break;
  }
 return XCPT_CONTINUE_SEARCH;
}

// create main pipe and playlist pipe with only one instance possible
// since these pipes are almost all the time free, it wouldn't make
// sense having multiple intances.
BOOL create_pipes(void)
{
   ULONG rc;
   int number = 2;
   char buffer[512];

   /* main pipe */
   while((rc = DosCreateNPipe(pipename, &piippu,
                  NP_ACCESS_DUPLEX,
                  NP_WAIT | NP_TYPE_BYTE | NP_READMODE_BYTE | 1,
                  512,
                  512,
                  500)) == ERROR_PIPE_BUSY)
   {
      sprintf(pipename,"\\PIPE\\PM123_%d",number);
      sprintf(plpipename,"\\PIPE\\PM123PL_%d",number);
      number++;
   }

   if(rc != 0)
   {
      sprintf(buffer,"Could not create pipe %s, rc = %d.", pipename, rc);
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buffer, "Fatal", 0, MB_ERROR | MB_OK);
      return FALSE;
   }

   /* Playlist pipe */
   rc = DosCreateNPipe(plpipename,
           &plpiippu,
           NP_ACCESS_DUPLEX,
           NP_WAIT | NP_TYPE_BYTE | NP_READMODE_BYTE | 1,
           32768,
           32768,
           500);

   if(rc != 0)
   {
      sprintf(buffer,"Could not create playlist pipe %s, rc = %d.", plpipename, rc);
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, buffer, "Fatal", 0, MB_ERROR | MB_OK);
      return FALSE;
   }

   return TRUE;
}

PFNWP OldpFrameWndProc;

MRESULT EXPENTRY FrameWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   switch(msg) {
      case WM_DOCKWINDOW:
         if(list_search(dock_list,mp1) == NULL)
            list_add(dock_list, mp1);
         break;

      case WM_UNDOCKWINDOW:
         list_remove(dock_list, mp1);
         break;

      case WM_WINDOWPOSCHANGED:
      {
         PSWP pswpnew = (PSWP) mp1;
         SWP swplist;

         // user does not want docking
         if(cfg.dock_windows == 0)
            break;

         // try to see if we should dock in the playlist window.
         // it seems bit 19 is set when the user is finished dragging around.
         if(LONGFROMMP(mp2) & 0x80000)
         {
            if(!WinQueryWindowPos(hwndPlaylist,&swplist))
            {
               //DosBeep(600,200);
               break;
            }

            if(dockWindow(pswpnew,&swplist,cfg.dock_margin))
               WinPostMsg(hwnd, WM_DOCKWINDOW, MPFROMHWND(hwndPlaylist), 0);
            else
               WinPostMsg(hwnd, WM_UNDOCKWINDOW, MPFROMHWND(hwndPlaylist), 0);
         }
      }

      case WM_ADJUSTWINDOWPOS:
      {
         PSWP pswpnext = (PSWP) mp1;
         SWP swpnow;

         // user does not want docking
         if(cfg.dock_windows == 0)
            break;

         // we only want to process the MOVE messages
         if(!(pswpnext->fl & SWP_MOVE))
            break;

         if(!WinQueryWindowPos(hwnd,&swpnow))
         {
            //DosBeep(600,200);
            break;
         }

         // try to see if we are approaching the playlist window
         // if it not already docked
         if(hwndPlaylist != NULLHANDLE && list_search(dock_list, (void *) hwndPlaylist) == NULL)
         {
            SWP swplist;

            if(!WinQueryWindowPos(hwndPlaylist,&swplist))
            {
               //DosBeep(600,200);
               break;
            }

            // "dock" with the playlist, but don't post WM_DOCKWINDOW
            // just yet.  do that only when the user has finished dragging
            // the window around, in WM_WINDOWPOSCHANGED
            dockWindow(pswpnext,&swplist,cfg.dock_margin);
         }

         // try to see if we have any docked windows we need to move with
         // the main frame window
         if(!list_isempty(dock_list))
         {
            SWP swpdock;
            LIST_NODE *docked_window = list_getnext(dock_list);

            while(docked_window != NULL)
            {
               if( (!WinQueryWindowPos((HWND)list_getdata(docked_window),&swpdock)) ||
                   (!WinSetWindowPos((HWND)list_getdata(docked_window),NULLHANDLE,
                                     swpdock.x+pswpnext->x-swpnow.x,
                                     swpdock.y+pswpnext->y-swpnow.y,0,0,SWP_MOVE | SWP_NOADJUST)))
               {
                  LIST_NODE *temp = list_getnext(docked_window);
                  list_remove(dock_list, list_getdata(docked_window));
                  docked_window = temp;

                  //DosBeep(600,200);
               }
               else
                  docked_window = list_getnext(docked_window);
            }
         }
         break;
      }
   }

   return OldpFrameWndProc(hwnd, msg, mp1, mp2);
}

int main(int argc, char *argv[])
{
  ULONG flCtlData = FCF_TASKLIST | FCF_NOBYTEALIGN | FCF_ACCELTABLE | FCF_ICON;
  char bjuf[1024];
  int i, files, o;
  static HACCEL haccel = 0;
  APIRET rc;
  char buf1[256], buf2[256];
  int input = 3;
  EXCEPTIONREGISTRATIONRECORD RegRec = { 0 };

  RegRec.ExceptionHandler = (ERR)MyTermHandler;
  DosSetExceptionHandler(&RegRec);

  // used for debug printf()s
  setvbuf(stdout,NULL,_IONBF, 0);

  stat_shade = 1; vol_shade = 1;

  haba = WinInitialize(0);
  hmq = WinCreateMsgQueue(haba, 0);

  DosCreateMutexSem(NULL, &mutexDir, 0, FALSE);

//  _wildcard(&argc, &argv);
  files = count_files(argc, argv);

  if (files == 1)
     argument = argv[argc - 1];

  no_file_loaded();
  if (files > 1)
  {
     tmplist = fopen("pm123tmp.lst", "w");
     for (i = 1; i < argc; i++)
     {
        if (argv[i][0] != '/' && argv[i][0] != '-')
           fprintf(tmplist, "%s\n", argv[i]);
     }
     fclose(tmplist);
     open_a_fucking_temp_list = 1;
  }

  strcpy(http_proxy, "");
  strcpy(http_auth, "");

  proxyurl = cfg.proxy;
  httpauth = cfg.auth;

  strcpy(pipename, "\\PIPE\\PM123");
  strcpy(plpipename, "\\PIPE\\PM123PL");

  for (o = 1; o < argc; o++)
  {
   strcpy(buf, argv[o]);

   if (stricmp(buf, "-shuffle") == 0 || stricmp(buf, "/shuffle") == 0)
     initial_shuffle = 1;
   else if (stricmp(buf, "-smooth") == 0 || stricmp(buf, "/smooth") == 0)
     smooth_scroller = 1;
   else if (stricmp(buf, "-cmd") == 0 || stricmp(buf, "/cmd") == 0)
   {
    o++;
    if(strncmp(argv[o], "\\\\", 2) == 0)
    {
       strcpy(pipename, argv[o]);  // machine name
       strcat(pipename, "\\PIPE\\PM123");
       o++;
    }
    strcpy(bjuf, "*");
    for (i = o; i < argc; i++)
    {
       strcat(bjuf, argv[i]);
       strcat(bjuf, " ");
    }

    rc = DosOpen(pipename,
              &piippu,
              &action,
              0,
              FILE_NORMAL,
              OPEN_ACTION_FAIL_IF_NEW | OPEN_ACTION_OPEN_IF_EXISTS,
              OPEN_SHARE_DENYREADWRITE | OPEN_ACCESS_READWRITE | OPEN_FLAGS_FAIL_ON_ERROR,
              NULL);

    if(rc == 0)
    {
       DosWrite((HFILE) piippu,
              bjuf,
              strlen(bjuf) + 1,
              &action);
       DosDisConnectNPipe(piippu);
       DosClose(piippu);
    }

    exit(0);
   }
  }


  /* If we have files in argument, try to open \\pipe\pm123 and write to it */
  if (files > 0 && DosOpen(pipename,
        &piippu,
        &action,
        0,
        FILE_NORMAL,
        OPEN_ACTION_FAIL_IF_NEW | OPEN_ACTION_OPEN_IF_EXISTS,
        OPEN_SHARE_DENYREADWRITE | OPEN_ACCESS_READWRITE | OPEN_FLAGS_FAIL_ON_ERROR,
        NULL) == 0)
  {
     // this only takes the last argument we hope is the filename
     // this should be changed
     DosWrite((HFILE) piippu,
                argv[argc - 1],
                strlen(argv[argc - 1]) + 1,
                &action);
     DosDisConnectNPipe(piippu);
     DosClose(piippu);
     exit(0);
  }
  else
  {
     if(!create_pipes())
        exit(1);

     _beginthread(pipe_thread, NULL, 1024*1024, NULL);
     _beginthread(playlist_thread, NULL, 1024*1024, NULL);
  }

  getExeName(startpath,sizeof(startpath));

  /* Randomize */
  srand((unsigned long) time(NULL));

  load_ini();

/* set default volume */
  i = cfg.defaultvol;
  if (i > 100) i = 100;
  volume = i;
  volnorm();

// priority1 = cfg.priority;

  /* Initialize Button'95 - oOoo */
  InitButton(haba);

  dock_list = list_create();

  WinRegisterClass(haba, "PM123", MyWinProc, CS_SIZEREDRAW, 0);

  hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
             &flCtlData, "PM123", VERSION,
             0, NULLHANDLE, 1/*0*/, &hwndClient);

  OldpFrameWndProc = WinSubclassWindow(hwndFrame, (PFNWP)FrameWndProc);

  mp3   = WinLoadPointer(HWND_DESKTOP, 0, 1700);
  /* Played MP3 */
  mp3play = WinLoadPointer(HWND_DESKTOP, 0, 1701);

  if (cfg.mode != 1 && cfg.mode != 2)
   {
     WindowSmall = WindowTiny = FALSE;
     WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, 300, 110,
           SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
   }
  else
   {
     if (cfg.mode == 1)
     {
      WindowSmall = TRUE;
      WindowTiny = FALSE;
      WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, 300, 70,
            SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
     }
    if (cfg.mode == 2)
     {
      WindowSmall = TRUE;
      WindowTiny = TRUE;
      WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, 300, 37,
            SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
     }
  }

  playlist_open = 3;
  amp_listwindow(hwndClient);

  if (cfg.mode != 1 && cfg.mode != 2)
   {
     WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, 300, 110,
           SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
   }
  else
   {
     if (cfg.mode == 1)
     {
      WindowSmall = TRUE;
      WindowTiny = FALSE;
      WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, 300, 70,
            SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
     }
    if (cfg.mode == 2)
     {
      WindowSmall = TRUE;
      WindowTiny = TRUE;
      WinSetWindowPos(hwndFrame, HWND_TOP, cfg.Main.x, cfg.Main.y, 300, 37,
            SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
     }
  }
  WinQueryWindowRect(hwndFrame, &wn);

  msg_mode = MSG_SCROLL;
  update_now = 1;

  while (WinGetMsg(haba, &qmsg, (HWND) 0, 0, 0))
   WinDispatchMsg(haba, &qmsg);

  DosCloseMutexSem(mutexDir);
  amp_quit(hwndClient, haba, hmq);

  list_destroy(dock_list);

  return 0;
}
